#!/usr/local/bin/perl
#***************************************************************************
#*          Copyright 2000 DBAmon Software, All Rights Reserved            *
#***************************************************************************
# --------------------------------------------------------------
# Changes:
#   bb 19Oct01 - Added arcDestFix to fix broken destinations.
#   bb 29Oct01 - Changed arcDestFix to sleep for 60 seconds (was 5)
#     before rechecking a fixed arcdest.
#   bb 05Nov01 - Added code to detect 64 bit 8.1.7.
#   bb 13Dec01 - Added inSync code.
#   bb 17May02 - Added code to InSyncPri to send a message as to
#     whether the DB is up on the primary. 
#   bb 03Jun02 - Added code to read backup age from a file (standby)
#   bb 04Sep02 - Added code to process multiple archivelog destinations
# 1.22 bb 19Dec02 - New code to not consider UNDO ts's for space checking. 
# 1.23 bb 17Jan03 - New aliasInfo sub.
# 1.24 bb 27Jan03 - New rmanHung sub.
# 1.25 bb 18Mar03 - Added code to query lib and dict get count.
# 1.26 bb 03Aug03 - Added code to diagnose tnsping problem.
# 1.27 bb 06Oct03 - Changed 'chop trailing period' logic for nslookup linux.
# 1.28 bb 06Oct03 - Changed bklvlts logic to account for OFFLINE backups. 
# 1.29 bb 29Apr04 - New code to not report TEMP Df's on standby DB's as orphan.
# 1.30 bb 18Jun04 - Set SHLIB_PATH if needed
# 1.31 bb 15Jul04 - New patches subroutine 
# 1.32 bb 27Aug04 - Fix to rmanHung - added ruser column
# 1.33 bb 16Nov04 - Change save_config DF list to query v$ views 
# 1.34 bb 18Nov04 - New logic to automatically alter users with bad dflt/temp TS
# 1.35 bb 27Nov04 - Added DBOpenheck logic - for standbys that drop open 
# 1.36 bb 23Dec04 - Changed perf to check for sg_size specified in "M"
# 1.37 bb 07Jan05 - Added security subroutine and first few checks 
# 1.38 bb 30Jan05 - Added checkRollstat for WWW invocation - Good db hang check 
# 1.39 bb 08Feb05 - Added undo and mts checks in perf
# 1.40 bb 07Mar05 - New logic to check for standby inhibit
# 1.41 bb 11Mar05 - Added code to count analyzed SYS objects (sys_analyzed) 
# 1.42 bb 06Apr05 - New oddJob1 logic 
# 1.43 bb 14Apr05 - New serverInfoHPUX module, new memory % used logic 
# 1.44 bb 21Apr05 - Added comm_method logic to make insync work on ssh servers 
# 1.45 bb 03May05 - New debug log in select from dual
# 1.46 bb 04May05 - Security fix - New logic in saving and reading files from /tmp 
# 1.47 bb 16May05 - Security fix - turned on listener_security
# 1.48 bb 20May05 - New REQUIRE file - this will simplify much 
# 1.49 bb 26May05 - New archlogByDest logic
# 1.50 bb 05Jun05 - New checkAutostart logic
# 1.51 bb 07Jun05 - New checkListenerLog logic
# 1.52 bb 06Sep05 - New buffer_cache_size 
# 1.53 bb 27Sep05 - New count of cron lines 
# 1.54 bb 12Oct05 - New Solaris serverinfo 
# 1.55 bb 17Oct05 - New DCF logic
# 1.56 bb 11Nov05 - New default temp/perm ts logic
# 1.57 bb 23Dec05 - Enhanced component incompatible check - now only 4 version levels 
# 1.58 bb 23Dec05 - Vastly improved TEMP tablespace usage checking
# 1.59 bb 06Jun06 - Improved logic for requiring dcf - zero bytes
# 1.60 bb 22Aug06 - New logic for insync - no NOLOG events for forced logging db's
# 1.61 bb 11Sep06 - Improved RMANHUNG logic 
# 1.62 bb 27Dec06 - New perfRedo subroutine 
# 1.63 bb 06Feb07 - Changed lockfile_time from 2 hours to 3 hours
# 1.64 bb 09Feb07 - New oddJob2 sub 
# 1.65 bb 25May07 - In userPassword, don't do the check depending of default profile 
# 1.66 bb 23Jun07 - New COMPLEXPW check 
# 1.67 bb 14Aug07 - New corruption check 
# 1.68 bb 01Oct07 - New EMCheck and ISQCheck
# 1.69 bb 22Oct07 - New checkDST 
# 1.70 bb 10Dec07 - New alert log local exclude file 
# 1.71 bb 11Dec07 - New DFCOUNT check in datafiles sub 
# 1.72 bb 21Dec07 - Fixed alert log EXCL logic to escape brackets
# 1.73 bb 14Feb08 - Added SNAPADM to the list of userids that are allowed to have DBA 
# --------------------------------------------------------------
$version = "1.73";
$| = 1;
#$# = 2;

use Time::Local;
use File::Basename;

##$listener_security = 0;
##$listener_security = 1 if $host eq "acomr20";
$listener_security = 1;

##$debug = 1;
$debug_up = 0;

$phonehome = "dbanull\@dba.it.agilent.com"; 

$P       = basename($0); 
$progdir = dirname($0);
##$tmpdir= "$progdir";      #---- Old setting 
$tmpdir  = "$progdir/tmp";  #---- FUTURE - after new dirs are implemented
system("mkdir  $tmpdir 2>&1") if ! -e $tmpdir;
chdir("$progdir") || print "chdir to $progdir failed\n";
chop($pwd = `pwd`);

$fs = "<font face='Trebuchet MS' size=2>"; 

#---- List of Oracle "system" userids
$system_userids = ""; 
$system_userids = "'SYS','SYSTEM','OUTLN','DBSNMP','RMAN','CSMIG'";

#---- START Temporary code to cleanup the old software/tmp files
#system("rm -f /tmp/dbamon_* 2>/dev/null");
#---- END   Temporary code to cleanup the old software/tmp files

$ENV{"PATH"} = "$ENV{'PATH'}:/usr/sbin:/usr/contrib/bin";

chop($thisos = `uname`);
if    ($thisos eq "HP-UX") { $bdfcmd = "bdf";    }
elsif ($thisos eq "SunOS") { $bdfcmd = "df -k"; }
elsif ($thisos eq "Linux") { $bdfcmd = "df -k"; }
else                       { $bdfcmd = "df -k";    }
##print "$P | Setting bdfcmd=$bdfcmd for OS=$thisos version=$version \n";

#---- Set config file path
$cfg = "$progdir/dbamon_ora.cfg";

chop($os_version = `uname -r`);

$verb = $ARGV[0];
$arg1 = $ARGV[1];
$arg2 = $ARGV[2];
$arg3 = $ARGV[3];
$arg4 = $ARGV[4];
$dashes = '-' x 80;

# Get hostname
chop($host = `hostname`);
if (index($host,'.') > -1)
{
  $host = (split(/\./,$host)) [0];
  &msg("This host had a fully qualified hostname - trimmed to first level (host=$host)");
}

if ($host eq "zfdprd01")
{
  system("sleep 120");
}

# Get userid
chop($userid = `whoami`);

# Save Company name
if ($thisos eq "Linux")
{
  chop($compwork = `host $host | awk '{ print \$1 }'`);
  chop $compwork if $compwork =~ /\.$/;  # remove trailing period
}
else
{
  chop($compwork = `nslookup $host | grep 'Name:' | awk '{ print \$2 }'`);
}
$fqhost = $compwork;

@words = split(/\./,$compwork);
$nexttolast = $#words - 1;
$company = $words[$nexttolast];

chop($date = `date`);
#chop($datefmt = `date +%Y%m%d`);

$os = $ENV{"ORACLE_SID"};
$oh = $ENV{"ORACLE_HOME"};

$tmp1 = "$tmpdir/dbamon_ora_${os}_tmp1_$$.txt";
$tmp2 = "$tmpdir/dbamon_ora_${os}_tmp2.txt";

#---- Require the common parameter file
$rq_backup_age = $rq_runmon = $rq_check_datafiles = $rq_arclog_by_dest = "";  #get rid of compile warnings
$reqfile = "$progdir/dbamon_common_req_$os.pl"; 
if (-e "$reqfile") 
{
  &msg("DEBUG - Requiring reqfile=$reqfile"); 
  #---- Only require the file if it passes a perl syntax check
  if (system("perl -wc $reqfile > $tmp2 2>&1") != 0)
  {
    &msg("Require file $reqfile Perl compile error - Not requiring"); 
    system("cat $tmp2"); 
    system("cat $tmp2 | mailx -s 'DBAmon | $host/$os $reqfile Compile Error' $phonehome") if $company eq "agilent";
  }
  else
  {
    require "$reqfile"; 
  }
  &msg("DEBUG - rq_listener_check=$rq_listener_check rq_runmon=$rq_runmon rq_backup_age=$rq_backup_age rq_check_datafiles$rq_check_datafiles"); 
}
else
{
  &msg("Require file $reqfile missing - REQFILEMISSING"); 
  system("echo ' ' | mailx -s 'DBAmon | $host/$os - $reqfile Missing' $phonehome") if $company eq "agilent";
}

#---- See if SHLIB_PATH is needed - set it if it is
if (`sqlplus -? 2>&1` =~ /dld.sl/) 
{
  &msg("SHLIB_PATH is needed - Setting - Ignore previous Coredump message");
  $ENV{'SHLIB_PATH'} = "$oh/lib";
  system("env | grep 'SHLIB'");
}

# This should only happen for the lightbulb
if ($oh eq "*" || $oh eq "")
{
  &msg("Resolving ORACLE_HOME of */blank");
  chop($ENV{"ORACLE_HOME"} = `grep '^$ENV{"ORACLE_SID"}:' /etc/oratab | awk -F: '{ print \$2 }'`);
  $oh = $ENV{"ORACLE_HOME"};
  &msg("Resolved to: $oh");
  $ENV{"PATH"} = "$oh/bin:$progdir:$ENV{'PATH'}";
}

# Set the temp tnsnames dir name
$tmp_tnsnames_dir = "dbamon_tnsnames_dir_$os";

#---- See if this is an SAP DB
if (system("grep 'SAP.WORLD' $oh/network/admin/listener.ora 2>&1") == 0)
{
  $sap_db = 1;
}
else
{
  $sap_db = 0;
}

#---- Try to determine the Oracle version that we are running

#---- Old way
#if (-f "$oh/install/unix.rgs")
#{
#  chop($oraver = `cat \$ORACLE_HOME/install/unix.rgs | grep 'rdbms' | head -1 |awk '{ print \$2 }'`);
#}
#else
#{
#  chop($oraver = `sqlplus -v | grep 'SQL' | awk '{ print \$3 }'`);
#}
#$oraver3 = substr($oraver,0,3);
#if    ($oraver3 eq "10.") { $sqlcmd = "sp"; } # sqlplus
#elsif ($oraver3 lt "9.0") { $sqlcmd = "sv"; } # svrmgrl
#else                      { $sqlcmd = "sp"; } # sqlplus

#---- New way
@temp_banner = `$oh/bin/sqlplus -?`;
foreach $line (@temp_banner)
{
  if ($line =~ /SQL/)
  {
    @words        = split(' ',$line);
    $oraver       = substr(${words[2]},0,5);
    $oraver_short = $words[2];
    #---- Chop the last 4 chars off (8.1.7.4.0 -> 8.1.7)
    $oraver_short =~ s/......$//g;
    $oraver_num   = $oraver_short + 0;
    last;
  }
}
if ($oraver_num >= 8.1) { $sqlcmd = "sp"; }
else                    { $sqlcmd = "sv"; }

##&msg("DEBUG - oraver=$oraver"); 

&oraSQL("exit");

$WWW = $ENV{"WWW"}; 

#---- Figure out comm_method
##system("env 2>&1");
if ($ENV{"SSH_CLIENT"} ne "")
{
  $comm_method = "ssh";
}
else
{
  $comm_method = "remsh";
}

&msg("Starting - version=$version host=$host verb=$verb arg1=$arg1 arg2=$arg2 arg3=$arg3 arg4=$arg4 date=$date userid=$userid");
&msg("  rq_dbamonmode=$rq_dbamonmode ORACLE_HOME=$oh ORACLE_SID=$os fqhost=$fqhost company=$company");
&msg("  thisos=$thisos os_version=$os_version tmp_tnsnames_dir=$tmp_tnsnames_dir oraver=$oraver sqlcmd=$sqlcmd WWW=$WWW sap_db=$sap_db");
&msg("  progdir=$progdir tmpdir=$tmpdir pwd=$pwd os_scmd=$os_scmd os_conn=$os_conn comm_method=$comm_method");

#if ($debug)
#{
#  print "$P | Env:\n";
#  system("env | sort");
#}

##print "dbamon_mssql TEST\n" if $host eq "bigdog" && $os eq "DBA";

$lockfile = "/tmp/DBAmon_Lock_$os.txt";
$lockfile_hours = 3;
&msg("Checking for Lockfile $lockfile"); 
system("ls -l $lockfile 2>&1");

# 30Jan02 - bb - New "Lockfile" - this allows an application to block monitoring
#  for the time during which file /tmp/DBAmon_Lock_<SID>.txt exists. If we find
#  the file we will sleep until it is gone.
#while(-e "$lockfile")
#{
#  &msg("Lockfile $lockfile exists - sleeping 60 before rechecking"); 
#  system("sleep 60");
#}

# 07Sep02 - bb - Lockfile will now act as a trigger to auto-inhibit. If
#  the lockfile is found, its create date will be examined. i will add
#  120 minutes to it and that will be the time during which auto-inhibit
#  is valid. I will pass the string AUTO-INHIBIT back to the caller.
if (-e "$lockfile")
{
  $lockfile_mtime = (stat "$lockfile") [9];
  $lockfile_age_min = int((time - $lockfile_mtime) / 60);
  &msg("Lockfile $lockfile does exist - it was created $lockfile_age_min minutes ago"); 
  $exp_mtime = $lockfile_mtime + ($lockfile_hours*60*60);  # Add $lockfile_hours hours
  if (time < $exp_mtime)
  {    
    &msg("Since it is < $lockfile_hours hours since Lockfile was created, sending AUTO-INHIBIT message back to caller - exiting"); 

    #&msg("test"); 
    #&securityChecks;

    exit;
  }
  else
  {    
    &msg("Since it is >= $lockfile_hours hours since Lockfile was created, it is not valid - rm'ing $lockfile"); 
    system("rm $lockfile");
    print "$P | diag. email\n";
    system("echo ' ' | mailx -s 'DBAmon | Lockfile $lockfile deleted - lockfile_hours=$lockfile_hours $phonehome") if $company eq "agilent";
  }
}

#------------------------------------------------------------------------------
#
# Subroutines
#
#------------------------------------------------------------------------------

#------------------------------------------------------------------------------
sub timeToNum 
#------------------------------------------------------------------------------
{
  $zz_text = $_[0];
  $zz_text =~ s/-/\//g;
  $zz_text =~ s/:/\//g;
  ##print "zz_text=$zz_text\n";
  @words = split(/\//,$zz_text);

  if ($#words != 5)
  {
    &error("Input Target_End_Time ($zz_text) should be in the format: YYYY/MM/DD-HH:MM:SS","DOC116");
  }

  $zz_yyyy = $words[0];
  $zz_mon  = $words[1];
  $zz_dd   = $words[2];
  $zz_hh   = $words[3];
  $zz_mm   = $words[4];
  $zz_ss   = $words[5];
  ##print "zz_yyyy=$zz_yyyy zz_mon=$zz_mon zz_dd=$zz_dd zz_hh=$zz_hh zz_mm=$zz_mm zz_ss=$zz_ss\n";

  &error("Input Target_End_Time - YYYY must be 2002-2099","DOC116") if ($zz_yyyy < 2002 || $zz_yyyy > 2099);
  &error("Input Target_End_Time - MON  must be 1-12     ","DOC116") if ($zz_mon  <    1 || $zz_mon  >   12);
  &error("Input Target_End_Time - DD   must be 1-31     ","DOC116") if ($zz_dd   <    1 || $zz_dd   >   31);
  &error("Input Target_End_Time - HH   must be 0-23     ","DOC116") if ($zz_hh   <    0 || $zz_hh   >   23);
  &error("Input Target_End_Time - MM   must be 0-59     ","DOC116") if ($zz_mm   <    0 || $zz_mm   >   59);
  &error("Input Target_End_Time - SS   must be 0-59     ","DOC116") if ($zz_ss   <    0 || $zz_ss   >   59);

  @zz_date=($zz_ss,$zz_mm,$zz_hh,$zz_dd,--$zz_mon,$zz_yyyy);
  $zz_result = &timelocal(@zz_date);

  return $zz_result;
}

#------------------------------------------------------------------------------
sub timeToText 
#------------------------------------------------------------------------------
{
  $zz_ts = $_[0];
  ($sec,$min,$hour,$mday,$mon,$year) = localtime($zz_ts);
  $year += 1900;
  $mon += 1;

  # Pad with 0's
  $yy = sprintf("%04d",$year);
  $mm = sprintf("%02d",$mon);
  $dd = sprintf("%02d",$mday);
  $hh = sprintf("%02d",$hour);
  $mi = sprintf("%02d",$min);
  $ss = sprintf("%02d",$sec);

  $date = "$yy/$mm/$dd-$hh:$mi:$ss";
  return $date;
}

#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  my $msgmsg = $_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  print "$date ${P} | $msgmsg\n";
}

#------------------------------------------------------------------------------
sub oraSQL
#------------------------------------------------------------------------------
{
  my $sql = $_[0];

  if ($sqlcmd eq "sp")
  {
    $os_scmd = "sqlplus /NOLOG";
    $os_conn = "connect / as sysdba ";
    $os_set  = "set linesize 9999;";
    $os_end  = "/";
  }
  else
  {
    $os_scmd = "svrmgrl";
    $os_conn = "connect internal ";
    $os_set  = "";
    $os_end  = "";
  }

  ##&msg("os_scmd=$os_scmd os_conn=$os_conn");

  @oraSQLout = `$os_scmd <<! | tee -a $tmp2
    $os_conn;
    $os_set
    $sql
    ;
  !`;
}

# ----------------------------------------------------------------------
sub error
# ----------------------------------------------------------------------
{
  my $emsg = $_[0];

  if ($ENV{'WWW'})
  {
    print "\n<table bgcolor=red><tr><td><font size=2>$P | Fatal Error: <b>$emsg</b></table>\n\n";
  }
  else
  {
    &msg("================================================================");
    &msg("Fatal Error: $emsg");
    &msg("================================================================");
  }

  &msg("Exiting");
  &msg("END_OF_PROBE");
  exit 1;
}

# ----------------------------------------------------------------------
sub lan
# ----------------------------------------------------------------------
{
  if ($thisos eq "HP-UX" && $os_version lt "B.11.00")
  {
    &msg("LAN Half-Duplex checking only works on HP-UX >= 11.00");
    return;
  }

  &msg("Checking lan cards for half-duplex");

  @lans = `netstat -i | grep -v 'none' | grep '^lan' | grep -v ':' | sort | awk '{ print \$1 }'`;
  foreach $lancard (@lans)
  {
    chop $lancard;
    &msg("Checking lan interface: $lancard");
    chop($crd = `lanscan | grep '$lancard ' | awk '{ print \$3 }'`);
    chop($sta = `lanadmin -x $crd 2>&1`);
 
    $sta =~ s/  //g;

    &msg("  crd=$crd sta=$sta");
    if (
        $sta =~ /Half-Duplex/ &&
        $sta !~ /10 Half-Duplex/ 
       )
    {
      print "$P HALF_DUPLEX_LAN: $lancard $sta\n";
    }
    else
    {
      print "$P FULL_DUPLEX_LAN: $lancard $sta\n";
    }
  } 
 
}

# ----------------------------------------------------------------------
sub ts_full
# ----------------------------------------------------------------------
{
  $tmplog = "$tmpdir/dbamon_ora_ts_full_${$}.log";
  $t_warn = $arg1;
  $t_crit = $arg2;
  $t_free = $arg3;
  $t_cmd  = $arg4;

  print "\n$P | ts_full() - t_warn=$t_warn t_crit=$t_crit t_free=$t_free t_cmd=$t_cmd \n";

  $sqlstmt = "
    select \'BLOCK_SIZE\', value from v\\\$parameter where name = \'db_block_size\';
    select \'TEMP_USED_SPACE\',
      tablespace_name,
      sum(used_blocks) 
    from
      v\\\$sort_segment
    group by
      tablespace_name ;
    select \'DBAMON_TS_SIZE\',
          a.tablespace_name as tablespace_name,
          a.sum_bytes as bytes_avail,
          a.sum_bytes - nvl(c.sum_bytes,0) as bytes_used,
          nvl(c.sum_bytes,0) as bytes_free,
          round((a.sum_bytes-nvl(c.sum_bytes,0.00)) / a.sum_bytes * 100.0, 2) as pct_used,
          b.contents
     from 
          ( select 
              tablespace_name,
              sum(bytes) sum_bytes,
              count(1) max_id
            from 
              dba_data_files
            group by 
              tablespace_name
          ) a,
          ( select 
              tablespace_name,
              contents
            from 
              dba_tablespaces
          ) b,
          ( select 
              tablespace_name,
	      sum(bytes) sum_bytes
	    from 
              dba_free_space
	    group by 
              tablespace_name
          ) c
     where 
         a.tablespace_name = c.tablespace_name (+) and
         a.tablespace_name = b.tablespace_name 
       $ts_where ;
    select
      \'T\',
      tablespace_name,
      sum(bytes)
    from
      dba_temp_files
    group by
      tablespace_name ;
     ";

  $sqlgood = 0;

  &oraSQL($sqlstmt);
  foreach (@oraSQLout)
  {
    ##print;
    $diagout .= $_;
    @words = split;
    $verb    = $words[0];
    if ($verb =~ /ORA-/) 
    { 
      print "$P | ERROR: ORA- Oracle error message encountered while checking tablespaces \n";
    }

    if ($verb eq "BLOCK_SIZE") 
    { 
      $blocksize = $words[1];
    }

    if ($verb eq "TEMP_USED_SPACE" && $blocksize > 0) 
    { 
      $tempts   = $words[1];
      $tempused = int(($words[2] * $blocksize) / 1000000);
      &msg("DEBUG tempused=$tempused"); 
      $tempspaceused{$tempts} = $tempused;
      &msg("DEBUG tempspaceused{$tempts}=$tempspaceused{$tempts}"); 
    }

    if ($verb eq "T") 
    { 
      $ts   = $words[1];
      $size = $words[2]/1000000;
      $used = 0; 
      $free = $size;
      $pct  = 0;
      $type = "TEMPFILE";

      #---- For TEMPORARY tablespaces, the used space calc is different.
      #----   It is based on sort segment usage.
      if ($tempspaceused{$ts} ne "" && $size > 0)
      {
        &msg("DEBUG - overriding ts=$ts used space - from $used to $tempspaceused{$ts}"); 
        $used = $tempspaceused{$ts};
        $free = $size - $used;
        $pct  = sprintf("%.2f", ($used / $size) * 100);
      }

      $flag = "OK";  
      if ($pct  >= $t_warn && $pct < $t_crit) { $flag = "W"; }
      if ($pct  >= $t_crit )                  { $flag = "C"; }
      if ($free >= $t_free)                   { $flag = "OK";  }

      printf("DBAMON_TS_SIZE %-16s %8d %8d %8d %7.1f %s %s\n",$ts,$size,$used,$free,$pct,$flag,$type);
    }

    if ($verb eq "DBAMON_TS_SIZE") 
    { 
      $ts   = $words[1];
      $size = $words[2]/1000000;
      $used = $words[3]/1000000;
      $free = $words[4]/1000000;
      $pct  = $words[5];
      $type = $words[6];

      #---- For TEMPORARY tablespaces, the used space calc is different.
      #----   It is based on sort segment usage.
      if ($type eq "TEMPORARY" && $tempspaceused{$ts} ne "")
      {
        &msg("DEBUG - overriding ts=$ts used space - from $used to $tempspaceused{$ts}"); 
        $used = $tempspaceused{$ts};
        $free = $size - $used;
        $pct  = sprintf("%.2f", ($used / $size) * 100);
      }
 
      $flag = "OK";  # Default 1.22

      # MB Needed to get to 5% below warning threshold

      $t_warn = 6 if $t_warn <= 5;
      $needed = int($used / (($t_warn-5)/100) - $size);
      if ($needed < 100)
      {
        $needed = 50;
      }
      if ($needed > 2000)
      {
        $needed = 2000;
      }

      if ($pct  >= $t_warn && $pct < $t_crit) { $flag = "W" . " " . $needed; }
      if ($pct  >= $t_crit )                  { $flag = "C" . " " . $needed; }
      if ($free >= $t_free)                   { $flag = "OK";  }

      if ($type eq "UNDO")
      {
        $flag = "OK";
        ##print "undo ts\n";
      }

      if ($flag ne "OK" && $ts =~ /RBS/ && $already_rbs != 1 && $t_crit != 999)
      {
        printf("%s %-16s %8d %8d %8d %7.1f %s\n",$verb,$ts,$size,$used,$free,$pct);
        print "\n--------------------------------------------------------------------\n";
        print "RBSSHRINKING: $ts \n";
        push(@recheck_list,$ts);

        &rbs_shrink();

	print "$P | ts_full() will be re-invoked to recheck ts=$ts\n";
        $already_rbs = 1;
        $ts_recheck = 1;
        print "--------------------------------------------------------------------\n\n";
        next;
      }

      if ($flag ne "OK" && $ts =~ /TEMP/ && $already_temp != 1 && $t_crit != 999)
      {
        printf("%s %-16s %8d %8d %8d %7.1f %s\n",$verb,$ts,$size,$used,$free,$pct);
        print "\n--------------------------------------------------------------------\n";
        print "COALESCING: $ts \n";
        push(@recheck_list,$ts);

        &ts_coalesce("$ts");

	print "$P | ts_full() will be re-invoked to recheck ts=$ts\n";
        $already_temp = 1;
        $ts_recheck = 1;
        print "--------------------------------------------------------------------\n\n";
        next;
      }

      if ($ts =~ /TEMP/ && $flag ne "OK")
      {
	print "  (Since the following tablespace is a TEMP tablespace, it\n";
	print "   will not be eligible for automatic datafile addition)\n";
      }
      elsif ($flag ne "OK" && $t_cmd ne "" && $t_crit != 999)
      {
        # Try to add space
        $cmd = $t_cmd;
	print "$P ======================================================\n";
	print "$P Command before {TS} $ts {SIZE} $needed substitution: $cmd\n";
	$cmd =~ s/\{TS\}/${ts}/g;
	$cmd =~ s/\{SIZE\}/${needed}/g;
	print "$P About to issue: $cmd\n";
        $rc = system("$cmd 2>&1 > $tmplog");
        $rc = $rc / 256;
        print "DBAMON_TS_ADD $rc $ts $pct $needed\n"; 
        system("cat $tmplog >> $tmpdir/DBAmon_TS_Add.log");
        system("cat $tmplog");
        system("rm $tmplog");
	print "$P ======================================================\n";
        if ($rc == 0)
        {
          $flag = "OK";
        }
      }
      printf("%s %-16s %8d %8d %8d %7.1f %s %s\n",$verb,$ts,$size,$used,$free,$pct,$flag,$type);
    }
  }
  close(INDB);

  if ($ts eq "")
  {
    print "$P | ERROR: No tablespaces found (something is wrong) - Diagnostic output:\n";
    print $diagout;
  }
  print "$P | Done \n\n";
}

# ----------------------------------------------------------------------
sub ts_coalesce
# ----------------------------------------------------------------------
{
  my $ts = $_[0];
  $sqlstmt = 'select \'X\', pct_increase from dba_tablespaces;';
  &oraSQL($sqlstmt);
  foreach (@oraSQLout)
  {
    ##print;
    @words       = split();
    $verb        = $words[0];
    if ($verb eq "X")
    {
      $pctincrease  = $words[1];
      print "$P | PCTINCREASE For ts=$ts is $pctincrease\n";
      last;
    }
  }
  close(RO);

  if ($pctincrease == 0) 
  {
    print "$P | Since PCTINCREASE is 0, we will temporarily alter it to 1 for the coalesce \n";
    $stmt1 = "alter tablespace $ts default storage ( pctincrease 1 );"; 
    $stmt2 = "alter tablespace $ts default storage ( pctincrease 0 );"; 
  }
  print "$P | Running alter table space coalesce 3 times for ts=$ts \n";
  system("$os_scmd <<! 
    $os_conn
    $stmt1
    alter tablespace $ts coalesce;
    alter tablespace $ts coalesce;
    alter tablespace $ts coalesce;
    $stmt2
  !");
  print "$P | Done \n";
}

# ----------------------------------------------------------------------
sub rbs_shrink
# ----------------------------------------------------------------------
{
  $sqlstmt = 'select \'X\', 
      SEGMENT_NAME,
      OWNER,
      TABLESPACE_NAME,
      SEGMENT_ID,
      INITIAL_EXTENT,
      NEXT_EXTENT,
      MIN_EXTENTS,
      MAX_EXTENTS,
      PCT_INCREASE,
      STATUS
    from dba_rollback_segs;';

  &oraSQL($sqlstmt);
  foreach (@oraSQLout)
  {
    ##print;
    @words   = split();
    $verb    = $words[0];
    $name    = $words[1];
    $owner   = $words[2];
    $tsrbs   = $words[3];
    #$id      = $words[4];
    #$xinit   = $words[5];
    #$xnext   = $words[6];
    #$xmin    = $words[7];
    #$xmax    = $words[8];
    #$xpct    = $words[9];
    $status  = $words[10];
    if ($verb eq "X" && $tsrbs eq $ts)
    {
      print "$P | Found rollback segment: $name in ts: $tsrbs - shrinking\n";
      system("$os_scmd <<! 
	$os_conn
	alter rollback segment $name shrink;
      !");
    }
  }
}

# ----------------------------------------------------------------------
sub lsnrSecurity
# ----------------------------------------------------------------------
{
  &msg("lsnrSecurity Starting ===========================");

  if ($thisos eq "Linux")
  {
    &msg("This routing DOES NOT WORK on Linux");
    return;
  }

  if (`lsnrctl status 2>&1` =~ /dld.sl/) 
  {
    &msg("SHLIB_PATH is needed - Setting");
    $ENV{'SHLIB_PATH'} = "$oh/lib";
    system("env | grep 'SHLIB'");
  }

  if (! -r "$lsnr_file")
  {
    &msg("THIS WILL NOT WORK - I do not have READ access to listener.ora file $lsnr_file");
    return;
  }

  &msg("Looking for password in $lsnr_file");
  chop($pwlines = `grep -v '^#' $lsnr_file | grep -i 'passwords_listener' | wc -l`); 
  &msg("pwlines=$pwlines");
  if ($pwlines < 1)
  {
    &msg("Listener password is not set - Setting");

    # Isolate new pw 
    chop($newlispw = `cat $progdir/dbamon_ora.key2 | crypt dbamon`);
    if ($newlispw eq "")
    {
      system("echo ' ' | mailx -s 'DBAmon | $host/$os - key2 pw is NULL thisos=$thisos' $phonehome") if $company eq "agilent";
      return;
    }

    $! = ""; 

    open(LSNR, ">>$lsnr_file");  
    if ($! ne "")
    {
      &msg("Cannot open append $lsnr_file - $!");
      system("ll $lsnr_file | mailx -s 'DBAmon | $host/$os/$userid - Cannot open output $lsnr_file - $!' $phonehome") if $company eq "agilent";
      return;
    }

    print LSNR "
# listener_password Added by DBAmon $date - Start
PASSWORDS_LISTENER = $newlispw
ADMIN_RESTRICTIONS_LISTENER = ON
# listener_password Added by DBAmon $date - End
";
    close(LSNR);
    &msg("Listener password added to $lsnr_file ");
    &msg("Issuing: lsrnctl reload");
    system("lsnrctl reload 2>&1");
    &msg("Issuing: lsrnctl status");
    system("lsnrctl status 2>&1");
    if (system("grep -i 'passwords_listener' $lsnr_file") != 0)
    {
      system("echo ' ' | mailx -s 'DBAmon | $host/$os/$userid - listener password add did NOT work' $phonehome") if $company eq "agilent";
    }
    else
    {
      system("cat $lsnr_file | mailx -s 'DBAmon | $host/$os/$userid - listener password add DID work' dbaadmin\@dba.it.agilent.com") if $company eq "agilent";
      print "$S$P LSNRPWSET: Set password\n"; 
    }
  }
  else
  {
    &msg("The Listener password is already enabled");
  }

  &msg("lsnrSecurity Done ===========================");
}

# ----------------------------------------------------------------------
sub lsnr
# ----------------------------------------------------------------------
{
  if    (-e "/etc/listener.ora")                { $lsnr_file = "/etc/listener.ora"; }
  elsif (-e "${oh}/network/admin/listener.ora") { $lsnr_file = "${oh}/network/admin/listener.ora"; }
  else
  {
    &msg("Cannot find listener.ora file in the usual locations");
  }

  $S = "Stack: oraLsnrStack ";

  if ($listener_security == 1 && $runmon ne "B")
  {
    &lsnrSecurity; 
  }

  if (`lsnrctl status 2>&1` =~ /dld.sl/)
  {
    &msg("SHLIB_PATH is needed - Setting");
    $ENV{'SHLIB_PATH'} = "$oh/lib";
    system("env | grep 'SHLIB'");
  }

  # Check for lsnr process
  if (&lsnr_check() == 0)
  {
    print "$S$P LSNROK: Listener is active and pingable\n"; 
    return 0;
  }

  # Restart it
  if (&lsnr_start() != 0)
  {
    print "$S$P lsnr: Error trying to restart listener:\n"; 
    return 0;
  }

  # Check it again
  if (&lsnr_check() == 0)
  {
    print "$S$P LSNRRESTARTED: Restarted listener:\n"; 
  }
  else
  {
    print "$S$P LSNRNORESTART: Error trying to restart listener:\n"; 
  }
}

# ----------------------------------------------------------------------
sub datafiles
# ----------------------------------------------------------------------
{
  &msg("Checking datafiles (Status) - rq_check_datafiles=$rq_check_datafiles");

  if ($rq_check_datafiles eq "N")
  {
    &msg("Skipping check since rq_check_datafiles=N"); 
    return;
  }

  $S = "Stack: oraDatafilesStack ";

  $sqlstmt = 'select
      \'Y\', controlfile_type from v\$database;
    select
      \'Z\',
      d.file#,
      d.status,
      to_char(d.last_time,\'YYYY/MM/DD-HH24:MM:SS\') as timestamp,
      t.name,
      d.name
    from
      v\$datafile   d,
      v\$tablespace t
    where
      d.ts# = t.ts#
      and d.status != \'ONLINE\'
      and d.status != \'SYSTEM\';';
  &oraSQL($sqlstmt);
  foreach (@oraSQLout)
  {
    ##print;
    @words = split;
    $verb    = $words[0];
    if ($verb eq "Y" && $words[1] eq "STANDBY") 
    { 
      $standby = 1;
    }
    if ($verb eq "Z") 
    { 
      #if (!$flag)
      #{
      #  print "$S\n";
      #  print "$S                            DFNum  Status      LastUpdated          TSName            DFName\n";
      #  print "$S                            =====  ==========  ===================  ================  =======================\n";
      #  $flag = 1;
      #}

      $dfnum     = $words[1];
      $status    = $words[2];
      $timestamp = $words[3];
      $tsname    = $words[4];
      $dfname    = $words[5];

      # There is an oracle bug where it is normal for ts's to be
      # in recover mode on standby db's - 8.1.6
      if ($standby == 1 && $status eq "RECOVER")
      {
        printf "$S$P Standby Datafile in RECOVER: %5d  %-10s  %-19s  %-16s  %-50s\n",$dfnum,$status,$timestamp,$tsname,$dfname; 
      }
      else
      {
	printf "$S$P DatafileDown: %5d  %-10s  %-19s  %-16s  %-50s\n",$dfnum,$status,$timestamp,$tsname,$dfname; 
        $dfdownnum++;
      }
    }
  }

  if ($flag)
  {
    print "$S$P | $dfdownnum Offline Datafile(s)\n"; 
  }
  else
  {
    print "$S$P | datafiles - OK - No Offline Datafile(s)\n";
  }

  #---- See if there are any tablespaces with NO datafiles
  &msg("Checking for empty tablespaces (no datafiles)");
  $sql = '
    select
      \'X\',
      tablespace_name
    from
      dba_tablespaces
    where
      tablespace_name not in
	(
	 select distinct tablespace_name from dba_data_files
	   union
	 select distinct tablespace_name from dba_temp_files
	)
    order by
      2;
  ';
  &oraSQL($sql);
  $tslist = ""; 
  foreach (@oraSQLout)
  {
    ##print;
    @words       = split();
    $verb        = $words[0];
    if ($verb eq "X")
    {
      $tslist .= $words[1] . ","; 
    }
  }
  if ($tslist)
  {
    chop($tslist);  #remove trailing comma
    print "$P TS_NO_DF: $tslist\n";
  }

  #---- See if there are any tablespaces with datafile count approaching limit (1022) 
  if (! $standby_flag)
  {
    &msg("Checking tablespace datafile count (vs. Max 1022 DFs per Tablespace)");
    $sql = '
      select
	\'X\',
	tablespace_name,
	count(*)
      from
	dba_data_files
      group by
	\'X\',
	tablespace_name
      order by
	2;
    ';
    &oraSQL($sql);
    $tslist = ""; 
    foreach (@oraSQLout)
    {
      ##print;
      @words       = split();
      $verb        = $words[0];
      if ($verb eq "X")
      {
	$tsname  = $words[1];
	$dfcount = $words[2];
	if (($dfcount / 1022) >= 0.5)
	{
	  $zpct  = sprintf("%.2f", ($dfcount / 1022) * 100); 
	  print "$P TSDFCOUNT: $tsname $dfcount $zpct\n"; 
	}
      }
    }
  }

}

# ----------------------------------------------------------------------
sub extents
# ----------------------------------------------------------------------
{
  #
  # Look for tables that are almost out of extents
  #
  &msg("Looking for tables at or near max_extents");
  $sqlstmt = "select 
    \'X\', 
    owner, 
    segment_name, 
    segment_type, 
    extents, 
    max_extents,
    round(nvl(extents,0.00) / max_extents * 100.0, 2) as x_pct
  from
    dba_segments 
  where
    segment_type in (\'TABLE\',\'INDEX\')
    and owner not in (\'SYS'\,\'SYSTEM\')
    --and (round(nvl(extents,0.00) / max_extents * 100.0, 2)) > $arg1 
  ;";

  ##print "sqlstmt=$sqlstmt\n";

  &oraSQL($sqlstmt);
  foreach (@oraSQLout)
  {
    ##print;
    @words = split;
    $verb    = $words[0];
    if ($verb eq "X") 
    { 
      $owner = $words[1];
      $sname = $words[2];
      $stype = $words[3];
      if ($words[4] =~ /PARTITION/) { shift @words; }
      $exts  = $words[4];
      $max   = $words[5];
      $pct   = $words[6] * 1;
      $rawcount++;

      if ($stype ne "TABLE" && $stype ne "INDEX")
      {
        print;
        &msg("Invalid stype=$stype - $owner=$owner sname=$sname");
        next;
      }
 
      $ext_hwm = $pct if $pct > $ext_hwm;

      if ($pct > $arg1)
      {
        $foundtbls++;
        $tbl = $owner . "." . $sname;
        if (!$titleflag)
        {
          print "\n"; 
          print "        Object(s) With Number of Extents >= Threshold\n"; 
          print "               Of $arg1% Of Max_Extents\n\n"; 
          print "Segment                                  Segment Extent    Max  Pct Of\n"; 
          print "Name                                     Type     Count Extent     Max\n"; 
          print "======================================== ======= ====== ====== =======\n"; 
          $titleflag = 1;
        }
        printf "%-40s %-7s %6i %6i %7.2f\n",$tbl,$stype,$exts,$max,$pct; 
        if (uc $arg2 eq "FIX")
        {
          #if the tbl name  contains a $, we have to fix that
          $tbl =~ s/\$/\\\$/g;

          print "$P | extents() - Attempting to ALTER this object to set MAXEXTENTS to UNLIMITED\n";
          print "$P | extents() - Issuing:  alter $stype $tbl storage ( maxextents unlimited );\n";
	  system("$os_scmd <<! 
          $os_conn
	  alter $stype $tbl storage ( maxextents unlimited );
!");
          $fixedtbls = " FIXED";
        }
      }
    }
  }
  print "\n";
  if ($foundtbls > 0)
  {
    print "$P FOUND $foundtbls $fixedtbls\n";
    &msg("Extents/Max - FOUND $fixedtbls - Found $foundtbls table(s) with > $arg1 percent of extents used - rawcount=$rawcount ext_hwm=$ext_hwm");
  }
  else
  {
    &msg("Extents/Max - OK - No tables with > $arg1 percent of extents used - rawcount=$rawcount ext_hwm=$ext_hwm");
  }

  #
  # Look for tables where the next extent will not fit in the largest
  #   freespace hole for their tablespace
  #
  &msg("Looking for tables whose next extent will not fit");
  $sqlstmt = '
    select
      \'X\',
      segment_owner,
      segment_name,
      segment_type,
      ts1,
      max_chunk,
      chunk_needed
    from
      (select
	 tablespace_name ts1,
	 max(bytes) as max_chunk
       from dba_free_space
       group by tablespace_name),
      (select
	 owner segment_owner,
	 segment_name,
	 segment_type,
	 tablespace_name ts2,
	 next_extent chunk_needed
	 from dba_segments)
    where
      ts1=ts2
      and chunk_needed> max_chunk
  ';
  &oraSQL($sqlstmt);

  $foundtbls = 0;
  $titleflag = 0;

  foreach (@oraSQLout)
  {
    ##print;
    @words = split;
    $verb    = $words[0];
    if ($verb eq "X") 
    { 
      $owner           = $words[1];
      $sname           = $words[2];
      $stype           = $words[3];
      $ts              = $words[4];
      $ts_max_free     = $words[5];
      $s_next_size     = $words[6];

      $foundtbls++;
      $tbl = $owner . "." . $sname;

      if (!$titleflag)
      {
	print "\n"; 
	print "                          Object(s) Whose Next_Extent Will Not Fit\n"; 
	print "\n"; 
	print "Segment                                  Segment Tablespace               Object Next  TS Max Contig.\n"; 
	print "Name                                     Type    Name                     Extent Size      Free Space\n"; 
	print "---------------------------------------- ------- -------------------- --------------- ---------------\n"; 
	$titleflag = 1;
      }
      printf "%-40s %-7s %-20s %15i %15i\n",$tbl,$stype,$ts,$s_next_size,$ts_max_free; 
    }
  }
  print "\n";
  if ($foundtbls > 0)
  {
    print "$P NEXTNOFIT $foundtbls\n";
    &msg("Extents/Nextfit - Found $foundtbls whose next extent will not fit");
  }
  else
  {
    &msg("Extents/NextFit OK - No tables whose next extent will not fit");
  }
}

# ----------------------------------------------------------------------
sub arclogsByDest
# ----------------------------------------------------------------------
{
  $t_warn = $rq_arc_dest{$thisdest}{threshold_w};
  $t_crit = $rq_arc_dest{$thisdest}{threshold_c};
  $t_cmd  = $rq_arc_dest{$thisdest}{cmd};

  my $found_dest = "";

  &msg("arclogsByDest() - Processing thisdest=$thisdest t_warn=$t_warn t_crit=$t_crit t_cmd=$t_cmd");

  $sql = "
    archive log list;
    select 
      \'Y\', 
      destination 
    from 
      v\\\$archive_dest 
    where 
      binding = \'MANDATORY\' and 
      dest_id = $thisdest and
      destination like \'/%\';
  ";
  
  @oraSQLout = `$os_scmd <<!
    $os_conn;
    $os_set
    $sql
    exit
  !`;

  foreach (@oraSQLout)
  {
    ##print;
    @words = split;
    $verb    = $words[0];
    #if (/> Database log mode/) 
    #{ 
    #  $arclogmode = $words[5];
    #}
    if (/Database log mode/ && /    Archive Mode/) 
    { 
      $arclogmode = "Archive";
    }
    if (substr($_,0,18) eq "Automatic archival") 
    { 
      $arcauto    = $words[2];
    }
    if ($verb eq "Y")
    {
      $arcdirraw  = $words[1];
      $found_dest = 1;
    }
  }

  if (! $found_dest)
  {
    my $emsg = "DBC File was coded for archivelog dest $thisdest - destination does not exist"; 
    system("echo ' ' | mailx -s 'DBAmon | $host/$os - $emsg' dbaadmin\@dba.it.agilent.com") if $company eq "agilent";
    &error("$emsg"); 
  }

  $flag = "";

  &msg("Archivelog destination $arcdirraw will be processed");

  #---- If the 1st char of arcdirraw is ?, then xlate it to oracle_home
  if ($arcdirraw =~ /\?/)
  {
    $arcdirraw =~ s/\?/$oh/;
    print "$P | arcdirraw Promoted from ?... to $arcdirraw \n";
  }

  #---- Cut off last level of (example) /oracle/PD1/saparch/PD1arch,
  #---- only if the last char is NOT a SLASH
  $lastchar = substr($arcdirraw,length($arcdirraw)-1);
  $z = -e $arcdirraw;
  ##print "lastchar=$lastchar z=$z\n";
  if ($lastchar ne "/" && $z == 0)
  {
    @words = split(/\//,$arcdirraw);
    $numlevels = $#words - 1;
    $arcdir = "";
    for ($i = 1; $i <= $numlevels; $i++)
    {
      $arcdir = $arcdir . "/" . $words[$i];
    }
  }
  else
  {
    $arcdir = $arcdirraw;
  }

  if ($arcdir ne "") 
  {
    open(BDF, "$bdfcmd $arcdir 2>/dev/null | tail -1 |") || &error("Error running $bdfcmd");
    while(<BDF>)
    {
      @words = split;
      $arcdirfull = $words[$#words-1];
      $arcfs      = $words[$#words];
      # Remove the % sign
      chop $arcdirfull;
    }
    close(BDF);
    if ($arcdirfull  >= $t_warn && $arcdirfull < $t_crit) { $flag = "W"; }
    if ($arcdirfull  >= $t_crit )                         { $flag = "C"; }
  }
  else
  {
    $flag = "E";
  }

  # Count the number of *arch* files in the archivelog directory
  &msg("Reading directory arcdir=$arcdir - looking for arch* files");
  opendir(ARCDIR,"$arcdir");
  @filenames = sort readdir(ARCDIR);
  closedir(ARCDIR);

  $arclogcount = 0;
  ARCFOREACH: foreach $file (@filenames)
  {
    $filefull = $arcdir . "/" . $file;
    &arcCheckBadFormat;
    next if -d "$filefull";
    next if $file !~ /^arch/;
    $arclogcount++;
  }
  &msg("Archivelog dir=$arcdir contains $arclogcount ^arch* files");

  # Run the specfied archivelog backup command
  $arccmdrun = "N";
  #if (($flag eq "W" || $flag eq "C") && $t_cmd ne "")
  if (($flag eq "W" || $flag eq "C") 
       && $t_cmd ne "" 
       && $arclogcount > 0)
  {
    $cmd = $t_cmd;
    print "$P Issuing at now command to run arclog backup:\n";
    print "$P Command before {SID} substitution: $cmd\n";
    $cmd =~ s/\{SID\}/$os/g;
    $cmd = "echo 'time $cmd' | at now";
    print "$P About to issue: $cmd\n";
    $rc = system($cmd);
    print "$P Back from issuing at now - rc=$rc\n";

    $arccmdrun = "Y";
  }
  if (($flag eq "W" || $flag eq "C") 
       && $arclogcount == 0)
  {
    &msg("<b>================================================================</b>");
    &msg("<b>NOTE: The archivelog filesystem $arcfs</b>");
    &msg("<b>  is over its threshold full, but because there are 0 </b>");
    &msg("<b>  archivelogs to backup for this filesystem, it would not </b>");
    &msg("<b>  do any good to run an archivelog backup. I will assume that </b>");
    &msg("<b>  the filesystem is full because of another DB which is also </b>");
    &msg("<b>  using this filesystem. The sev of this event will be $flag. </b>");
    &msg("<b>================================================================</b>");
  }

  print "$P arcdirraw:  $arcdirraw\n";
  print "$P arclogmode: $arclogmode\n";
  print "$P arcauto:    $arcauto\n";
  print "$P arcdir:     $arcdir\n";
  print "$P arcfs:      $arcfs\n";
  print "$P arcdirfull: $arcdirfull\n";
  print "$P arcflag:    $flag\n";
  print "$P arc_t_warn: $t_warn\n";
  print "$P arc_t_crit: $t_crit\n";
  print "$P arc_t_cmd:  $t_cmd\n";
  print "$P arccmdrun:  $arccmdrun\n";
}

# ----------------------------------------------------------------------
sub arcCheckBadFormat
# ----------------------------------------------------------------------
{
  if ($filefull =~ /\/1\_\d+\.dbf$/ || $filefull =~ /archarch.+\.dbf$/)
  {
    print "$P arccheckbadformat:  $filefull\n" unless $arc_check_bad_format_flag;
    $arc_check_bad_format_flag = 1; 
  }
}

# ----------------------------------------------------------------------
sub arclogsFRA
# ----------------------------------------------------------------------
{
  &msg("arclogsFRA() Checking FRA"); 

  $sql = '
    archive log list;
    select \'Y\', destination from v\$archive_dest 
      where destination is not null; 
  ';
  
  @oraSQLout = `$os_scmd <<!
    $os_conn;
    $os_set
    $sql
    exit
  !`;

  $arcdir_in_oh = ""; 

  foreach (@oraSQLout)
  {
    ##print;
    @words = split;
    $verb    = $words[0];
    if (/Database log mode/ && /    Archive Mode/) 
    { 
      $arclogmode = "Archive";
    }
    if (substr($_,0,18) eq "Automatic archival") 
    { 
      $arcauto    = $words[2];
    }
    if (substr($_,0,19) eq "Archive destination" && $words[2] =~ /^\//) 
    { 
      $arcdirraw  = $words[2];
    }
    if ($verb eq "Y")
    {
      $arcdirraw  = $words[1];

      #---- See if this destination resides in $ORACLE_HOME
      if ($arcdirraw =~ /^$oh/)
      {
        $arcdir_in_oh .= "$arcdirraw,";  
      }
    }
  }
  
  &msg("Checking FRA full"); 
  $flag = "";

  chop($fra_full = `$progdir/dbamon_orastat.pl -fra | grep 'FRAFULL' | head -1 | awk '{ print \$NF }'`); 
  chop $fra_full;  #---- remove %
  chop($fra_file = `$progdir/dbamon_orastat.pl -fra | grep 'FRAFILE' | head -1 | awk '{ print \$NF }'`); 
  &msg("Result fra_full=$fra_full fra_file=$fra_file"); 

  $arcdirfull = $fra_full; 
  $arcdir = "?"; 
  $arcfs = $fra_file; 

  if ($fra_full  >= $t_warn && $fra_full < $t_crit) { $flag = "W"; }
  if ($fra_full  >= $t_crit )                       { $flag = "C"; }

  # Run the specfied archivelog backup command
  $arccmdrun = "N";
  if (($flag eq "W" || $flag eq "C") 
       && $t_cmd ne "" )
  {
    $cmd = $t_cmd;
    print "$P Issuing at now command to run arclog backup:\n";
    print "$P Command before {SID} substitution: $cmd\n";
    $cmd =~ s/\{SID\}/$os/g;
    $cmd = "echo 'time $cmd' | at now";
    print "$P About to issue: $cmd\n";
    $rc = system($cmd);
    print "$P Back from issuing at now - rc=$rc\n";
    $arccmdrun = "Y";
  }

  print "$P arcdirraw:  $arcdirraw\n";
  print "$P arclogmode: $arclogmode\n";
  print "$P arcauto:    $arcauto\n";
  print "$P arcdir:     $arcdir\n";
  print "$P arcfs:      $arcfs\n";
  print "$P arcdirfull: $arcdirfull\n";
  print "$P arcflag:    $flag\n";
  print "$P arc_t_warn: $t_warn\n";
  print "$P arc_t_crit: $t_crit\n";
  print "$P arc_t_cmd:  $t_cmd\n";
  print "$P arccmdrun:  $arccmdrun\n";

  # Check archivelog destination status
  ARCLOG_FINISH: $sqlstmt = 'select \'X\',
      DEST_ID      ,
      STATUS       ,
      BINDING      ,
      NAME_SPACE   ,
      TARGET       ,
      REOPEN_SECS  ,
      DESTINATION  ,
      to_char(FAIL_DATE,\'YYYY/MM/DD-HH24:MM:SS\') ,
      ERROR
    from v\$archive_dest ;';
  
  &oraSQL($sqlstmt);
  foreach (@oraSQLout)
  {
    ##print;
    @words = split;
    $verb    = $words[0];
    if ($verb eq "X") 
    { 
      $dest    = $words[1];
      $status  = $words[2];
      $binding = $words[3];
      $name    = $words[4];
      $target  = $words[5];
      $reopen  = $words[6];
      $dest2   = $words[7];
      $faildt  = $words[8];
      $error   = $words[9] . " " . $words[10]  . " " . $words[11]  . " " . $words[12]  . " " . $words[13]  . " " . $words[14]  . " " . $words[15]  . " " . $words[16];

      if ($faildt ne "") { $faildt = "Failure Date: $faildt"; }
       
      # Try to fix dest
      if ($status eq "ERROR") 
      { 
        &arcDestFix;
      }

      # See if it is still broken
      if ($status eq "ERROR") 
      { 
	$desterror = 1; 
	$color = "red";
	$desterrorlist .= $dest . ",";
      }
      else
      {
        $color = "lime";
      }
      $arcdesthtml .= "<tr bgcolor=$color><td><h5>$dest<td><h5>$status<td><h5>$binding<td><h5>$name<td><h5>$target<td><h5>$reopen<td><h5>$dest2<td><h5>$faildt $error </tr>\n";
    }
  }
  print "<p><hr><b>Archive Log Destination Status:</b>\n";
  print "<table border=1>\n";
  print "<tr bgcolor=slate>
    <th>$fs Dest<br>Number
    <th>$fs Status
    <th>$fs Binding
    <th>$fs System/<br>Session
    <th>$fs Primary/<br>Standby
    <th>$fs Reopen<br>Secs.
    <th>$fs Destination
    <th>$fs Error(s)
  ";

  print $arcdesthtml;

  print "</table><hr>\n";

  if ($desterror)
  {
    chop $desterrorlist;
    print "$P arcdesterror: Y $desterrorlist $destfixmsg\n";
  }
  if ($destwarning)
  {
    chop $destwarninglist;
    print "$P arcdestwarning: Y $destwarninglist $destfixmsg\n";
  }
  if ($arcdir_in_oh)
  {
    chop $arcdir_in_oh;
    print "$P ARCDESTINOH: $arcdir_in_oh\n";
  }

  &msg("arclogsFRA() Done"); 
}

# ----------------------------------------------------------------------
sub arclogs 
# ----------------------------------------------------------------------
{
  &msg("arclogs() Checking archivelog destination(s)"); 

  $t_warn = $arg1;
  $t_crit = $arg2;
  $t_cmd  = $arg3;
  &msg("t_warn=$t_warn t_crit=$t_crit t_cmd=$t_cmd");

  chop($fra_output = `$progdir/dbamon_orastat.pl -fra`); 
  if ($fra_output =~ /FRAFULL/)
  {
    &msg("This instance uses FRA for archivelog dest - Invoking arclogsFRA"); 
    &arclogsFRA; 
    return;
  }
  else
  {
    &msg("This instance does not use FRA - continuing"); 
  }

  if ($rq_arclog_by_dest)
  {
    &msg("arclog() - Invoking arclogsByDest");  
    foreach $thisdest (sort keys %rq_arc_dest)
    {
      &arclogsByDest;
    }
    &msg("arclog() - Back from arclogsByDest");  
    goto ARCLOG_FINISH; 
  }

  $sql = '
    archive log list;
    select \'X\', destination from v\$archive_dest 
      where arcmode = \'MUST SUCCEED\' and destination like \'/%\';
    select \'Y\', destination from v\$archive_dest 
      where binding = \'MANDATORY\' and destination like \'/%\';
  ';
  
  @oraSQLout = `$os_scmd <<!
    $os_conn;
    $os_set
    $sql
    exit
  !`;

  $arcdir_in_oh = ""; 

  foreach (@oraSQLout)
  {
    ##print;
    @words = split;
    $verb    = $words[0];
    #if (/> Database log mode/) 
    #{ 
    #  $arclogmode = $words[5];
    #}
    if (/Database log mode/ && /    Archive Mode/) 
    { 
      $arclogmode = "Archive";
    }
    if (substr($_,0,18) eq "Automatic archival") 
    { 
      $arcauto    = $words[2];
    }
    if (substr($_,0,19) eq "Archive destination" && $words[2] =~ /^\//) 
    { 
      $arcdirraw  = $words[2];
      push(@arcdirs,$arcdirraw);
    }
    if ($verb eq "X")
    {
      #8.0
      $arcdirraw  = $words[1];
      push(@arcdirs,$arcdirraw) unless $arcdirs[0] eq $arcdirraw;
    }
    if ($verb eq "Y")
    {
      #8.1
      $arcdirraw  = $words[1];
      push(@arcdirs,$arcdirraw) unless $arcdirs[0] eq $arcdirraw;

      #---- See if this destination resides in $ORACLE_HOME
      if ($arcdirraw =~ /^$oh/)
      {
        $arcdir_in_oh .= "$arcdirraw,";  
      }
    }
  }

  # Process each @arcdirs
  $z = $#arcdirs + 1;
  &msg("$z Archivelog destinations will be considered");
  @arcdirssorted = sort @arcdirs;
  foreach $arcdirraw (@arcdirssorted)
  {
    &msg("Processing arcdirraw=$arcdirraw");
    $flag = "";

    # if the 1st char of arcdirraw is ?, then xlate it to oracle_home
    #if (substr($arcdirraw,0,1) eq "?")
    if ($arcdirraw =~ /\?/)
    {
      $arcdirraw =~ s/\?/$oh/;
      print "$P | arcdirraw Promoted from ?... to $arcdirraw \n";
    }

    # Cut off last level of (example) /oracle/PD1/saparch/PD1arch,
    # only if the last char is NOT a SLASH
    $lastchar = substr($arcdirraw,length($arcdirraw)-1);
    $z = -e $arcdirraw;
    ##print "lastchar=$lastchar z=$z\n";
    if ($lastchar ne "/" && $z == 0)
    {
      @words = split(/\//,$arcdirraw);
      $numlevels = $#words - 1;
      $arcdir = "";
      for ($i = 1; $i <= $numlevels; $i++)
      {
	$arcdir = $arcdir . "/" . $words[$i];
      }
    }
    else
    {
      $arcdir = $arcdirraw;
    }

    if ($arcdir ne "") 
    {
      open(BDF, "$bdfcmd $arcdir 2>/dev/null | tail -1 |") || &error("Error running $bdfcmd");
      while(<BDF>)
      {
	@words = split;
	$arcdirfull = $words[$#words-1];
	$arcfs      = $words[$#words];
	# Remove the % sign
	chop $arcdirfull;
      }
      close(BDF);
      if ($arcdirfull  >= $t_warn && $arcdirfull < $t_crit) { $flag = "W"; }
      if ($arcdirfull  >= $t_crit )                         { $flag = "C"; }
    }
    else
    {
      $flag = "E";
    }

    # Count the number of *arch* files in the archivelog directory
    &msg("Reading directory arcdir=$arcdir - looking for arch* files");
    opendir(ARCDIR,"$arcdir");
    @filenames = sort readdir(ARCDIR);
    closedir(ARCDIR);

    $arclogcount = 0;
    ARCFOREACH: foreach $file (@filenames)
    {
      $filefull = $arcdir . "/" . $file;
      &arcCheckBadFormat;
      next if -d "$filefull";
      next if $file !~ /^arch/;
      $arclogcount++;
    }
    &msg("Archivelog dir=$arcdir contains $arclogcount ^arch* files");

    # Run the specfied archivelog backup command
    $arccmdrun = "N";
    #if (($flag eq "W" || $flag eq "C") && $t_cmd ne "")
    if (($flag eq "W" || $flag eq "C") 
         && $t_cmd ne "" 
         && $arclogcount > 0)
    {
      $cmd = $t_cmd;
      print "$P Issuing at now command to run arclog backup:\n";
      print "$P Command before {SID} substitution: $cmd\n";
      $cmd =~ s/\{SID\}/$os/g;
      $cmd = "echo 'time $cmd' | at now";
      print "$P About to issue: $cmd\n";
      $rc = system($cmd);
      print "$P Back from issuing at now - rc=$rc\n";

      $arccmdrun = "Y";
    }
    if (($flag eq "W" || $flag eq "C") 
         && $arclogcount == 0)
    {
      &msg("<b>================================================================</b>");
      &msg("<b>NOTE: The archivelog filesystem $arcfs</b>");
      &msg("<b>  is over its threshold full, but because there are 0 </b>");
      &msg("<b>  archivelogs to backup for this filesystem, it would not </b>");
      &msg("<b>  do any good to run an archivelog backup. I will assume that </b>");
      &msg("<b>  the filesystem is full because of another DB which is also </b>");
      &msg("<b>  using this filesystem. The sev of this event will be $flag. </b>");
      &msg("<b>================================================================</b>");
    }

    print "$P arcdirraw:  $arcdirraw\n";
    print "$P arclogmode: $arclogmode\n";
    print "$P arcauto:    $arcauto\n";
    print "$P arcdir:     $arcdir\n";
    print "$P arcfs:      $arcfs\n";
    print "$P arcdirfull: $arcdirfull\n";
    print "$P arcflag:    $flag\n";
    print "$P arc_t_warn: $t_warn\n";
    print "$P arc_t_crit: $t_crit\n";
    print "$P arc_t_cmd:  $t_cmd\n";
    print "$P arccmdrun:  $arccmdrun\n";
  } # end of foreach arcdirs

  # Check archivelog destination status
  ARCLOG_FINISH: $sqlstmt = 'select \'X\',
      DEST_ID      ,
      STATUS       ,
      BINDING      ,
      NAME_SPACE   ,
      TARGET       ,
      REOPEN_SECS  ,
      DESTINATION  ,
      to_char(FAIL_DATE,\'YYYY/MM/DD-HH24:MM:SS\') ,
      ERROR
    from v\$archive_dest ;';
  
  &oraSQL($sqlstmt);
  foreach (@oraSQLout)
  {
    ##print;
    @words = split;
    $verb    = $words[0];
    if ($verb eq "X") 
    { 
      $dest    = $words[1];
      $status  = $words[2];
      $binding = $words[3];
      $name    = $words[4];
      $target  = $words[5];
      $reopen  = $words[6];
      $dest2   = $words[7];
      $faildt  = $words[8];
      $error   = $words[9] . " " . $words[10]  . " " . $words[11]  . " " . $words[12]  . " " . $words[13]  . " " . $words[14]  . " " . $words[15]  . " " . $words[16];

      if ($faildt ne "") { $faildt = "Failure Date: $faildt"; }
       
      # Try to fix dest
      if ($status eq "ERROR") 
      { 
        &arcDestFix;
      }

      # See if it is still broken
      if ($status eq "ERROR") 
      { 
	$desterror = 1; 
	$color = "red";
	$desterrorlist .= $dest . ",";
      }
      else
      {
        $color = "lime";
      }
      $arcdesthtml .= "<tr bgcolor=$color><td><h5>$dest<td><h5>$status<td><h5>$binding<td><h5>$name<td><h5>$target<td><h5>$reopen<td><h5>$dest2<td><h5>$faildt $error </tr>\n";
    }
  }
  print "<p><hr><b>Archive Log Destination Status:</b>\n";
  print "<table border=1>\n";
  print "<tr bgcolor=slate><th>Dest<br>Number<th>Status<th>Binding<th>System/<br>Session<th>Primary/<br>Standby<th>Reopen<br>Secs.<th>Destination<th>Error(s)\n";

  print $arcdesthtml;

  print "</table><hr>\n";

  if ($desterror)
  {
    chop $desterrorlist;
    print "$P arcdesterror: Y $desterrorlist $destfixmsg\n";
  }
  if ($destwarning)
  {
    chop $destwarninglist;
    print "$P arcdestwarning: Y $destwarninglist $destfixmsg\n";
  }
  if ($arcdir_in_oh)
  {
    chop $arcdir_in_oh;
    print "$P ARCDESTINOH: $arcdir_in_oh\n";
  }
}

# ----------------------------------------------------------------------
sub arcDestFix
# ----------------------------------------------------------------------
{
  print "$P | Attempting to fix archive dest $dest\n";

  print "$P | Looking for init.ora log_archive_dest_$dest parm\n";
  open(RO,"$oh/dbs/init$os.ora") || &error("Cannot OPEN init.ora file=$oh/dbs/init$os.ora");
  while (<RO>)
  {
    $initora .= $_;
    @words = split(/=/);
    if (substr($words[0],0,5) eq "ifile")
    {
      $ifile = $words[$#words];
      $initora .= "#**** Contents of ifile: $ifile *****\n";
      # if the 1st char of ifile is ?, then xlate it to oracle_home
      if ($ifile =~ /\?/)
      {
	$ifile =~ s/\?/$oh/;
	&msg("ifile Promoted from ?... to $ifile");
      }
      open(RO2,"$ifile") || &error("Cannot OPEN init.ora file=$ifile");
      while (<RO2>)
      {
        $initora .= $_;
      }
      close(RO2);
      $initora .= "#**** End of ifile: $ifile *****\n";
    }
  }
  close(RO);

  @lines = split(/\n/,$initora);
  foreach (@lines) 
  {
    if (/^log_archive_dest_$dest/)
    {
      $initdest = $_;
    }
  }
  print "$P | log_archive_dest_$dest init.ora value: $initdest\n";

  if ($initdest eq "")
  {
    print "$P | ERROR: Could not find a valid log_archive_dest_2 parm in init.ora\n";
    print "$P | Auto restart of broken destintaion cannot occur\n";
    return;
  }

  print "$P | Running $os_scmd - alter system set $initdest;\n";
  $rc = system("$os_scmd <<! 
    $os_conn
    set echo on;
    alter system set $initdest;
    alter system archive log current;
  !");
  print "$P | $os_scmd Done rc=$rc\n";

  print "$P | Sleeping 60\n";
  system("sleep 60");

  print "$P | Rechecking status of dest $dest\n";

  &oraSQL('select \'X\', STATUS, from v\$archive_dest where dest_id = $dest');
  foreach (@oraSQLout)
  {
    ##print;
    @words = split;
    $verb    = $words[0];
    if ($verb eq "X") 
    { 
      $status  = $words[1];
      last;
    }
  }
  print "$P | Status is $status\n";

  ##print "$P | diag. email\n";
  ##system("echo ' ' | mailx -s 'DBAmon | arcDestFix $host $os $status $initdest' dbaadmin\@dba.it.agilent.com") if $company eq "agilent";

  if ($status eq "ERROR")
  {
    $destfixmsg = " (Restart attempted, not successful)";
  }
  else
  {
    $destfixmsg = " (Restart successful)";
    $destwarning = 1;
  }
}

# ----------------------------------------------------------------------
sub aliasInfo
# ----------------------------------------------------------------------
{
  &msg("aliasInfo() - Starting");
  # Send host/alias info
  print "$P FQHOSTNAME:     $fqhost\n";
  print "$P HOSTNAME:       $host\n";

  @alias_list = `netstat -i | grep ':' | grep 'com \$' | awk '{ print \$NF }'`;
  foreach (@alias_list)
  {
    chop;
    print "$P NETALIAS:       $_\n";
  }
  &msg("aliasInfo() - Done");
}

# ----------------------------------------------------------------------
sub upParm
# ----------------------------------------------------------------------
{

  $id3file = "/tmp/dbamon_ora_${os}_id3.txt";
  &msg("up() - Saving ID3 value of $arg2 to $id3file");
  system("echo '$arg2' > $id3file 2>&1");

  if ($ENV{'PAGER_EMAIL'} ne "")
  {
    $pagerfile = "/tmp/dbamon_ora_${os}_pager.txt";
    &msg("up() - Saving PAGER_EMAIL value of $ENV{'PAGER_EMAIL'} to $pagerfile");
    $z = $ENV{'PAGER_EMAIL'};
    system("echo '$z' > $pagerfile 2>&1");
  }

  $backup_tape_io_slaves = "";
  $dbwr_io_slaves = "";
  $large_pool_size = "";

  &msg("Checking for conflicting init.ora parameters");
  $parms = lc "'large_pool_size','backup_tape_io_slaves','dbwr_io_slaves','control_file_record_keep_time'";
  &oraSQL("select  \'Z\', name, value from v\\\$parameter where name in ($parms);");
  foreach (@oraSQLout)
  {
    ##print;
    @words = split;
    if ($words[0] eq "Z")
    {
      $stmt = "\$$words[1] = '$words[2]'\;";
      ##print "stmt=$stmt \n";
      eval $stmt;
    }
  }

  if ($large_pool_size > 0 && $backup_tape_io_slaves eq "FALSE" && $dbwr_io_slaves eq "0")
  {
    print "$P PARMERROR: large_pool_size > 0 & backup_tape_io_slaves = FALSE & dbwr_io_slaves = 0 \n";
  }
  #if ($control_file_record_keep_time < 45 && substr($oraver,0,3) ge "8.1" && $bktype eq "bkRMAN")
  #{
  #  print "$P PARMERROR: Since this 8.1+ instance uses RMAN for backups and no RCVCAT, control_file_record_keep_time (now $control_file_record_keep_time) must be >= 45 \n";
  #}

}

# ----------------------------------------------------------------------
sub alertlog
# ----------------------------------------------------------------------
{
  $okflag = 1;
  &msg("Checking Alert Log - After timestamp=$dcf_hash{'LastAlertCheckChar'} - New excl logic"); 

  $S = "Stack: oraAlertsStack ";

  $tmpincl = "$tmpdir/dbamon_ora_alertlog.incl";
  $tmpexcl = "$tmpdir/dbamon_ora_alertlog.excl";
  $tmpout1 = "$tmpdir/dbamon_ora_alertlog.out1";
  $tmpout2 = "$tmpdir/dbamon_ora_alertlog.out2";

  &oraSQL('select value from v\$parameter where name =\'background_dump_dest\'');
  foreach (@oraSQLout)
  {
    if (/^\//)
    {
      @words = split;
      $fname = $words[0];
    }
  }
  print "$S$P alertlog: fname=$fname/alert_$os.log\n";

  # Isolate INCL lines
  ## system("grep '^CHKALERT I' $cfg | awk '{ print \$3 }' > $tmpincl");
  system("grep '^CHKALERT I' $cfg | awk '{ print substr(\$0,12) }' > $tmpincl");

  # Isolate EXCL lines
  ## system("grep '^CHKALERT E' $cfg | awk '{ print \$3 }' > $tmpexcl");
  ##system("grep '^CHKALERT E' $cfg | awk '{ print substr(\$0,12) }' > $tmpexcl");
  system("grep '^CHKALERT E' $cfg | awk '{ print \$3 }' | sed 's/\\\[/\\\\\\[/g' | sed 's/\\\]/\\\\\\]/g' > $tmpexcl");

  #---- 1.70 BB 10Dec07 - See if there is a local instance exclude file. If 
  #----  there is, then add it to the tmpexcl file.
  $li_exclude_file = "$ENV{'HOME'}/.dbamon_${os}_alert_exclude.txt"; 
  &msg("Looking for local instance exclude file $li_exclude_file"); 
  if (-e $li_exclude_file && -r $li_exclude_file)
  {
    &msg("Found LIE file - appending to tmpexcl=$tmpexcl"); 
    system("cat $li_exclude_file"); 
    system("cat $li_exclude_file >> $tmpexcl"); 
    #---- DEGUG start
    ##&msg("DEBUG - contents:"); 
    ##system("cat $tmpexcl"); 
    #---- DEGUG end
  }

  # NOTE: On 21Jan03 I changed the 'grep' in these 2 test from grep to fgrep
  #   for Solaris. 

  # grep for INCL lines
  system("tail -50 $fname/alert_$os.log 2>/dev/null | fgrep -if  $tmpincl > $tmpout1");

  # grep for EXCL lines
  system("cat $tmpout1 | fgrep -vif $tmpexcl > $tmpout2");

  $lines = `wc -l $tmpout2 | awk '{ print \$1 }'`;
  chop $lines;
  print "$S$P alertlog: lines=$lines\n";

  if ($lines > 0)
  {
    print "$S$P alertlog: ALERT Exception Message(s) Found:\n"; 
    ##print "$S=======================================================\n\n";
    print "$S               <b>\n"; 

    @z = `cat $tmpout2`; 
    foreach (@z) { print "$S$_ "; }

    print "$S               </b>\n"; 
    ##print "\n$S=======================================================\n";

    $okflag = 0;
  }

  # For lightbulb
  print "<b>$dashes</b>\n";
  print "<b> Last 50 lines of Oracle Alert Log: \n   $fname/alert_$os.log    </b>\n";
  print "$S$P alertlog: Last 50 Lines Of Alert Log:\n"; 
  print "<b>$dashes</b>\n";

  # Display the last 50 lines of the alert log
  open(CAT,"tail -50 $fname/alert_$os.log 2>/dev/null |") || &error("Cannot cat alert log file $fname");
  while (<CAT>)
  {
    print "${S}alerttext: $_";
  }
  close(CAT);
  
  print "$S$P alertlog: OK\n" if $okflag;

  #---- Cycle finish variable
  $z = time; 
  $dcf_hash{"LastAlertCheckNum"}  = $z; 
  $dcf_hash{"LastAlertCheckChar"} = &timeToText($z); 
}

# ----------------------------------------------------------------------
sub alertLogByTS
# ----------------------------------------------------------------------
{
  &msg("alertLogByTS() Alert Log - After timestamp=$dcf_hash{'LastAlertCheckChar'}"); 

  if ($dcf_hash{'LastAlertCheckChar'} eq "")
  {
    #---- Set to 2 hours ago
    $dcf_hash{'LastAlertCheckChar'} = &timeToText(time - (2*60*60));
    &msg("LastAlertCheck was null - set to $dcf_hash{'LastAlertCheckChar'}"); 
  }

  $S = "Stack: oraAlertsStack ";

  $tmpincl = "$tmpdir/dbamon_ora_alrtincl_${os}_$$.txt";
  $tmpexcl = "$tmpdir/dbamon_ora_alrtexcl_${os}_$$.txt";
  $tmpalrt = "$tmpdir/dbamon_ora_alrtalrt_${os}_$$.txt";
  $tmpout1 = "$tmpdir/dbamon_ora_alrtout1_${os}_$$.txt";
  $tmpout2 = "$tmpdir/dbamon_ora_alrtout2_${os}_$$.txt";

  &oraSQL('select value from v\$parameter where name =\'background_dump_dest\'');
  foreach (@oraSQLout)
  {
    if (/^\//)
    {
      @words = split;
      $fname = $words[0];
    }
  }
  print "$S$P alertlog: fname=$fname\n";

  #---- Isolate INCL lines from .cfg file
  open(INCL, ">$tmpincl") || &error("Error opening output $tmpalrt - $!");
  open(CFGIN,"grep '^CHKALERT I' $cfg |") || &error("Error opening output $tmpalrt - $!");
  while(<CFGIN>)
  {
    ($line = $_) =~ s/^CHKALERT I //;
    print INCL $line;
  }
  close(CFGIN);
  close(INCL);

  #---- Isolate EXCL lines from .cfg file
  open(EXCL, ">$tmpexcl") || &error("Error opening output $tmpalrt - $!");
  open(CFGIN,"grep '^CHKALERT E' $cfg |") || &error("Error opening output $tmpalrt - $!");
  while(<CFGIN>)
  {
    ($line = $_) =~ s/^CHKALERT E //;
    print EXCL $line;
  }
  close(CFGIN);
  close(EXCL);

  #---- Populate $tmpalrt with all alert log lines since the last check
  $alrtdata = ""; 
  foreach (`$progdir/dbamon_orastat.pl -mr a`)
  {
    next if $_ !~ /^2/;
    next if $_ =~ /orastat/;

    $ts = (split())[0];

    chop($z = $_); 
    ##&msg("DEBUG - ts=$ts z=$z"); 

    next if $ts le $dcf_hash{'LastAlertCheckChar'};

    $alrtdata .= $_;
  }

  if (length($alrtdata) == 0)
  {
    &msg("NOTE: There are no alert log entries newer than $dcf_hash{'LastAlertCheckChar'}"); 
  }
  else
  {
    open(ALRT, ">$tmpalrt") || &error("Error opening output $tmpalrt - $!");
    print ALRT $alrtdata;
    close(ALRT);

    &msg("DEBUG - file=$tmpalrt"); 
    system("cat $tmpalrt 2>&1"); 

    #---- grep for INCL lines
    system("cat $tmpalrt | fgrep -if  $tmpincl > $tmpout1");

    #---- grep for EXCL lines
    system("cat $tmpout1 | fgrep -vif $tmpexcl > $tmpout2");

    chop($lines = `wc -l $tmpout2 | awk '{ print \$1 }'`);
    print "$S$P alertlog: lines=$lines\n";

    if ($lines > 0)
    {
      print "$S$P alertlog: ALERT Messages Found:\n"; 
      print "$S=======================================================\n";
      @z = `cat $tmpout2`; 
      foreach (@z) { print "$S$_ "; }
      print "$S=======================================================\n";
    }
  }

  #---- For lightbulb
  print "<b>$dashes</b>\n";
  print "<b> Last 50 lines of Oracle Alert Log: \n   $fname/alert_$os.log    </b>\n";
  print "<b>$dashes</b>\n";

  #---- Display the last 50 lines of the alert log
  open(CAT,"$progdir/dbamon_orastat.pl -mr 50 | grep -v 'orastat' |") || &error("Cannot cat alert log file $fname");
  while (<CAT>)
  {
    print "${S}alerttext: $_";
  }
  close(CAT);
  
  print "$S$P alertlog: OK\n";

  #---- Cycle finish variable
  $z = time; 
  $dcf_hash{"LastAlertCheckNum"}  = $z; 
  $dcf_hash{"LastAlertCheckChar"} = &timeToText($z); 

  &msg("alertLogByTS() Removing tmp files");
  #system("rm $tmpincl $tmpexcl $tmpalrt $tmpout1 $tmpout2 2>&1");
}

# ----------------------------------------------------------------------
sub alertlogWWW
# ----------------------------------------------------------------------
{
  $tmpincl = "$tmpdir/dbamon_ora_alertlog.incl";
  $tmpexcl = "$tmpdir/dbamon_ora_alertlog.excl";
  $tmpout1 = "$tmpdir/dbamon_ora_alertlog.out1";
  $tmpout2 = "$tmpdir/dbamon_ora_alertlog.out2";

  &oraSQL('select value from v\$parameter where name =\'background_dump_dest\'');
  foreach (@oraSQLout)
  {
    if (/^\//)
    {
      @words = split;
      $fname = $words[0];
    }
  }
  &msg("Checking Alert Log $fname For Critical Messages - New excl logic");

  # Isolate INCL lines
  system("grep '^CHKALERT I' $cfg | awk '{ print \$3 }' > $tmpincl");

  # Isolate EXCL lines
  #system("grep '^CHKALERT E' $cfg | awk '{ print \$3 }' > $tmpexcl");
  system("grep '^CHKALERT E' $cfg | awk '{ print \$3 }' | sed 's/\\\[/\\\\\\[/g' | sed 's/\\\]/\\\\\\]/g' > $tmpexcl");

  #---- Test
  if ($host eq "slums03")
  {
    system("cat $tmpexcl"); 
  }

  #---- 1.70 BB 10Dec07 - See if there is a local instance exclude file. If 
  #----  there is, then add it to the tmpexcl file.
  $li_exclude_file = "$ENV{'HOME'}/.dbamon_${os}_alert_exclude.txt"; 
  &msg("Looking for local instance exclude file $li_exclude_file"); 
  if (-e $li_exclude_file && -r $li_exclude_file)
  {
    &msg("Found LIE file - appending to tmpexcl=$tmpexcl"); 
    system("cat $li_exclude_file"); 
    system("cat $li_exclude_file >> $tmpexcl"); 
    #---- DEGUG start
    ##&msg("DEBUG - contents:"); 
    ##system("cat $tmpexcl"); 
    #---- DEGUG end
  }

  # NOTE: On 21Jan03 I changed the 'grep' in these 2 test from grep to fgrep
  #   for Solaris. 

  # grep for INCL lines
  system("tail -50 $fname/alert_$os.log 2>/dev/null | fgrep -if  $tmpincl > $tmpout1");

  # grep for EXCL lines
  system("cat $tmpout1 | fgrep -vif $tmpexcl > $tmpout2");

  $lines = `wc -l $tmpout2 | awk '{ print \$1 }'`;
  chop $lines;
  &msg("Found $lines Critical Alert Messages");

  $alertmsg = "OK";

  if ($lines > 0)
  {
    print "$S=======================================================\n";
    @z = `cat $tmpout2`; 
    foreach (@z) { print "$S$_"; }
    print "$S=======================================================\n";
    $alertflag = 1;
    $alertmsg = ">>> Critical Error Message(s) Found <<<";
  }
}

# ----------------------------------------------------------------------
sub DBOpenCheck
# ----------------------------------------------------------------------
{
  $dboc_debug = 1;
  &msg("DBOpenCheck() - Ensuring DB is OPEN") if $dboc_debug;

  my $dboc_status = "?";
  my $dboc_diag   = "";
 
  my $dboc_sql = 'select \'X\', status from v\$instance;';

  my @dboc_oraSQLout = `$os_scmd <<!
    $os_conn;
    $os_set
    $dboc_sql
    ;
  !`;

  foreach (@dboc_oraSQLout)
  {
    print if /^ORA/;
    @dboc_words = split;
    $dboc_verb  = $dboc_words[0];
    if ($dboc_verb eq "ORA-00904:") 
    {
      #---- This must be oracle v7 - return false open
      &msg("This must be Oracle V7 - returning false open"); 
      $dboc_status = "OPEN";
      last;
    }
    if ($dboc_verb eq "X") { $dboc_status = $dboc_words[1]; }
    $dboc_diag .= $_;
  }
  &msg("DBOpenCheck() - Returning $dboc_status") if $dboc_debug;

  if ($dboc_status ne "OPEN")
  {
    &msg("DBOpenCheck() - DB Status is $dboc_status (should be OPEN) - $os_scmd Output: \n$dboc_diag");
    ##system("echo ' ' | mailx -s 'DBAmon | $host/$os - Dropped-OPEN - dboc_status=$dboc_status' dbaadmin\@dba.it.agilent.com") if $company eq "agilent";
  }

  return $dboc_status;
}

# ----------------------------------------------------------------------
sub dfCheck
# ----------------------------------------------------------------------
{
  #---- Count the rows in dba_data_files - This will catch DB's with df problems 
  &msg("Counting rows in dba_data_files");
 
  $sqlstmt = '
    select \'X\', count(*) from dba_data_files;
  ';

  $dfcount = "?";

  &oraSQL($sqlstmt);
  foreach (@oraSQLout)
  {
    print if /^ORA/;
    @words = split;
    $verb    = $words[0];
    if ($verb eq "X")
    {
      $dfcount = $words[1];
    }
  }
  &msg("Rows in dba_data_files: $dfcount");
 
  if ($dfcount eq "?")
  {
    system("echo ' ' | mailx -s 'DBAmon | $host/$os - Cound not select dba_data_files' dbaadmin\@dba.it.agilent.com") if $company eq "agilent";
    &error("Cound not run 'select count(*) from dba_data_files'");
  }
}

# ----------------------------------------------------------------------
sub filesList
# ----------------------------------------------------------------------
{
  # List all datafiles, controlfile and redo logs as comments for the alertlog
  print "Stack: oraSaveCfgStack # \n";
  print "Stack: oraSaveCfgStack # Report of all Datafiles, RedoLogs and ControlFiles:\n";
  print "Stack: oraSaveCfgStack # \n";

  #---- BEFORE select \'X\', file_name, tablespace_name from dba_data_files

  $sqlstmt = '
  select \'X\', V\$datafile.name, V\$tablespace.name from V\$datafile, V\$tablespace where V\$datafile.TS# = V\$tablespace.TS#
  union all
  select \'Y\', member, \' \' from v\$logfile
  union all
  select \'Z\', name, \' \' from v\$controlfile
  union all
  select \'W\', to_char(dbid), \' \' from v\$database
  order by 1, 2;';

  ##&msg("Running sqlstmt=$sqlstmt"); 

  &oraSQL($sqlstmt);
  foreach (@oraSQLout)
  {
    ##print;
    @words = split;
    $verb    = $words[0];
    $ts      = $words[2];
    if ($verb eq "X")
    {
      $f = $words[1];
      print "Stack: oraSaveCfgStack # Datafile:    $f  (TS=$ts)\n";
    }
    if ($verb eq "W")
    {
      $dbid = $words[1];
      print "Stack: oraSaveCfgStack # DBID:  $dbid \n";
    }
    if ($verb eq "Y")
    {
      $f = $words[1];
      print "Stack: oraSaveCfgStack # RedoLog:     $f \n";
    }
    if ($verb eq "Z")
    {
      $f = $words[1];
      print "Stack: oraSaveCfgStack # ControlFile: $f \n";
    }
  }
}

# ----------------------------------------------------------------------
sub onlineRedo
# ----------------------------------------------------------------------
{
  print "$P | Checking for Online Redo Logs in exception status \n";

  $sqlstmt = 'select \'Y\', group#, status, member from v\$logfile where status is not null';
  &oraSQL($sqlstmt);
  foreach (@oraSQLout)
  {
    ##print;
    @words = split;
    $verb    = $words[0];
    $group      = $words[1];
    $status     = $words[2];
    $member     = $words[3];
    if ($verb eq "Y")
    {
      print "ONLINEREDOSTATUS: Group=$group File=$member \n";
    }
  }

  $sqlstmt = 'select 
    \'X\', 
    archiver,
    translate(log_switch_wait,\' \',\'_\')
  from
    v\$instance; 
  select
    \'Y\', 
    log_mode
  from
    v\$database; 
  ';
  &oraSQL($sqlstmt);
  foreach (@oraSQLout)
  {
    ##print;
    @words = split;
    $verb    = $words[0];
    if ($verb eq "X")
    {
      $archiver      = $words[1];
      $logswitchwait = $words[2];
      print "$P ARCHIVER:      $archiver\n";
      print "$P LOGSWITCHWAIT: $logswitchwait\n";
    }
    if ($verb eq "Y")
    {
      $arclogmode = $words[1];
      print "$P ARCLOGMODE:    $arclogmode\n";
    }
  }

  &msg("Running orastat -l to display current log details");
  &msg("================================================================");
  system("$progdir/dbamon_orastat.pl -l 2>&1");
  &msg("================================================================");
}

# ----------------------------------------------------------------------
sub processesCount
# ----------------------------------------------------------------------
{
  print "$P | Counting PROCESSES vs. init.ora value \n";
  $sqlstmt = '
  select \'Y\', count(*) from v\$process;
  select \'Z\', value from v\$parameter where name = \'processes\';';
  &oraSQL($sqlstmt);
  foreach (@oraSQLout)
  {
    ##print;
    @words = split;
    $verb    = $words[0];
    $p_count  = $words[1] if ($verb eq "Y");
    $p_config = $words[1] if ($verb eq "Z");
  }
  print "$P PROCESSES_THRESHOLD: $p_count $p_config \n";
}

# ----------------------------------------------------------------------
sub filesCount
# ----------------------------------------------------------------------
{
  print "$P | Counting FILES vs. init.ora value \n";
  $sqlstmt = '
  select \'Y\', count(*) from v\$datafile;
  select \'Z\', value from v\$parameter where name = \'db_files\';';
  &oraSQL($sqlstmt);
  foreach (@oraSQLout)
  {
    ##print;
    @words = split;
    $verb    = $words[0];
    $f_count  = $words[1] if ($verb eq "Y");
    $f_config = $words[1] if ($verb eq "Z");
  }
  print "$P FILES_THRESHOLD: $f_count $f_config \n";
}

# ----------------------------------------------------------------------
sub lsnr_start
# ----------------------------------------------------------------------
{
  # dr 01Oct01 Unset SHLIB_PATH prior to starting the listener. If there
  # are multiple oracle versions, SHLIB_PATH cannot be set when
  # starting the listener.
  
  print "$S$P lsnr: Attempting to restart listener:\n";
  $ENV{'SHLIB_PATH'} = "";
  $rc = system('lsnrctl <<! 
$lsnr_pwline
start
quit
!');
  print "$S$P lsnr: Restart rc=$rc\n";
  $lsnrerror = 'Lsnr Restart Attempted - rc=$rc';
}

# ----------------------------------------------------------------------
sub lsnr_check
#
# 01/24/00 DR: Allow for multiple tnslsnr processes, as you can run
#              more than one listener on a machine.
# ----------------------------------------------------------------------
{
  # Extract lsnr password (if any)

  
  if ($lsnr_file ne "")
  {
    chop($lsnr_pw = `cat $lsnr_file | grep -v '^#' | grep -i 'PASSWORDS_LISTENER' | awk -F= '{ print \$NF }'`);
  }

  if ($lsnr_pw ne "")
  {
    $lsnr_pwline = "set password $lsnr_pw";
    #&msg("Listener password is set - lsnr_cmd=$lsnr_pwline");
    &msg("Listener password is set");
  }
  else
  {
    $lsnr_pwline = "";
    &msg("Listener password is not set - lsnr_cmd=$lsnr_pwline");
  }

  $lsnr_cmd = "lsnrctl <<!
    $lsnr_pwline
    status
!";

  # Check for lsnr process
  $os_type = `uname -a`;
  $lc_os_type=lc($os_type);
  if ($lc_os_type =~ "linux")
  {
    $numlsnr = `ps -ef --cols 200 | grep 'tnslsnr' | grep -v 'grep' | wc -l`;
  }
  else 
  {
    $numlsnr = `ps -ef | grep 'tnslsnr' | grep -v 'grep' | wc -l`;
  }
  chop $numlsnr;
  print "$S$P NUMLSNR: $numlsnr\n";

  print "$P | Creating /tmp/$tmp_tnsnames_dir/tnsnames.ora\n";
  
  # See if this is an SAP system
  if (system("grep 'SAP.WORLD' $oh/network/admin/listener.ora 2>&1") == 0)
  {
    print "$P | This is a SAP system - altering tnsnames data\n";
    $tns_port = 1527;
    $tns_comm = "(COMMUNITY = SAP.WORLD)";
  }
  else
  {
    print "$P | This is a NOT an SAP system\n";
    $tns_port = 1521;
    $tns_comm = "";
  }

  &msg("Checking hostname being listened on"); 
  chop($listener_host = `netstat -l | grep 'tcp' | grep ':1521 ' | tail -1 | awk '{ print \$4 }' | awk -F. '{ print \$1 }'`);  
  &msg("listener_host=$listener_host"); 

  $tnsping_host = $fqhost;

  $host3char = substr($host,0,3); 
  &msg("DEBUG - host=$host listener_host=$listener_host host3char=$host3char"); 
  if ($listener_host =~ /^$host3char/ && $listener_host ne $host)
  {
    &msg("Resetting tnsping_host to $listener_host - host=$host listener_host=$listener_host host3char=$host3char"); 
    ##system("echo '' | mailx -s 'DBAmon | $host/$os - Resetting tnsping_host - host=$host listener_host=$listener_host host3char=$host3char' dbaadmin\@dba.it.agilent.com");
    $tnsping_host = $listener_host; 
  }

  # Create tnsnames.ora file
  $entry = "$os=
 (DESCRIPTION =
  (ADDRESS_LIST =
   (ADDRESS=(PROTOCOL=TCP)  $tns_comm  (HOST=$tnsping_host) (PORT=$tns_port)))
    (CONNECT_DATA = (SID = $os)))
$os.world=
 (DESCRIPTION =
  (ADDRESS_LIST =
   (ADDRESS=(PROTOCOL=TCP)  $tns_comm  (HOST=$tnsping_host) (PORT=$tns_port)))
    (CONNECT_DATA = (SID = $os)))";

  &msg("Cleanup up possible old files (error messages are OK)");
  system("rm -fr /tmp/$tmp_tnsnames_dir 2>&1");
  system("mkdir  /tmp/$tmp_tnsnames_dir 2>&1");
  system("rm -fr    /tmp/$tmp_tnsnames_dir/tnsnames.ora 2>&1");
  system("touch     /tmp/$tmp_tnsnames_dir/tnsnames.ora 2>&1");
  system("chmod 777 /tmp/$tmp_tnsnames_dir/tnsnames.ora 2>&1");

  &msg("Writing new /tmp/$tmp_tnsnames_dir/tnsnames.ora");

  close(TNS);
  open(TNS, ">/tmp/$tmp_tnsnames_dir/tnsnames.ora") || &error("can't open output /tmp/$tmp_tnsnames_dir/tnsnames.ora - $!");
  print TNS "$entry \n";
  close(TNS);

  &msg("Dynamically created TNSNAMES dir");
  system("ls -l /tmp/$tmp_tnsnames_dir/*");
  system("cat /tmp/$tmp_tnsnames_dir/*");

  $ENV{"TNS_ADMIN"} = "/tmp/$tmp_tnsnames_dir";
  
  # Check listener status
  &msg("lsnr_check(): Running lsnrctl status");
  $lsnrout = `$lsnr_cmd`;
  print "\nlsnrout=$lsnrout \n\n";
  if (index($lsnrout,"successfully") > -1)
  {
    $lsnrstat = 1;
  }
  else
  {
    $lsnrstat = 0;
  }
  print "$S$P LSNRSTAT: $lsnrstat $lsnrerror\n";

  # try tnsping
  # Bug in 8.1.6 when running MTS prevents tnsping from working.
  # If using MTS on an OPS system, keyword REGISTER appears in
  # tnsnames, so look for that.

  $mts = `grep -i 'register' /etc/tnsnames.ora 2>/dev/null | wc -l`;
  chop $mts;
  if ($mts == 0)
  { 
    &msg("lsnr_check(): Running tnsping $os.world");
    $tnspingout = `tnsping $os.world`;
    print $tnspingout;
    if (index($tnspingout,"OK") > -1)
    {
      $tnsstat = 1;
    }
    else
    {
      &msg("=============================================================");
      &msg("Current dynamic /tmp/$tmp_tnsnames_dir/tnsnames.ora file contents:");
      system("cat /tmp/$tmp_tnsnames_dir/tnsnames.ora 2>&1");
      &msg("=============================================================");
      $tnsstat = 0;
      $z = substr($tnspingout,index($tnspingout,'TNS-'));
      @words = split(/\n/,$z);
      $tnserror = $words[0];
    }
    print "$S$P TNSPING: $tnsstat $tnserror\n";
  }
  else 
  { 
    $tnsstat = $lsnrstat; 
    print "$S$P TNSPING: $tnsstat\n";
  }

  # Remove /tmp/$tmp_tnsnames_dir to resolve a bug with db_links
  system("rm -fr /tmp/$tmp_tnsnames_dir 2>&1");

  if ($numlsnr >= 1)
  {
    return 0;
  }
  else
  {
    return 1;
  }
}

# ----------------------------------------------------------------------
sub userPassword
# ----------------------------------------------------------------------
{
  &msg("userPassword() - Checking for users with bad passwords"); 
  $runmon = $arg4;   # is this instance backup-only monitoring?
  
  if ($thisos ne "Linux")
  {
    # Isolate pw lines
    chop($newsyspw = `cat $progdir/dbamon_ora.key1 | crypt dbamon`);
  }
  ##print "newsyspw=$newsyspw\n";

  #---- Look for illegal role grants
  &msg("Looking for non-SYS users granted the DBA role");
  $sqlstmt = 'select  \'X\', grantee from dba_role_privs where granted_role = \'DBA\' and 
    grantee not in (\'SYS\',\'SYSTEM\',\'CTXSYS\',\'WKSYS\',\'SYSMAN\',\'CSMIG\',\'SNAPADM\');';
  &oraSQL($sqlstmt);
  $grantdba = 0;
  foreach (@oraSQLout)
  {
    ##print;
    print if /^ORA/;
    @words = split;
    $verb    = $words[0];
    if ($verb eq "X")
    {
      $grantee = $words[1];
      print "$P DBAROLE: $grantee\n";
      $grantdba++
    }
  }
  &msg("There are $grantdba grants of the DBA role");

  #---- Look for illegal role grants
  &msg("Looking for non-SYS users granted the IMP_FULL_DATABASE role");
  $sqlstmt = 'select  \'X\', grantee from dba_role_privs where granted_role like \'%IMP_FULL_DATABASE%\' 
    and grantee not in (\'SYS\',\'DBA\',\'SYSTEM\',\'DATAPUMP_IMP_FULL_DATABASE\',\'WKSYS\',\'SYSMAN\',\'CSMIG\');';
  &oraSQL($sqlstmt);
  $grantimp = 0;
  foreach (@oraSQLout)
  {
    ##print;
    print if /^ORA/;
    @words = split;
    $verb    = $words[0];
    if ($verb eq "X")
    {
      $grantee = $words[1];
      print "$P IMPROLE: $grantee\n";
      $grantimp++
    }
  }
  &msg("There are $grantimp grants of the IMP_FULL_DATABASE role");

  #---- Look for illegal sys priv grants
  &msg("Looking for non-SYS users granted the ALTER USER sys priv");
  $sqlstmt = 'select  \'X\', grantee from dba_sys_privs where privilege = \'ALTER USER\' 
    and grantee not in (\'DBA\',\'SYS\',\'SYSTEM\',\'CTXSYS\',\'SYSMAN\',\'WKSYS\',\'DATAPUMP_IMP_FULL_DATABASE\',\'IMP_FULL_DATABASE\',\'MDSYS\');';
  &oraSQL($sqlstmt);
  $grant_au = 0;
  foreach (@oraSQLout)
  {
    ##print;
    print if /^ORA/;
    @words = split;
    $verb    = $words[0];
    if ($verb eq "X")
    {
      $grantee = $words[1];
      print "$P AU_PRIV: $grantee\n";
      $grant_au++
    }
  }
  &msg("There are $grant_au grants of the ALTER USER sys priv");


  #---- See if the DEFAULT profile has failed_login_attempts set - if true, then return
  chop($z = `$progdir/dbamon_orastat.pl -pr | grep 'FAILED_LOGIN_ATTEMPTS' | grep '^DEFAULT' | awk '{ print \$NF }'`); 
  &msg("DEFAULT profile FAILED_LOGIN_ATTEMPTS: $z"); 
  if ($z > 0)
  {
    &msg("This instance has FAILED_LOGIN_ATTEMPTS set in the DEFAULT profile - skipping USERID=PASSWORD check"); 
    return;
  }

  # one-time agilent test
  if (-e "/opt/oracle/adm/config/.system" && 
     system("grep 'manager' /opt/oracle/adm/config/.system") == 0)
  {
    system("echo $os | mailx -s 'DBAmon | $host/$os - .system Is set to manager [AUTO]' dbaadmin\@dba.it.agilent.com");
  }

  if ($logswitchwait eq "ARCHIVE_LOG")
  {
    &msg("This DB appears to be hung due to no free archivelog destinations - skipping PW check");
    return;
  }

  # See how many users there are
  &msg("Counting rows in DBA_USERS");
  # Collect user exception data
  $sqlstmt = 'select \'X\', count(*) from dba_users;';
  &oraSQL($sqlstmt);
  foreach (@oraSQLout)
  {
    ##print;
    @words = split;
    $verb    = $words[0];
    if ($verb eq "X")
    {
      $usercount = $words[1];
    }
  }
  &msg("There are $usercount rows in DBA_USERS");

  # we don't want to check more than 100 userids each iteration. so
  # if there are > 100 then we want to take a random sample of userids
  if ($usercount > 100)
  {
    &msg("Since there are > 100 users, we will do RANDOM checking"); 
    $rand = int($usercount / 100);
    # add a random number between 1 and 5
    $z = int(rand 5);
    $rand += $z;
    &msg("rand=$rand z=$z"); 
  }
  else
  {
    $rand = 0;
  }

  &msg("Checking for non-system users with obvious passwords");
  # Collect user exception data
  $sqlstmt = '
    select
      \'USER_LIST\',
      us.username
    from
      dba_users us
    where
      us.username not in
	(\'SYS\',\'SYSTEM\',\'OUTLN\',\'DBSNMP\',\'RMAN\',\'CSMIG\')
    order by
      2
      ;
  ';

  &oraSQL($sqlstmt);
  $usersql = "";
  $userstocheck = 0;
  $thisuser = 0;
  foreach (@oraSQLout)
  {
    ##print;
    push(@oraout,$_);
    @words = split;
    $verb    = $words[0];
    
    if (
        $verb eq "USER_LIST" 
       )
    {
      $thisuser++;
    
      if ($rand > 0)  # if we are just sampling ...
      {
        if ( ($thisuser / $rand) != int($thisuser / $rand) )
        {
          next;
        } 
      }
      ##print "thisuser=$thisuser rand=$rand\n";

      $user   = $words[1];

      $usersql .= "disconnect ;\n";
      $usersql .= "connect $user/$user ;\n";
      $usersql .= "select 'X', user from dual ;\n";

      $userstocheck++;
    }
  }

  ##print "usersql=$usersql\n";
  &msg("Begining user connection test for $userstocheck userids");

  $s_time = time;

  $save_os_conn = $os_conn;
  $os_conn = "";
  &oraSQL($usersql);

  foreach (@oraSQLout)
  {
    ##print;
    push(@oraout,$_);
    @words = split;
    $verb    = $words[0];
    
    if ( $verb eq "X" )
    {
      $user = $words[1];
      print "$P USER=PW: $user\n";
    }
  } 

  $os_conn = $save_os_conn;

  $elapsed = time - $s_time;
  &msg("previous check took $elapsed seconds");
  if ($elapsed > 300)
  {
    system("echo $os | mailx -s 'DBAmon | $host/$os - Non-sys pw check took $elapsed seconds t=300 [AUTO]' dbaadmin\@dba.it.agilent.com") if $company eq "agilent";
  }

  &msg("Checking for system users with obvious passwords");
  $usersql = "";

  $usersql .= "disconnect ;\n";
  $usersql .= "connect system/manager ;\n";
  $usersql .= "select 'X', user from dual ;\n";

  $usersql .= "disconnect ;\n";
  $usersql .= "connect system/system ;\n";
  $usersql .= "select 'X', user from dual ;\n";

  $usersql .= "disconnect ;\n";
  $usersql .= "connect sys/changeoninstall ;\n";
  $usersql .= "select 'X', user from dual ;\n";

  $usersql .= "disconnect ;\n";
  $usersql .= "connect sys/sys ;\n";
  $usersql .= "select 'X', user from dual ;\n";

  $usersql .= "disconnect ;\n";
  $usersql .= "connect outln/outln ;\n";
  $usersql .= "select 'X', user from dual ;\n";

  $usersql .= "disconnect ;\n";
  $usersql .= "connect csmig/csmig ;\n";
  $usersql .= "select 'X', user from dual ;\n";

  $usersql .= "disconnect ;\n";
  $usersql .= "connect dbsnmp/dbsnmp ;\n";
  $usersql .= "select 'X', user from dual ;\n";

  ##print "usersql=$usersql\n";

  $save_os_conn = $os_conn;
  $os_conn = "";
  &oraSQL($usersql);

  foreach (@oraSQLout)
  {
    ##print;
    push(@oraout,$_);
    @words = split;
    $verb    = $words[0];
    
    if ( $verb eq "X" )
    {
      $user = $words[1];

      if ($newsyspw ne "" && $runmon ne "B")
      {
	# Change pw
        &msg("Changing password for user=$user to cfg value");

        #---- New way
	system("$os_scmd <<! 2>&1
	  $os_conn
	  alter user $user identified by $newsyspw;
	!");

        #---- Old way
	#&oraSQL("alter user $user identified by $newsyspw;");
	#foreach (@oraSQLout)
	#{
	#  print;
	#}

        print "$P USER=PW-CHANGED: $user\n";
      }
      else
      {
        print "$P USER=PW-SYS: $user\n";
      }

    }
  } 
  $os_conn = $save_os_conn;

}

# ----------------------------------------------------------------------
sub perf
# ----------------------------------------------------------------------
{
  &msg("Running SQL to collect perf data");

  $sqlstmt = '
  alter session set NLS_NUMERIC_CHARACTERS = \'.,\';
  select
    \'F\', count(*) from v\$bh where status = \'free\';
  select
    \'P\',
    name,
    100* (1-(physical_reads / (DB_BLOCK_GETS + CONSISTENT_GETS)))
    from
      v\$buffer_pool_statistics;
  select
    \'V\', 
    round((sum(gethits) / sum(gets) * 100),2),
    sum(gets)
     from v\$librarycache;
  select 
    \'U\', 
    round((sum(gets) - sum(getmisses)) / sum(gets) * 100,2),
    sum(gets)
     from v\$rowcache;
  select 
      \'A\', 
      property_name,
      property_value
    from 
      database_properties 
    where 
      property_name like \'DEFAULT%TABLESPACE\';
  select
    \'G\', count(*) from dba_tables 
      where 
        owner = \'SYS\' 
        and last_analyzed is not null 
        and table_name not in (\'DUAL\',\'PLAN_TABLE\',\'AUD\$\',\'SYS_TZUV2_AFFECTED_REGIONS\');
  select
    \'R\', bytes from v\$sgastat where name = \'free memory\' and pool = \'shared pool\';
  select
    \'E\', nvl(pool,\'?\'), name, bytes from v\$sgastat;
  select
    \'S\', value from v\$parameter where name = \'shared_pool_size\';
  select
    \'T\', value from v\$parameter where name = \'db_block_buffers\';
  select
    \'J\', value from v\$parameter where name = \'db_block_size\';
  select
    \'L\', sum(totalq) from v\$queue;
  select
    \'M\', value from v\$parameter where name = \'undo_management\';
  select
    \'N\', force_logging from v\$database;
  select
    \'Q\', value from v\$parameter where name = \'db_cache_size\';
  select
    \'H\', max(granule_size) from v\$sga_dynamic_components; 
  select
    \'K\', value from v\$parameter where name = \'spfile\';
  select
    \'X\', value from v\$parameter where name = \'sql_trace\';
  select 
    \'W\',
       sum(decode(name, \'consistent gets\', value, 0)) consistent,
       sum(decode(name, \'db block gets\',   value, 0)) db_blockgets,
       sum(decode(name, \'physical reads\',  value, 0)) physical,
       round(((sum(decode(name, \'consistent gets\', value, 0)) +
               sum(decode(name, \'db block gets\',   value, 0)) -
               sum(decode(name, \'physical reads\',  value, 0))) /
              (sum(decode(name, \'consistent gets\', value, 0)) +
               sum(decode(name, \'db block gets\',   value, 0)))) * 100, 2)
    hitratio from v\$sysstat;
  select
    \'Z\',
    100* (1-(sum(physical_reads) / (sum(DB_BLOCK_GETS) + sum(CONSISTENT_GETS))))
  from
    v\$buffer_pool_statistics
  where
    (db_block_gets + consistent_gets) > 0
    and name != \'RECYCLE\';
  show sga
  ';

  $sqlgood = 0;
  $free_buffers = -1;
  
  &oraSQL($sqlstmt);
  foreach (@oraSQLout)
  {
    ##print;
    push(@oraout,$_);
    @words = split;
    $verb    = $words[0];

    if ($_ = /Total System Global/)
    {
      $shmsize = int($words[4] / (1024*1024));
    }
    
    if ($verb eq "F")
    {
      print "F $words[1]\n";
      $free_buffers = $words[1];
    }

    if ($verb eq "R")
    {
      ##print "R $words[1]\n";
      $sg_free = $words[1];
    }

    if ($verb eq "S")
    {
      ##print "S $words[1]\n";
      $sg_size = $words[1];
      if ($sg_size =~ /M$/)
      {
        chop($sg_size);
        $sg_size *= 2**20;
      }
    }

    if ($verb eq "A")
    {
      if ($words[1] eq "DEFAULT_TEMP_TABLESPACE")
      {
        $df_temp_ts = $words[2]; 
      }
      if ($words[1] eq "DEFAULT_PERMANENT_TABLESPACE")
      {
        $df_perm_ts = $words[2]; 
      }
    }

    if ($verb eq "K") { $spfile = $words[1]; }
    if ($verb eq "T") { $db_block_buffers = $words[1]; }
    if ($verb eq "J") { $db_block_size = $words[1]; }
    if ($verb eq "Q") { $db_cache_size = $words[1]; }
    if ($verb eq "X") { $sql_trace = $words[1]; }

    if ($verb eq "G") { $sys_analyzed = $words[1]; }

    if ($verb eq "L") { $mts_queue = $words[1]; }
    if ($verb eq "M") { $undo_mgmt = $words[1]; }
    if ($verb eq "N") { $force_logging = $words[1]; }

    if ($verb eq "H") { $granule_size = $words[1]; }

    if ($verb eq "E" && $words[2] eq "buffer_cache" ||  
        $verb eq "E" && $words[2] eq "db_block_buffers")
    {
      $buffer_cache_size = int($words[3] / (1024*1024));
    }
 
    if ($verb eq "P")
    {
      $pool_keep_hitratio    = $words[2] if $words[1] eq "KEEP";
      $pool_recycle_hitratio = $words[2] if $words[1] eq "RECYCLE";
      $pool_default_hitratio = $words[2] if $words[1] eq "DEFAULT";
    }

    if ($verb eq "W") 
    { 
      $bufcongets   = $words[1];
      $bufblkgets   = $words[2];
      $bufphysreads = $words[3];
      $bufhitratio  = $words[4];
    }

    if ($verb eq "Z") 
    { 
      $bufhitratio_xr   = $words[1];
    }

    if ($verb eq "V") 
    { 
      $libcachehitratio = $words[1];
      $libcachegets     = $words[2];
    }

    if ($verb eq "U") 
    { 
      $dictcachehitratio = $words[1];
      $dictcachegets     = $words[2];
    }
  }
  close(INDB);

  #Edits
  $pool_default_hitratio = sprintf("%.2f", $pool_default_hitratio) if $pool_default_hitratio ne "";
  $pool_recycle_hitratio = sprintf("%.2f", $pool_recycle_hitratio) if $pool_recycle_hitratio ne "";
  $pool_keep_hitratio    = sprintf("%.2f", $pool_keep_hitratio)    if $pool_keep_hitratio ne "";

  if ($sg_size > 0)
  {
    $sg_pct = 100 - (($sg_free / $sg_size) * 100);
  }
  else
  {
    $sg_pct = ".";
  }

  chop($num_otrace = `ls -l \$ORACLE_HOME/otrace/admin/*.dat 2>/dev/null | wc -l`); 

  print "$P SGA:              $sg_pct $sg_size $sg_free \n";
  print "$P POOL_DEFAULT_HR:  $pool_default_hitratio\n"; 
  print "$P BUFFER_CACHE_SIZE: $buffer_cache_size\n"; 
  print "$P POOL_RECYCLE_HR:  $pool_recycle_hitratio\n"; 
  print "$P POOL_KEEP_HR:     $pool_keep_hitratio\n"; 
  print "$P BUFBLKGETS:       $bufblkgets\n"; 
  print "$P BUFCONGETS:       $bufcongets\n"; 
  print "$P BUFPHYSREADS:     $bufphysreads\n"; 
  print "$P BUFHITRATIO:      $bufhitratio\n"; 
  print "$P BUFHITRATIO_XR:   $bufhitratio_xr\n"; 
  print "$P LIBHITRATIO:      $libcachehitratio\n"; 
  print "$P LIBGETS:          $libcachegets\n"; 
  print "$P DICTHITRATIO:     $dictcachehitratio\n"; 
  print "$P DICTGETS:         $dictcachegets\n"; 
  print "$P DB_BLOCK_BUFFERS: $db_block_buffers\n"; 
  print "$P DB_BLOCK_SIZE:    $db_block_size\n"; 
  print "$P DB_CACHE_SIZE:    $db_cache_size\n"; 
  print "$P GRANULE_SIZE:     $granule_size\n"; 
  print "$P NUM_OTRACE:       $num_otrace\n"; 
  print "$P SQL_TRACE:        $sql_trace\n"; 
  print "$P FREE_BUFFERS:     $free_buffers\n"; 
  print "$P SPFILE:           $spfile\n"; 
  print "$P MTS_QUEUE:        $mts_queue\n"; 
  print "$P UNDO_MGMT:        $undo_mgmt\n"; 
  print "$P FORCE_LOGGING:    $force_logging\n"; 
  print "$P SYS_ANALYZED:     $sys_analyzed\n"; 
  print "$P SHMSIZE:          $shmsize\n"; 
  print "$P DF_TEMP_TS:       $df_temp_ts\n"; 
  print "$P DF_PERM_TS:       $df_perm_ts\n"; 

  # Find the names of suitable USER* and TEMP* tablespaces
  &msg("Looking for suitable USER* and TEMP* tablespaces");
  $sqlstmt = '
    select
      \'USER_TS\',
      ts.tablespace_name
    from
      dba_tablespaces ts
    where
      ts.tablespace_name like \'USER%\'
    order by
      1 ;

    select
      \'ALT_USER_TS\',
      us.default_tablespace,
      count(*) 
    from
      dba_users us
    where 
      us.default_tablespace != \'SYSTEM\'
    group by
      \'ALT_USER_TS\',
      us.default_tablespace
    order by 3 desc
      ;

    select
      \'ALT_TEMP_TS\',
      us.temporary_tablespace,
      count(*) 
    from
      dba_users us
    where 
      us.temporary_tablespace != \'SYSTEM\'
    group by
      \'ALT_TEMP_TS\',
      us.temporary_tablespace
    order by 3 desc
      ;

    select
      \'TEMP_TS\',
      ts.tablespace_name
    from
      dba_tablespaces ts
    where
      ts.tablespace_name like \'TEMP%\'
      and ts.contents = \'TEMPORARY\'
    order by
      1; ';

  &oraSQL($sqlstmt);
  foreach (@oraSQLout)
  {
    ##print;
    push(@oraout,$_);
    @words = split;
    $verb    = $words[0];
    
    if ($verb eq "TEMP_TS" && $good_temp_ts eq "")
    {
      $good_temp_ts = $words[1];
      print "good_temp_ts=$good_temp_ts\n";
    }
    if ($verb eq "USER_TS" && $good_users_ts eq "")
    {
      $good_users_ts = $words[1];
      print "good_users_ts=$good_users_ts\n";
    }
    if ($verb eq "ALT_USER_TS" && $alt_users_ts eq "")
    {
      $alt_users_ts = $words[1];
      print "alt_users_ts=$alt_users_ts\n";
    }
    if ($verb eq "ALT_TEMP_TS" && $alt_temp_ts eq "")
    {
      $alt_temp_ts = $words[1];
      print "alt_temp_ts=$alt_temp_ts\n";
    }
  }

  if ($good_users_ts eq "") { $good_users_ts = $alt_users_ts; }
  if ($good_temp_ts eq "")  { $good_temp_ts  = $alt_temp_ts; }

  if ($good_temp_ts eq "" || $good_temp_ts eq "")  
  { 
    system("echo ' ' | mailx -s 'DBAmon | perf() temp=$good_temp_ts users=$good_users_ts alt_users_ts=$alt_users_ts alt_temp_ts=$alt_temp_ts dbaadmin\@dba.it.agilent.com") if $company eq "agilent";
  }

  print "$P GOOD_USERS_TS: $good_users_ts\n";
  print "$P GOOD_TEMP_TS:  $good_temp_ts\n";

  # START - TEMP FIX - there are many DB's where there is a RPT user that keeps 
  #  getting set to temp=tools; Try to fix that. 

  &oraSQL("select 'X' from dba_users where username = 'RPT' and TEMPORARY_TABLESPACE = 'TOOLS';");
  &msg("Looking for RPT user with TOOLS as temporary tablespace");
  foreach (@oraSQLout)
  {
    ##print;
    @words = split;
    $verb    = $words[0];
    if ($verb eq "X")
    {
      &msg("Altering RPT to set temporary tablespace to TEMP");
      &oraSQL("alter user RPT temporary tablespace TEMP;");
    }
  }

  # END   - TEMP FIX - there are many DB's where there is a RPT user that keeps 
  #  getting set to temp=tools; Try to fix that. 

  &msg("Done collecting user exception data - temp=$good_temp_ts users=$good_users_ts alt_users_ts=$alt_users_ts alt_temp_ts=$alt_temp_ts");

  #---- User exceptions - Fix 
  &userException("Fix");

  #---- User exceptions - Report 
  &userException("Report");

  #---- Collect ts exception data
  &msg("Running SQL to find tablespaces in exception status");
  $sqlstmt = '

    select
      \'TEMP_PERM\',
      ts.tablespace_name
    from
      dba_tablespaces ts
    where
      tablespace_name = \'TEMP\'
      and ts.contents = \'PERMANENT\'
      ;
  ';

  &oraSQL($sqlstmt);
  foreach (@oraSQLout)
  {
    ##print;
    push(@oraout,$_);
    @words = split;
    $verb    = $words[0];
    
    if (
        $verb eq "TEMP_PERM" 
       )
    {
      $ts   = $words[1];
      print "$P TS_EXCEPTION: $verb: $ts\n";
    }
  }
  &msg("Done collecting tablespace exception data");

  &perfRollback;
  &perfRedo;

  if ($thisos eq "HP-UX")
  {
    #
    # Sample NFILE usage
    #

    open(IN, "sar -v 1 | tail -1 |") || &error("Error running sar -v");
    while(<IN>)
    {
      ##print;
      @words     = split;
      $nfileraw  = $words[7];
      ##print "nfileraw=$nfileraw\n";
      @words2    = split(/\//,$nfileraw);
      $current   = $words2[0];
      $max       = $words2[1];
      if ($max > 0)
      {
        $pct       = ($current/$max*100);
      }
      else
      {
        $pct       = "?";
      }
     
    }
    close(IN); 
    printf("$P NFILE: %4d %4d %4d\n",$current,$max,$pct);
  }

  #---- Sample OS user processes
  if ($thisos eq "HP-UX")
  {
    &msg("Measuring maxuprc versus current ($userid) processes");
    $os_user_processes = -1;
    $maxuprc           = -1;
    $pct               = -1;
    chop($os_user_processes = `ps -ef | grep '${userid} ' | wc -l`); 
    chop($maxuprc = `kmtune 2>/dev/null | grep '^maxuprc' | awk '{ print \$2 }'`); 
    $pct  = sprintf("%.2f", ($os_user_processes / $maxuprc) * 100) if $maxuprc > 0;
    print "$P NUSERPROC: $os_user_processes $maxuprc $pct\n";
  }

  &msg("Done collecting perf data");
}

# ----------------------------------------------------------------------
sub userException
# ----------------------------------------------------------------------
{
  my $mode = $_[0];
  &msg("userException() - mode=$mode");

  # Collect user exception data
  &msg("Running SQL to find users in exception status");
  $sqlstmt = '
    select
      \'DFLT_SYS\',
      us.username,
      us.default_tablespace,
      us.temporary_tablespace
    from
      dba_users us
    where
      default_tablespace = \'SYSTEM\'
      and us.username not in
	(\'SYS\',\'SYSTEM\',\'OUTLN\',\'DBSNMP\',\'DBAMON\',\'CSMIG\')
      and us.username not like \'%\$%\';
      ;

    select
      \'TEMP_SYS\',
      us.username,
      us.default_tablespace,
      us.temporary_tablespace
    from
      dba_users us
    where
      temporary_tablespace  = \'SYSTEM\'
      and us.username not in
	(\'SYS\',\'SYSTEM\',\'OUTLN\',\'DBSNMP\',\'DBAMON\',\'CSMIG\')
      and us.username not like \'%\$%\';
      ;

    select
      \'TEMP_PERM\',
      us.username,
      us.default_tablespace,
      us.temporary_tablespace
    from
      dba_users us,
      dba_tablespaces ts
    where
      us.temporary_tablespace = ts.tablespace_name
      and ts.contents = \'PERMANENT\'
      and us.default_tablespace != \'SYSTEM\'
      and us.username not in
	(\'SYS\',\'SYSTEM\',\'OUTLN\',\'DBSNMP\',\'DBAMON\',\'CSMIG\')
      and us.username not like \'%\$%\';
      ;
  ';

  my $sql = "";
  my $count = 0;

  &oraSQL($sqlstmt);
  foreach (@oraSQLout)
  {
    ##print;
    push(@oraout,$_);
    @words = split;
    $verb    = $words[0];
    
    if (
        $verb eq "DFLT_SYS" ||
        $verb eq "TEMP_SYS" ||
        $verb eq "TEMP_PERM" 
       )
    {
      $user   = $words[1];
      $dfltts = $words[2];
      $tmpts  = $words[3];

      $count++;

      if ($mode eq "Report") 
      {
        print "$P USER_EXCEPTION: $verb: $user $dfltts $tmpts\n";
      }
      else  #---- mode=Fix
      {
        &msg("Found user=user dfltts=$dfltts tmpts=$tmpts"); 

        if ($verb eq "DFLT_SYS" && $good_users_ts)
        {
	  $sql .= "ALTER USER $user DEFAULT TABLESPACE $good_users_ts;\n";
        }
        if ($verb eq "TEMP_SYS" && $good_temp_ts)
        {
	  $sql .= "ALTER USER $user TEMPORARY TABLESPACE $good_temp_ts;\n";
        }
        if ($verb eq "TEMP_PERM" && $good_temp_ts)
        {
	  $sql .= "ALTER USER $user TEMPORARY TABLESPACE $good_temp_ts;\n";
        }
      }
    }
  }

  if ($sql)
  {
    &msg("Running sql=\n$sql"); 
    system("$os_scmd <<! 
	  $os_conn
	  $sql
	!");
  }

  &msg("Done collecting user exception data - count=$count mode=$mode");
}

# ----------------------------------------------------------------------
sub perfRedo
# ----------------------------------------------------------------------
{
  &msg("perfRedo - Starting");

  my $oneday_count = -1; 
  my $oneday_rate = -1; 
  my $thirtyday_avg_gb = -1; 
  my $thirtyday_max_gb = -1; 
  my $archv_fs_gb = -1; 
  my $archv_size_ratio = -1; 
  my $archv_fs = "?"; 
  my $redo_size = -1; 

  #---- Querying redo log size
  &msg("  Querying redo log size"); 
  $sqlstmt = 'select \'X\', avg(bytes) from v\$log;';
  &oraSQL($sqlstmt);
  foreach (@oraSQLout)
  {
    @words       = split();
    $verb        = $words[0];
    if ($verb eq "X")
    {
      $redo_size = sprintf("%.2f",($words[1] / (1024*1024)));
      last;
    }
  }

  #---- Collect 1 day stats
  &msg("  Collecting 1 day archivelog stats"); 
  foreach (`$progdir/dbamon_orastat.pl -av 1 H 2>&1`)
  {
    if (/Total/)
    {
      $oneday_count  = (split())[2];
    }
  }

  #---- Collect 30 day stats
  &msg("  Collecting 30 days archivelog stats"); 
  foreach (`$progdir/dbamon_orastat.pl -av 30 D 2>&1`)
  {
    if (/Max/)
    {
      $thirtyday_max_gb  = sprintf("%.2f",((split())[1] / 1024));
    }
    if (/\(Average\)/)
    {
      $thirtyday_avg_gb  = sprintf("%.2f",((split())[1] / 1024)); 
    }
  }

  #---- Query archv filesystem name 
  &msg("  Querying archivelog FS name"); 
  foreach (`$progdir/dbamon_orastat.pl -l 2>&1`)
  {
    if (/Archive Dest FS:/)
    {
      $archv_fs = (split())[6];
    }
  }
  &msg("  Archivelog FS: $archv_fs"); 

  if ($archv_fs =~ /^\//)
  {
    #---- Query archv filesystem size 
    &msg("  Querying archivelog FS size"); 
    foreach (`$bdfcmd $archv_fs | grep -vi 'Filesystem' | tail -1`)
    {
      if (/^\//)
      {
        ##print; 
        $archv_fs_gb = sprintf("%.2f",((split())[1] / (1024*1024))); 
      }
      else
      {
        ##print; 
        $archv_fs_gb = sprintf("%.2f",((split())[0] / (1024*1024))); 
      }
    }
  }

  $oneday_rate      = sprintf("%.2f",$oneday_count / 24) if $oneday_count > 0;
  $archv_size_ratio = sprintf("%.2f",$thirtyday_max_gb / $archv_fs_gb) if $archv_fs_gb > 0;

  print "$P Redo_1Day_Count:   $oneday_count\n";
  print "$P Redo_1Day_PerHour: $oneday_rate\n";
  print "$P Redo_30Day_Avg_GB: $thirtyday_avg_gb\n";
  print "$P Redo_30Day_Max_GB: $thirtyday_max_gb\n";
  print "$P Redo_Archv_FS_GB:  $archv_fs_gb\n";
  print "$P Redo_Archv_FS:     $archv_fs\n";
  print "$P Redo_Archv_Ratio:  $archv_size_ratio\n";
  print "$P Redo_Log_Size:     $redo_size\n";

  &msg("perfRedo - Done");
}

# ----------------------------------------------------------------------
sub perfRollback
# ----------------------------------------------------------------------
{
  &msg("Checking rollback segments");
  #
  # Check for rollback segment header waits
  #

  $sqlstmt = 'select \'X\', 
    rn.NAME,
    rs.EXTENTS,
    rs.EXTENDS,
    rs.RSSIZE,
    rs.XACTS,
    rs.GETS,
    rs.HWMSIZE,
    rs.WRAPS,
    rs.AVEACTIVE,
    rs.STATUS,
    rs.WAITS,
    rs.optsize
  from 
    v\$rollstat rs, 
    v\$rollname rn 
  where 
    rn.usn=rs.usn;';

  print "Name          Extents  Extends         RSSize   A Xn's      Gets         HWMSize  Wraps   Avg Actv  Status   Waits Optimal\n";
  print "------------ -------- -------- -------------- -------- ---------- -------------- ------  --------- -------- ------ -------\n";

  &oraSQL($sqlstmt);
  foreach (@oraSQLout)
  {
    ##print;
    @words     = split();
    $verb      = $words[0];
    $name      = $words[1];
    $extents   = $words[2];
    $extends   = $words[3];
    $rssize    = $words[4];
    $xacts     = $words[5];
    $num_gets  = $words[6];
    $hwmsize   = $words[7];
    $wraps     = $words[8];
    $aveactive = $words[9];
    $status    = $words[10];
    $waits     = $words[11];
    $optimal   = $words[12];
    if ($verb eq "X")
    {
      printf "%-12s %8d %8d %14d %8d %10d %14d %6s %10d %-8s %6d %-8s\n",
        $name,$extents,$extends,$rssize,$xacts,$num_gets,$hwmsize,$wraps,$aveactive,$status,$waits,$optimal;
      $t_waits += $waits;
      $t_gets  += $num_gets;
    }
  }

  $waits_gets_r = 100 * ($t_waits/$t_gets) if $t_gets > 0;
  $waits_gets_r = sprintf("%8.5f",$waits_gets_r);

  print "$P Rollback_Total_Waits:   $t_waits\n";
  print "$P Rollback_Total_Gets:    $t_gets\n";
  print "$P Rollback_Waits_To_Gets: $waits_gets_r%\n";

  if ($waits_gets_r > 1)
  {
    &msg("Because the ratio is > 1, add more rollback segments");
  }
}

# ----------------------------------------------------------------------
sub up
# ----------------------------------------------------------------------
{
  &msg("up() - Checking for Oracle Up");

  if ($ENV{'WWW'} && $os =~ /ASM/)
  {
    &msg("================= Test Begin ======================"); 
    &alertlog;
    &msg("================== Test End ======================="); 
  }

  # bb 10Jan00 - The Roseville dbshut and dbstart scripts create an 
  #  entry in an "inhibit" file when the DB is intentionally down
  #  for backups. Check that file. If the oracle_sid is present, don't
  #  bother to monitor and mark it inhibited.

  #---- test
  ##system("ps -ef | grep 'ora_pmon_$os\$' | grep -v 'grep' | wc -l"); 

  chop($numpmon     = `ps -ef | grep 'ora_pmon_$os\$' | grep -v 'grep' | wc -l`); 
  chop($numpmon_asm = `ps -ef | grep 'asm_pmon_$os\$' | grep -v 'grep' | wc -l`); 
  if ($numpmon eq "0" && $numpmon_asm eq "0") 
  {
    print "$P | PMON for ORACLE_SID $os is not active \n";
  } 

  # create var of init.ora background_dump_dest
  &msg("Reading init.ora file $oh/dbs/init$os.ora");
  open(RO,"$oh/dbs/init$os.ora") || &error("Cannot OPEN init.ora file=$oh/dbs/init$os.ora");
  &msg("DEBUG - After open of init.ora - numpmon=$numpmon numpmon_asm=$numpmon_asm") if $debug_up; 
  while (<RO>)
  {
    if (!$debug_msgflag)
    {
      &msg("DEBUG - In while") if $debug_up; 
      $debug_msgflag = 1;
    }
  
    $initora .= $_;
    @words = split(/=/);
    if (substr($words[0],0,5) eq "ifile")
    {
      &msg("DEBUG - ifile start") if $debug_up; 

      $ifile = $words[$#words];
      $initora .= "#**** Contents of ifile: $ifile *****\n";

      #---- if the 1st char of ifile is ?, then xlate it to oracle_home
      if ($ifile =~ /\?/)
      {
	$ifile =~ s/\?/$oh/;
        chop($z = $ifile);
	&msg("ifile Promoted from ?... to $z");
      }

      &msg("Opening ifile=$ifile") if $debug_up; 
      open(RO2,"$ifile") || &error("Cannot OPEN init.ora file=$ifile");
      while (<RO2>)
      {
        $initora .= $_;
      }
      close(RO2) || &error("Cannot close r02");
      $initora .= "#**** End of ifile: $ifile *****\n";

      &msg("DEBUG - ifile end") if $debug_up; 
    }
  }
  close(RO);
  &msg("DEBUG - After while RO") if $debug_up; 

  # Check for pmon process
  if ($numpmon eq "0" && $numpmon_asm eq "0")
  {
    print "$P | PMON is not active - checking to see how Oracle come down \n";

    # find background_dump_dest
    @lines = split(/\n/,$initora);
    foreach (@lines) 
    {
      if (/^background_dump_dest/)
      {
	$z1 = index($_,"=");
	$z2 = substr($_,$z1 + 1); 
	$bdumpdir1 = (split(/ /,$z2)) [0];
	$bdumpdir2 = (split(/ /,$z2)) [1];
	$bdumpdir = $bdumpdir1 if $bdumpdir1 ne "";
	$bdumpdir = $bdumpdir2 if $bdumpdir2 ne "";
	print "$P | background_dump_dest=$bdumpdir \n";
        $alertlog = "${bdumpdir}/alert_$os.log";
        print "$P | alertlog=$alertlog \n";
        $last2 = `tail -2 $alertlog`;
        if (index($last2,"terminating instance due to error") > -1)
        {
          $ora_crashed = 1;

          @lastlines = split(/\n/,$last2);
          $errorcode = (split(/ /,$lastlines[0])) [6];
          $errortext = `oerr ora $errorcode`;
          
          print "$P | -----------------------------------------------------------------\n";
          print "$P | Oracle crashed - Error: ORA-$errorcode - Explanation: \n";
          print "$errortext \n";

          print "$P | Diagnostic Data: \n";
          print $last2;

          if ($arg1 ne "N" && $errortext =~ /Warm start instance/)
          {
            print "\n$P | Since Must_Be_Up:=Y and Explanation (above) recommends 'Warm start instance', Initiating Auto Restart\n";

            system("$os_scmd <<! 
              $os_conn
	      startup;
	    !");

            $autorestart = "(Auto_Restart Was Attempted)";
            $autorestarted = 1;
          }
          else
          {
            print "$P | Since 'Warm start instance' was not found in the oerr output -OR- DBC Must_Be_Up:=N, Not Initiating Auto Restart\n";
            $autorestart = "(Auto_Restart Not attempted because DBC Must_Be_Up:=N)";
          }
          print "$P | -----------------------------------------------------------------\n";
        }
        else
        {
          print "$P | It appears that Oracle was brought down intentionally - Diagnostic Data: \n";
          print $last2;
        }
      }
    }
  }

  &msg("DEBUG - After WHILE") if $debug_up; 
  
  #if ($company eq "hp" || $company eq "agilent")
  #{
  #  ## the ora_dbshut script put in the sid followed by comments - hmmmmm
  #  $rc = system("grep '^$os' /opt/oracle/adm/config/ora_chk_instance.excl");
  #  if ($rc == 0) 
  #  { 
  #    print "$P INHIBITED: by ora_dbshut\n"; 
  #    return 2;
  #  }
  #}

  # Try to run an SQL statement
  &msg("Running SQL against v\$instance to see if DB is up");
  $sqlstmt = '
    select 
      \'X\', 
      status 
    from 
      v\$instance;
    select 
      \'Y\', 
      controlfile_type 
    from 
      v\$database;
  ';

  $db_status_nocolumn = 0;
  $dbgoodflag         = 0;
  $oradebug           = ""; 

  &oraSQL($sqlstmt);
  foreach (@oraSQLout)
  {
    print if /^ORA/;
    @words = split;
    $verb  = $words[0];
    if ($verb eq "X")
    {
      $db_status = $words[1];
      $dbgoodflag = 1; 
    }
    if ($verb eq "Y")
    {
      $cf_type = $words[1];
    }
    if ($verb =~ /ORA-00904/)
    {
      $db_status_nocolumn = 1;
    }
    $oradebug .= $_; 
  }

  #---- 1.45 BB - New debugging code to solve mysterious connection lost problems
  if (! $dbgoodflag)
  {
    &msg("Something went wrong - dbgoodflag=$dbgoodflag - Oracle output:"); 
    print $oradebug; 
  }

  print "$P DBSTATUS: $db_status\n";
  print "$P CFTYPE:   $cf_type\n";

  if ($db_status_nocolumn == 1)
  {
    &msg("This version of Oracle does not have a v\$instance/STATUS column");
  }
  elsif ($os =~ /^\+ASM/ && $db_status eq "STARTED")
  {
    &msg("DB Status of STARTED is OK for +ASM instance");
  }
  elsif ($db_status ne "OPEN")
  {
    &msg("Because the DB is not OPEN, exiting");
    &msg("END_OF_PROBE");
    exit 0;
  }

  #---- Testing
  if ($ENV{'WWW'} && $os =~ /ASM/)
  {
    &msg("================= Test Begin ======================"); 
    &ASMSpace;
    &msg("================== Test End ======================="); 
  }
  if ($ENV{'WWW'} && $os =~ /TSTRAC/)
  {
    &msg("================= Test Begin ======================"); 
    #$arg1 = 10; 
    #$arg2 = 20; 
    #$arg3 = "thecmd"; 
    #&arclogs; 
    &perf; 
    &msg("================== Test End ======================="); 
  }

  $numusersnd = 0; 

  # Try to run an SQL statement
  &msg("Running SQL to see if DB is up");
  $sqlstmt = 'select
    \'THIS\', banner from v\$version;
  select
    \'Y\', 
    controlfile_type, 
    dbid, 
    name 
    from v\$database;
  select 
    count(*) from dba_doesnt_exist;
  select
    \'THAT\', 
    parallel, 
    logins, 
    to_char(startup_time,\'YYYY/MM/DD-HH24:MI:SS\') startup_time,
    sysdate - startup_time
    from v\$instance;
  select
    \'Z\', inst_number, inst_name from v\$active_instances;
  select
    \'X\', SESSIONS_HIGHWATER from v\$license;
  select
    \'Q\', count(*) from DBAMON.TIMESTAMP;
  select
    \'J\', count(*) from v\$controlfile;
  select
    \'DB-ASM\', count(*) from v\$datafile where name like \'+%\';
  select
    \'US-US\', count(*) from dba_users;
  select
    \'US-PR\', count(distinct profile) from dba_profiles where profile not in (\'DEFAULT\',\'PROFILE_EXEMPTED\',\'PROFILE_NON_EXPIRED\',\'MONITORING_PROFILE\');
  select
    \'US-ND\', count(*) from dba_users where profile not in (\'DEFAULT\',\'MONITORING_PROFILE\',\'PROFILE_NON_EXPIRED\');
  select
    \'DB-PW\', limit from dba_profiles where profile = \'DEFAULT\' and resource_name = \'PASSWORD_VERIFY_FUNCTION\';
  SELECT
    \'RG\',
    version,
    status,
    comp_name
    FROM dba_registry
    where version is not null
    order by
      1, 3;
  ';

  $sqlgood = 0;

  &oraSQL($sqlstmt);

  foreach (@oraSQLout)
  {
    ##print;
    push(@oraout,$_);
    @words = split;
    $verb    = $words[0];
    # Check for message which indicates the need for Oracle patch
    if ($verb eq "ORA-00020:") 
    { 
      print "$P | ***************************************************\n";
      print "$P | Oracle Max Processes Exceeded \n";
      print "$P | ***************************************************\n";
      print "$P MAXPROCESSES: $words[5] \n";
      $sqlgood = 0; 
    }
    if ($verb eq "ORA-01219:") 
    { 
      print "$P | ***************************************************\n";
      print "$P | Oracle DB is Not OPEN\n";
      print "$P | ***************************************************\n";
      $sqlgood = 0; 
    }
    if ($verb eq "SVRMGR>" && $words[1] eq "MGR-11401:") 
    { 
      print "$P | ***************************************************\n";
      print "$P | Oracle 'input error, unable to read input line'\n";
      print "$P | error encountered while executing sql. This \n";
      print "$P | error indicates the need to apply the patch for \n";
      print "$P | bug 622943 to this Oracle version (7.3.4). See: \n";
      print "$P | http://dba.it.agilent.com/dba/processes/oracle/patches.html \n";
      print "$P | ***************************************************\n";
      $sqlgood = 0; 
      $oraver  = $words[3] if $words[3] ne "error,";
    }

    if ($verb eq "RG")
    {
      shift @words;
      $rg_component = "";
      $rg_version   = shift @words;
      $rg_status    = shift @words;
      foreach (@words)
      {
        $rg_component .= "$_ ";
      }

      $i = 0;
      $rg_version4 = ""; 
      foreach (split(/\./,$rg_version))
      {
	$rg_version4 .= $_ . ".";
	last if ++$i > 3;
      }
      chop $rg_version4;
      $rg_version = $rg_version4;

      ##&msg("DEBUG oraver=$oraver oraver4levels=$oraver4levels rg_version=$rg_version");

      #---- Exclude some packages
      next if $rg_component =~ /Oracle Workspace Manager/;    #---- Not patched with normal patch bundles

      if ($oraver4levels && $rg_version && $rg_version lt $oraver4levels)
      {
	if ($parallel eq "YES" && $instnum > 1)
	{
	  &msg("Since this RAC/OPS instance number is > $instnum, not performing Registry check");
	}
        else
        {
          $registry_events .= "$P REGISTRY_COMPONENT_OLD: |$rg_version|$rg_status|$rg_component|\n";
        }
      }
    }
    
    if ($verb eq "Q")
    {
      $timestamp_rows = $words[1];
    }

    if ($verb eq "US-US")
    {
      $numusers = $words[1];
    }
    if ($verb eq "US-PR")
    {
      $numprofs = $words[1];
    }
    if ($verb eq "US-ND")
    {
      $numusersnd = $words[1];
    }
    if ($verb eq "DB-ASM")
    {
      $asm = "YES" if $words[1] > 0;
    }

    if ($verb eq "DB-PW")
    {
      if ($words[1] eq "NULL")
      {
        $complexpw = "OFF";
      }
      elsif ($words[1] =~ /\_/)
      {
        $complexpw = "ON";
      }
      else
      {
        $complexpw = "?-$words[1]";
      }
    }

    if ($verb eq "J")
    {
      $controlfile_rows = $words[1];
    }

    if ($verb eq "Z" && $words[2] eq "$host:$os") 
    { 
      $instnum  = $words[1];
    }
    if ($verb eq "THAT") 
    { 
      $parallel  = $words[1];
      $logins    = $words[2];
      $startts   = $words[3];
      $hoursup   = $words[4] * 24;
      $hoursup   = sprintf("%.2f", $hoursup);
    }
    if ($verb eq "Y") 
    { 
      $standby  = $words[1];
      $dbid     = $words[2];
      $dbname   = $words[3];

      $standby_flag = 1 if $standby eq "STANDBY";
    }
    if ($verb eq "X") 
    { 
      $sessionshwm = $words[1];
    }
    if ($verb eq "THIS" && substr($words[1],0,6) eq "Oracle") 
    { 
      $sqlgood = 1; 
      $oraver  = $words[3];
      if ($oraver eq "Edition") { $oraver = $words[5]; }
      if ($oraver eq "Release") { $oraver = $words[4]; }
      if ($words[3] eq "11g")   { $oraver = $words[7]; }
      $mode64 = 1 if /64bit/;

      #---- Set var with oracle version 1st 4 levels
      $oraver4levels = ""; 
      $i = 0;
      foreach (split(/\./,$oraver))
      {
	$oraver4levels .= $_ . ".";
	last if ++$i > 3;
      }
      chop $oraver4levels;

    }
    if ($verb eq "THIS" && /10g/) 
    { 
      $sqlgood = 1; 
      $oraver  = $words[7];
      $mode64 = 1 if /64b/;

      #---- Set var with oracle version 1st 4 levels
      $oraver4levels = ""; 
      $i = 0;
      foreach (split(/\./,$oraver))
      {
	$oraver4levels .= $_ . ".";
	last if ++$i > 3;
      }
      chop $oraver4levels;
    }
  }
  close(INDB);

  chop($db_create_date = `$progdir/dbamon_orastat.pl - | grep 'Created:' | awk '{ print \$NF }'`);

  #---- See if any DFs are autoextend
  &msg("Running orastat -fa to see if any DFs are autoextend"); 
  chop($autoextend_cnt = `$progdir/dbamon_orastat.pl -da | grep 'DatafilesWithAutoextend:' | tail -1 | awk '{ print \$NF }'`);
  &msg("autoextend_cnt=$autoextend_cnt"); 

  #---- Get ISQLPlus WWW Port, if any
  chop($isqlport = `grep 'Plus HTTP port number' $oh/install/portlist.ini 2>/dev/null | awk '{ print \$NF }'`);
  $isqlport =~ s/\=//g;  #---- Remove possible equal sign

  #---- Get OEM WWW Port, if any
  chop($oemport = `grep 'Enterprise Manager Console HTTP Port ($os)' $oh/install/portlist.ini 2>/dev/null | awk '{ print \$NF }'`);
  if (! $oemport)
  {
    #---- It didn't work... try with 1 char chopped from instance name
    chop($z = $os); 
    &msg("Looking for OEM port for instance $z"); 
    chop($oemport = `grep 'Enterprise Manager Console HTTP Port ($z)' $oh/install/portlist.ini 2>/dev/null | awk '{ print \$NF }'`);
  }
  $oemport = "?" if ! $oemport;

  if (!$sqlgood)
  {
    print "svgmgrl Diagnostic Output Start: ==============================\n";
    print "@oraout";
    print "svgmgrl Diagnostic Output End: ================================\n";
  }

  $z = substr($oraver,length($oraver)-1,1);
  ##print "oraver=$oraver z=$z\n";
  if ($z eq ",")
  {
    chop($oraver);
    $oraver = $oraver . "(64)";
  }
  if ($mode64)
  {
    $oraver = $oraver . "(64)";
  }

  if ($ENV{'WWW'})
  {
    &alertlogWWW;
    if ($os !~ /^\+ASM/)
    {
      &filecheck;
      &dfCheck; 
    }

    #---- Test
    &corruption;

    if ($thisos eq "HP-UX")
    {
      &serverInfoHPUX;
    }
    if ($thisos eq "Linux")
    {
      &serverInfoLinux;
    }

    $www_bgcolor = "pink";
    $www_bgcolor = "lime" if $sqlgood == 1 && $alertflag != 1;
   
    $www_status = ">>> Down <<<";
    $www_status = "Up" if $sqlgood == 1 ;

    if ($os =~ /^\+ASM/ && $db_status eq "STARTED")
    {
      $www_status = "Up (STARTED is normal for an ASM instance)"; 
      $www_bgcolor= "lime"; 
    }

    $daysup = $hoursup / 24; 
    $daysup = sprintf("%.2f", $daysup);
    
    &msg("WWW Status Summary:");
    print "<table border=0 \n"; 
    print "<tr bgcolor=slate><td><font size=2>Item<td><font size=2>Status\n"; 
    print "<tr bgcolor=$www_bgcolor><td><font size=2>Oracle Status<td><h5>$www_status\n"; 
    print "<tr bgcolor=$www_bgcolor><td><font size=2>DB Status<td><h5>$db_status\n"; 
    print "<tr bgcolor=$www_bgcolor><td><font size=2>Alert Log Status<td><h5>$alertmsg\n"; 
    print "<tr bgcolor=$www_bgcolor><td colspan=2>\n"; 
    print "<tr bgcolor=$www_bgcolor><td><font size=2>Hostname<td><h5>$host\n"; 
    print "<tr bgcolor=$www_bgcolor><td><font size=2>ORACLE_SID<td><h5>$os\n"; 
    print "<tr bgcolor=$www_bgcolor><td><font size=2>DB Name<td><h5>$dbname\n"; 
    print "<tr bgcolor=$www_bgcolor><td><font size=2>Oracle Version<td><h5>$oraver\n"; 
    print "<tr bgcolor=$www_bgcolor><td><font size=2>CF Status<td><h5>$standby\n"; 
    print "<tr bgcolor=$www_bgcolor><td><font size=2>Logins<td><h5>$logins\n"; 
    print "<tr bgcolor=$www_bgcolor><td><font size=2>DB Create Date<td><h5>$db_create_date\n"; 
    print "<tr bgcolor=$www_bgcolor><td><font size=2>Oracle Started<td><h5>$startts\n"; 
    print "<tr bgcolor=$www_bgcolor><td><font size=2>Oracle Has Been Up<td><h5>$hoursup Hours / $daysup Days\n"; 
    print "<tr bgcolor=$www_bgcolor><td><font size=2>FILECHECK File Last Updated<td><h5>$fc_age_hours Hours Ago (File: $fc_filename) \n"; 
    print "<tr bgcolor=$www_bgcolor><td><font size=2>Datafile Count<td><h5>$dfcount\n"; 
    print "<tr bgcolor=$www_bgcolor><td><font size=2>OEM WWW Port<td><h5>$oemport\n"; 
    print "<tr bgcolor=$www_bgcolor><td><font size=2>iSQLPlus WWW Port<td><h5>$isqlport\n"; 
    print "<tr bgcolor=$www_bgcolor><td><font size=2>Complex Passwords Enforced?<td><h5>$complexpw\n"; 
    print "<tr bgcolor=$www_bgcolor><td><font size=2>ASM?<td><h5>$asm\n"; 

    if ($mem_gb > 0)
    {
      print "<tr bgcolor=$www_bgcolor><td colspan=2>\n"; 
      print "<tr bgcolor=$www_bgcolor><td><font size=2>Server Model:<td><h5>$servermodel\n"; 
      print "<tr bgcolor=$www_bgcolor><td><font size=2>Server CPU Count:<td><h5>$num_cpus\n"; 
      print "<tr bgcolor=$www_bgcolor><td><font size=2>Server Physical Memory:<td><h5>$mem_gb (gB)\n"; 
      print "<tr bgcolor=$www_bgcolor><td><font size=2>Server Uptime Memory:<td><h5>$serveruptime\n"; 

      if ($memfree ne "")
      {
	print "<tr bgcolor=$www_bgcolor><td><font size=2>Server Memory Free:<td><h5>$memfree (gB)\n"; 
	if    ($mempct >= 98.5) { $mem_color = "pink"; }
	elsif ($mempct >= 95)   { $mem_color = "yellow"; }
	else                    { $mem_color = "lime"; }
	print "<tr bgcolor=$mem_color><td><font size=2>Server Memory % Used:<td><h5>${mempct}%\n"; 
      }
    }
   
    print "</table>\n"; 

    &msg("Removing tmp files");
    system("rm $tmp1 $tmp2 >/dev/null 2>&1");

    &msg("WWWTEST"); 
    ####&auditSession;
    &EMCheck if $host =~ /quake/;
    ##&ISQCheck;
    ##&securityChecks;
    ##&instanceDetails;
    ##&lsnr if $host =~ /^bu/;
    &userPassword(); 
    ##&datafiles;
    ##&checkDST;

    &msg("Done");
    &msg("END_OF_PROBE");
    exit 0;
  }

  print "$P SQLGOOD:        $sqlgood\n"; 
  print "$P ORAVER:         $oraver\n"; 
  print "$P PARALLEL:       $parallel $instnum\n"; 
  print "$P LOGINS:         $logins\n"; 
  print "$P STANDBY:        $standby\n"; 
  print "$P DBID:           $dbid\n"; 
  print "$P SESSIONSHWM:    $sessionshwm\n"; 
  print "$P ORACLE_STARTED: $startts\n"; 
  print "$P TIMESTAMP_ROWS: $timestamp_rows\n"; 
  print "$P CF_ROWS:        $controlfile_rows\n"; 
  print "$P OEMPORT:        $oemport\n"; 
  print "$P ISQLPORT:       $isqlport\n"; 
  print "$P NUMUSERS:       $numusers\n"; 
  print "$P NUMUSERSND:     $numusersnd\n"; 
  print "$P NUMPROFS:       $numprofs\n"; 
  print "$P COMPLEXPW:      $complexpw\n"; 
  print "$P DBCREATEDATE:   $db_create_date\n"; 
  print "$P AUTOEXTENDCNT:  $autoextend_cnt\n"; 
  print "$P ASM:            $asm\n" if $asm; 

  if ($registry_events)
  {
    print $registry_events;
  }

  # Uptime processing
  if ($startts ne "")
  {
    # @timesplit = split(/:/,$startts);
    # 2001/08/09-15:52:53
    @dateary=(
      substr($startts,17,2),
      substr($startts,14,2),
      substr($startts,11,2),
      substr($startts,8,2),
      (substr($startts,5,2)) - 1,
      (substr($startts,0,4)) - 1900
    );
    $startts_num = &timelocal(@dateary);
    chop($date = `date +%Y/%m/%d-%H:%M:%S`);
    $time = time;
    print "$P UPTIME: $startts $startts_num $date $time \n";
  }

  #TEST 
  #($sec,$min,$hour,$mday,$mon,$year) = localtime($startts_num);
  #print "$sec,$min,$hour,$mday,$mon,$year \n";
  #print "startts_num=$startts_num \n";

  # Check for pmon process

  $numpmon = `ps -ef | grep 'ora_pmon_$os\$' | grep -v 'grep' | wc -l`; 
  chop $numpmon;
  print "$P NUMPMON: $numpmon\n"; 

  # Check for lgwr process

  $numlgwr = `ps -ef | grep 'ora_lgwr_$os\$' | grep -v 'grep' | wc -l`; 
  chop $numlgwr;
  print "$P NUMLGWR: $numlgwr\n"; 

  # Check for smon process

  $numsmon = `ps -ef | grep 'ora_smon_$os\$' | grep -v 'grep' | wc -l`; 
  chop $numsmon;
  print "$P NUMSMON: $numsmon\n"; 

  # Check for dbw. process

  $numdbwr = `ps -ef | grep 'ora_dbw._$os\$' | grep -v 'grep' | wc -l`; 
  chop $numdbwr;
  print "$P NUMDBWR: $numdbwr\n"; 

  # Check for dbw. process

  &msg("Looking for i1|i2 ora_i I/O Slave Background Processes");
  $zcmd = "ps -ef | grep 'ora_i' | grep '$os' | grep -v 'grep' | egrep 'i1|i2'";
  system("$zcmd"); 
  chop($numioslave = `$zcmd | wc -l`); 
  print "$P NUMIOSLAVE: $numioslave\n"; 

  # Old code
  ## system("ps -ef | grep 'ora_i..._$os\$' | grep -v 'grep'"); 
  ## chop($numioslave = `ps -ef | grep 'ora_i..._$os\$' | grep -v 'grep' | wc -l`); 

  # OS Stuff

  system("uname -a");
  system("model");
  system("echo 'MODE' `getconf SC_KERNEL_BITS 2>&1`") if $thisos ne "Linux";

  if ($thisos eq "HP-UX")
  {
    &serverInfoHPUX;
  }
  elsif ($thisos eq "SunOS")
  {
    &serverInfoSolaris;
  }
  elsif ($thisos eq "Linux")
  {
    &serverInfoLinux;
  }
  else
  {
    &msg("No serverInfo routine for thisos=$thisos"); 
  }

  #---- 1.53 Count cron lines
  chop($cronlines = `crontab -l 2>/dev/null | wc -l`); 
  if ($cronlines ne "")
  {
    print "$P CRONLINES: $cronlines\n"; 
  }

  &msg("Running $bdfcmd to check $oh filesystem");
  # Check for ORACLE_HOME full
  $homefull = `$bdfcmd $oh | tail -1 | awk '{ print \$5 }'`;
  chop $homefull;
  chop $homefull;
  if ($homefull >= 99)
  {
    $homeflag = "C";
  }
  elsif ($homefull >= 95)
  {
    $homeflag = "W";
  }
  else
  {
    $homeflag = "-";
  }
  print "$P HOMEFULL: $homefull $homeflag\n"; 

  &msg("Determining backup type");
  # Determine backup type
  $bktype = "bkNone";

  # If there is a recent row in dbamon.backup_age, then that also 
  # counts as a backup_type 
  &bkage();

  chop($orabk1 = `crontab -l | grep -v '^#' | grep 'ora_backup ' | grep '$os' | wc -l`);
  chop($orabk2 = `cat /usr/local/dba/tools/ora_backup_sched.cfg | grep -v '^#' | grep '$host' | grep '$os' | wc -l`);
  chop($orabk3 = `cat /usr/local/dba/tools/ora_backup_sched.cfg | grep -v '^#' | grep '$host' | awk '{ print \$2 }' | grep '*' | wc -l`);

  print "$P Backup_Checks: \n"; 
  print "$P orabk1: $orabk1 \n"; 
  print "$P orabk2: $orabk2 \n"; 
  print "$P orabk3: $orabk3 \n"; 

  #---- Read schedule file - START
  $bkup_found_arc = $bkup_found_lvl = 0;
  foreach $line (`cat /usr/local/dba/tools/ora_backup_sched.cfg | grep '$fqhost' | grep -v '^#' | grep -v '^\$'`)
  {
    $this_sid    = (split(' ',$line))[1];
    next if $this_sid ne $os; 

    $this_bktype = (split(' ',$line))[5];
    &msg("DEBUG - this_sid=$this_sid this_bktype=$this_bktype"); 
   
    $bkup_found_arc = 1 if $this_bktype eq "FRA"; 
    $bkup_found_arc = 1 if $this_bktype eq "FRACHECK"; 
    $bkup_found_arc = 1 if $this_bktype =~ /^ARC/; 
    $bkup_found_lvl = 1 if $this_bktype =~ /^LVL/; 
    $bkup_found_lvl = 1 if $this_bktype =~ /^FRADB/; 
    $bkup_found_lvl = 1 if $this_bktype =~ /^FRALVL/; 
  }
  &msg("DEBUG - bkup_found_arc=$bkup_found_arc bkup_found_lvl=$bkup_found_lvl"); 
  print "$P BKUP_SCHED_ARC: $bkup_found_arc\n"; 
  print "$P BKUP_SCHED_LVL: $bkup_found_lvl\n"; 
  #---- Read schedule file - END

  if ($bktype eq "bkNone" && ($orabk1 > 0 || $orabk2 > 0 || $orabk3 > 0))
  {
    $bktype = "bkRMAN";
  }

  # See if an RMAN or TBS or EXP or FULL backup is running
  chop($numrunning_rman = `ps -ef | grep 'ora_backup' | grep '$os' | grep -v 'grep' | grep 'LVL' | wc -l`);
  chop($numrunning_tbs  = `ps -ef | grep 'ora_tbs_bk' | grep '$os' | grep -v 'grep' | wc -l`);
  chop($numrunning_exp  = `ps -ef | grep 'ora_exp_bk' | grep '$os' | grep -v 'grep' | wc -l`);
  chop($numrunning_full = `ps -ef | grep 'ora_full_bk'| grep '$os' | grep -v 'grep' | wc -l`);

  if (
      $numrunning_rman > 0 ||
      $numrunning_tbs  > 0 ||
      $numrunning_exp  > 0 ||
      $numrunning_full > 0 
     )
  {
    $running = "Y";
  }
  else 
  {
    $running = "N";
  }
  print "$P BACKUP_RUNNING: $running\n";

  # This var is misspelled - i will comment it for now
  ### if ($bktype eq "bkNone" && $bcklevel ne "")
  ### {
  ###   $bcktype = "bk$bcklevel";
  ### }

  if (($company eq "hp" || $company eq "agilent") && $bktype eq "bkNone")
  {
    chop($bkscheds = `grep '$os' /opt/oracle/adm/config/*.sched 2>&1 | grep -v "#$os" | tail -1 | awk -F: {' print \$1 }'`);
    if ($bkscheds eq "/opt/oracle/adm/config/ora_tbs_bk.sched")
    {
      $bktype = "bkTBSold";
    }
    if ($bkscheds eq "/opt/oracle/adm/config/ora_full_bk.sched")
    {
      $bktype = "bkFULLold";
    }
    if ($bkscheds eq "/opt/oracle/adm/config/ora_exp_bk.sched")
    {
      $bktype = "bkEXPold";
    }
    chop($bknum    = `grep -l '$os' /opt/oracle/adm/config/*.sched 2>&1 | wc -l`);
    if ($bknum > 1)
    {
      $bktype = "bkMULTold";
    }
    chop($cronout = `crontab -l | grep -v '^#' | grep 'ora' | grep '$os'`);
    if ($cronout =~ /ora_tbs_bk/)
    {
      $bktype = "bkTBS";
    }
    if ($cronout =~ /ora_exp_bk/)
    {
      $bktype = "bkEXP";
    }
    if ($cronout =~ /ora_full_bk/)
    {
      $bktype = "bkFULL";
    }
    if ($cronout =~ /ora_backup_catexp/)
    {
      $bktype = "bkCATExp";
    }
    #if ($cronout =~ /db_export/)
    #{
    #  $bktype = "bkEXPUsr";
    #}
    if ($cronout =~ /ora_backup_catexp/)
    {
      $bktype = "bkCATExp";
    }
  }

  if ($parallel eq "YES" && $instnum > 1)
  {
    $bktype = "bkOPSN2_NA";
  }
  if ($standby eq "STANDBY" && !$bckfromfile)
  {
    $bktype = "bkSTBY_NA";
  }

  print "$P BKTYPE: $bktype\n"; 

  # Summarize for dbamon_check (WWW)
  if ($sqlgood && $numpmon && $numlgwr && $numsmon && $numdbwr)
  {
    print "<b>$dashes</b>\n";
    print "<b> Because SQL Ran OK and the PMON, LGWR, SMON and DBWR Tasks are active,\n   Oracle is UP and logins are ${logins}.</b>\n";
    print "<b>$dashes</b>\n";
    $autorestart = "(Auto_Restart Was Successful)" if $autorestarted;
  }
  else
  {
    print "<table border=3>\n";
    print "<tr><th>Oracle is DOWN.\n";
    print "</table>\n";
  }
  if ($ora_crashed)
  {
    print "$P ORACRASHED: $autorestart\n";
  }

  # List stack=oraSaveCfgStack
  print "Stack: oraSaveCfgStack # \n";
  print "Stack: oraSaveCfgStack # User-Specified init.ora Parameters:\n";
  print "Stack: oraSaveCfgStack # \n";
  @lines = split(/\n/,$initora);
  foreach (@lines) 
  {
    print "Stack: oraSaveCfgStack $_ \n";
  }

  #---- All init.ora parameters
  &oraSQL('select \'X\', 
    name, 
    nvl(value,\'(Null)\'), 
    nvl(isdefault,\'(Null)\'), 
    nvl(ismodified,\'(Null)\'), 
    nvl(isadjusted,\'(Null)\') 
  from v\$parameter order by 2;');
  $initoraall = ""; 
  foreach (@oraSQLout)
  {
    ##print;
    @words = split;
    if ($words[0] eq "X") 
    { 
      $parm = $words[1];
      $val  = $words[2];
      $isdef = uc $words[3];
      $ismod = uc $words[4];
      $isadj = uc $words[5];
      $ioa_flags = ""; 
      $ioa_flags .= " #DEFAULT"  if $isdef eq "TRUE"; 
      $ioa_flags .= " #MODIFIED"  if $ismod eq "TRUE"; 
      $ioa_flags .= " #ADJUSTED"  if $isadj eq "TRUE"; 
      ##print "DEBUG: parm=$parm val=$val isdef=$isdef ismod=$ismod isadj=$isadj ioa_flags=$ioa_flags\n"; 
      $initoraall .= "$parm = $val         $ioa_flags\n";
    }
  }
  print "Stack: oraSaveCfgStack # \n";
  print "Stack: oraSaveCfgStack # All init.ora Parameters:\n";
  print "Stack: oraSaveCfgStack # \n";
  @lines = split(/\n/,$initoraall);
  foreach (@lines) 
  {
    print "Stack: oraSaveCfgStack initOraAll: $_\n";
  }

  #---- Config stack tablespaces
  print "Stack: oraSaveCfgStack # \n";
  print "Stack: oraSaveCfgStack # Report of all Tablespaces:\n";
  print "Stack: oraSaveCfgStack # \n";
  foreach (`$progdir/dbamon_orastat.pl -ts`)
  {
    print "Stack: oraSaveCfgStack $_";
  }

  chop($cron_oddjob = `crontab -l | grep -v '^#' | grep 'ora_oddjob' | wc -l`);
  print "$P CRON_ODDJOB: $cron_oddjob\n"; 

  chop($cron_sched = `crontab -l | grep -v '^#' | grep 'ora_backup_sched' | wc -l`);
  print "$P CRON_SCHED: $cron_sched\n"; 

  &filesList();

  &upParm();

  &onlineRedo();

  &processesCount();

  &filesCount();

  &checkAutostart() if $company eq "agilent" && $thisos eq "HP-UX" && $rq_runmon ne "B";

  &checkListenerLog() if $rq_runmon ne "B";
}

# ----------------------------------------------------------------------
sub checkListenerLog
# ----------------------------------------------------------------------
{
  $listener_log    = "$oh/network/log/listener.log"; 
  $listener_log_gz = "$oh/network/log/listener.log.gz"; 

  if (! $rq_t_listlog)
  {
    &msg("Threshold rq_t_listlog is not set - skipping check"); 
    return;
  }

  &msg("checkListenerLog() - Seeing if the listener log ($listener_log) is > $rq_t_listlog MB"); 
  system("ls -l $listener_log 2>&1"); 

  $listener_log_size_mb = int( (stat "$listener_log" ) [7] / (1024*1024) );
  &msg("Log size: $listener_log_size_mb MB"); 

  if ($listener_log_size_mb >= $rq_t_listlog)
  {
    &msg("Size of log exceeds threshold - gziping log"); 
    ##print "$P LISTENER_LOG_SIZE: $listener_log_size_mb $rq_t_listlog $listener_log\n"; 
    $rc1 = system("gzip -c $listener_log > $listener_log_gz"); 
    $zerr1 = $!; 
    $rc2 = system("cat /dev/null > $listener_log"); 
    $zerr2 = $!; 
    if ($rc1 != 0 || $rc2 != 0)
    {
      $zerr = "$zerr1 $zerr2"; 
      &msg("Error gzipping $listener_log - rc=$rc - $zerr"); 
      print "$P LISTENER_LOG_GZIP_ERROR: $listener_log $zerr\n"; 
      return;
    }
    $listener_log_size_af = int( (stat "$listener_log_gz" ) [7] / (1024*1024) );
    $zsavings = $listener_log_size_mb - $listener_log_size_af;
    print "$P LISTENER_LOG_SAVINGS: $zsavings\n"; 
    system("ls -l $listener_log_gz 2>&1"); 
  }

  return;
}

# ----------------------------------------------------------------------
sub checkAutostart
# ----------------------------------------------------------------------
{
  &msg("checkAutostart() - Seeing if Oracle autostart scripts are in place and current"); 

  chop($numsg = `ps -efx | grep 'cmcld' | grep -v 'grep' | wc -l`);
  &msg("There are $numsg ServiceGuard daemon process(es) running"); 
  if ($numsg > 0)
  {
    &msg("ServiceGuard is running - Autostart check not applicable"); 
    return;
  }

  if (! -e "/sbin/rc2.d/K800oracle" || ! -e "/sbin/rc3.d/S200oracle")
  {
    &msg("Both autostart/autostop scripts are not in place");    
    system("ll /sbin/rc2.d/K800oracle 2>&1"); 
    system("ll /sbin/rc3.d/S200oracle 2>&1"); 
    print "$P ORACLE_AUTOSTART: NF\n"; 
  }
  if (-e "/sbin/init.d/oracle" && system("grep 'oraadmin' /sbin/init.d/oracle") != 0)
  {
    &msg("Oracle autostart script /sbin/init.d/oracle Is OBSOLETE - It does not invoke oraadmin");    
    print "$P ORACLE_AUTOSTART: OBSOLETE\n"; 
  }
}

# ----------------------------------------------------------------------
sub checkRollback
# ----------------------------------------------------------------------
{
  &msg("checkRollback() - Running 'select count(*) from v\$rollstat' to check DB health"); 
  $sqlstmt = ' select \'X\', count(*) from v\$rollstat; ';
  &oraSQL($sqlstmt);
  $rbcount = -1;
  foreach (@oraSQLout)
  {
    ##print;
    @words = split;
    $verb  = $words[0];
    if ($verb eq "X") 
    { 
      $rbcount = $words[1];
    }
  }
  if ($rbcount > -1)
  {
    &msg("checkRollback() - Result is $rbcount - Check successful"); 
  }
  else
  {
    &msg("<font color=red>Result is $rbcount - SOMETHING IS WRONG With This Oracle Instance</font>"); 
    system("echo ' ' | mailx -s 'DBAmon | $host/$os - rbcount=$rbcount [AUTO]' dbaadmin\@dba.it.agilent.com") if $company eq "agilent";
  }
}

# ----------------------------------------------------------------------
sub bkage
# ----------------------------------------------------------------------
{
  $lvlage = 99999999;  # Age in hours of most recent LVL? backup
  $sqlstmt = "
  select 
    'X', 
    bcklevel, 
    max(tsnum),
    max(tstext) 
  from dbamon.backup_age
  --where sid = '$os' and bcklevel != 'ARC'
    where sid = '$os' and bcklevel not like 'DF%'
  group by 'X', bcklevel
  order by 3;";

  &oraSQL($sqlstmt);
  foreach (@oraSQLout)
  {
    ##print;
    @words = split;
    $verb    = $words[0];
    if ($verb eq "X") 
    { 
      $bcklevel = $words[1];
      $maxts    = $words[2];
      $maxtstxt = $words[3];
      $now      = time();
      $agehrs   = ($now - $maxts) / 3600;
      $agehrs   = sprintf("%.0f", $agehrs);
      print "$P BACKUP_AGE: $bcklevel $agehrs\n";

      #---- Save TS of most recent non-ARC backup
      if ($maxtstxt gt $mr_ts_txt && $bcklevel !~ /^ARC/)
      {
        $mr_ts_txt = $maxtstxt;
      } 

      if (substr($bcklevel,0,3) eq "LVL" || $bcklevel =~ /FRALVL/)
      {
        $bktype = "bkRMAN";
	if ($agehrs < $lvlage) { $lvlage = $agehrs; }
        $bklvlts = $maxtstxt; 
      }
      #new 1.28 block
      if (substr($bcklevel,0,3) eq "OFF")
      {
        $bktype = "bkRMAN";
	if ($agehrs < $lvlage) { $lvlage = $agehrs; }
        $bklvlts = $maxtstxt; 
      }
      if (substr($bcklevel,0,3) eq "EXP")
      {
        $bktype = "bkEXP";
	if ($agehrs < $lvlage) { $lvlage = $agehrs; }
      }
      if (substr($bcklevel,0,3) eq "TBS")
      {
        $bktype = "bkTBS";
	if ($agehrs < $lvlage) { $lvlage = $agehrs; }
      }
      if (substr($bcklevel,0,3) eq "BCV")
      {
        $bktype = "bkBCV";
	if ($agehrs < $lvlage) { $lvlage = $agehrs; }
      }
    }
  }
  print "$P BACKUP_AGE_MR: $lvlage\n";
  print "$P BACKUP_TYPE_MR: $bcklevel\n";
  print "$P BACKUP_DATE_MR: $mr_ts_txt\n";

  $bckage_file = "/opt/oracle/adm/log/DBAmon_Backup_Age_$os.txt";
  if (-e $bckage_file)
  {
    &msg("Reading $bckage_file");
    open(BCKAGE, "$bckage_file") || &error("Cannot open input $bckage_file - $!");
    while(<BCKAGE>)
    {
      $bckfromfile = 1;
      @words  = split();
      $ts = $words[5];
      $bcklevel = $words[1];
      $agefilehrs = int((time - $ts) / 3600); 
      print "$P BACKUP_AGE_FILE: $words[0] $words[1] $words[2] $words[3] $words[4] $words[5] AgeHrs: $agefilehrs\n";
      if ($bcklevel =~ /^LVL/ || 
          $bcklevel eq "OFFLINE" 
         )
      {
        $bktype = "bkRMAN";
      }
      ##print "bcklevel=$bcklevel bktype=$bktype\n";
    }
    close(BCKAGE);
    print "$P BACKUP_AGE_FILE_MR: $agefilehrs\n";
  }

  # See if there have been any unrecoverable changes since the last LVLx backup
  if ($bktype eq "bkRMAN"  && ! $standby_flag)
  {
    &msg("Looking for v\$datafile unrecoverable changes since the last LVLx RMAN backup");
    $sqlstmt = '
      select
        \'X\',
	name, 
        to_char(unrecoverable_time,\'YYYY/MM/DD-HH24:MM:SS\')
      from 
	v\$datafile 
      where 
	unrecoverable_time > 
	  to_date( 
            -- ( select max(tstext) from dbamon.backup_age where bcklevel like \'LVL%\'), 
            -- ( select max(tstext) from dbamon.backup_age where bcklevel like \'LVL%\'),   #---- BB 29Oct07
               ( select max(tstext) from dbamon.backup_age where bcklevel like \'%LVL%\' or bcklevel = \'OFFLINE\'), 
          \'YYYY/MM/DD-HH24:MI:SS\');
    ';
    ##print "sqlstmt=\n$sqlstmt\n";
    &oraSQL("$sqlstmt");
    $unreccnt = 0;
    foreach (@oraSQLout)
    {
      ##print;
      print if /^ORA/;
      @words  = split();
      $verb = $words[0];
      if ($verb eq "X")
      {
        $dfname = $words[1];
        $dfts   = $words[2];
        print "$P UNREC_RMAN_CHANGE: $dfname $dfts $bklvlts\n";
        $unreccnt = 1;
      }
    }
    if ($unreccnt == 0)
    {
      &msg("No unrecoverable changes since the last LVLx RMAN backup were found");
    }
    else
    {
      &msg("$unreccnt unrecoverable changes since the last LVLx RMAN backup were found");
    }
    ### TEST
    ## print "$P UNREC_RMAN_CHANGE: mytestdfname 2009-1-3 $bklvlts\n";
  }
}

# ----------------------------------------------------------------------
sub filecheck
# ----------------------------------------------------------------------
{
  chop($fc_filename = `grep '^FILECHECK' $cfg | awk '{ print \$2 }'`);
  if ($fc_filename eq "")
  {
    print "$P FILECHECK: Parm not found in $cfg\n";
    return;
  }
  print "$P FILECHECK: fc_filename=$fc_filename\n";
  if (! -e $fc_filename)
  { 
    print "$P FILECHECK: NotFound fc_age_hours: . $fc_filename\n";
    return;
  }
  $fc_mtime = (stat "$fc_filename") [9];
  $fc_age = time - $fc_mtime;
  $fc_age_hours = $fc_age / 3600;
  $fc_age_hours = sprintf("%.2f", $fc_age_hours);
  #print "$P FILECHECK: file Found fc_age_hours: $fc_age_hours $fc_filename\n";
  print "$P FILECHECK: Found fc_age_hours: $fc_age_hours $fc_filename\n";
}

# ----------------------------------------------------------------------
sub bkrun
# ----------------------------------------------------------------------
{
  $cmd = $arg1;
  print "$P bkrun: Issuing at now command to run backup:\n";
  print "$P bkrun: Command before {SID} substitution: $cmd\n";
  $cmd =~ s/\{SID\}/$os/g;
  $cmd = "echo 'time $cmd' | at now 2>&1";
  print "$P bkrun: About to issue: $cmd\n";
  $rc = system($cmd);
  print "$P bkrun: Back from issuing at now - rc=$rc\n";
  print "<table bgcolor=skyblue>
  <tr><td><pre>

  Backup Was Invoked - cmd=$cmd
  </table>";
}

# --------------------------------------------------------------------
sub inSyncCheckInhibit 
# --------------------------------------------------------------------
{
  $tmpout = "$tmpdir/dbamon_ora_checkinhib_${$}.txt";

  #---- Check to see if DBAmon standby refresh inhibit is
  #----   turned on now (this is used for outages)
  &msg("Running ora_check_inhibit to see if sby refresh is inhibited");

  $rc = system("/usr/local/dba/tools/ora_check_inhibit_sby > $tmpout 2>&1");
  $rc /= 256;

  &msg("Back from ora_check_inhibit_sby - rc=$rc - Output:");
  system("cat $tmpout");

  if ($rc == 2)
  {
    &msg("=========================================================================================");
    &msg("This check is being cancelled because sby refresh is now inhibited via DBAmon.");
    &msg("=========================================================================================");
    system("cat $tmpout | mailx -s '$P | ora_check_inhibit_sby rc=$rc $host/$os - [AUTO]' dbaadmin\@dba.it.agilent.com");
    exit 0;
  }
}

# --------------------------------------------------------------------
sub inSyncSby
# --------------------------------------------------------------------
{
  $is_prihost   = $arg1;
  $is_prisid    = $arg2;
  &msg("inSyncSby(): is_prihost=$is_prihost is_prisid=$is_prisid");

  if ($company eq "agilent")
  {
    if (system("crontab -l | grep 'ora_standby_refresh_drp' >/dev/null 2>&1") == 0)
    {
      &msg("Invoking inSyncCheckInhibit"); 
      &inSyncCheckInhibit;
    }
  }

  &msg("inSyncSby(): Obtaining local Standby measurement");
  $sqlstmt = 'select \'X\', sysdate-CONTROLFILE_TIME from v\$database;';
  &oraSQL("$sqlstmt");
  foreach (@oraSQLout)
  {
    ##print;
    print if /^ORA/;
    @words  = split();
    $verb = $words[0];
    if ($verb eq "X")
    {
      $minago = $words[1] * 24 * 60;
      $minago = '.' if $minago eq "";
      printf "INSYNC: SBY %10.2f\n", $minago;
    }
  }

  # Get info from primary
  &msg("inSyncSby(): Obtaining remote Primary measurement");
  @rshout = `$comm_method $is_prihost 'export ORACLE_SID=$is_prisid; $progdir/dbamon_ora.pl inSyncPri $host $os'`;
  foreach (@rshout)
  {
    ##print;
    @words  = split();
    $verb = $words[0];
    ##print "verb=$verb w1=$words[1]\n";
    if ($verb eq "INSYNC:" && $words[1] eq "PRI")
    {
      $is_pritime = $words[2]; 
    }

    print;

    #if ($verb eq "INSYNC:" && $words[1] eq "NOLOG")
    #{
    #  print;
    #}
    #if ($verb eq "INSYNC:" && $words[1] eq "PRIUP")
    #{
    #  print;
    #}
    #if ($verb eq "INSYNC:" && $words[1] eq "PRIUNREC")
    #{
    #  print;
    #}
  }
  printf "INSYNC: PRI %10.2f\n", $is_pritime;
  &msg("inSyncSby(): Calculating delta");
  $delta = $minago - $is_pritime;
  printf "INSYNC: DELTA %10.2f\n", $delta;

}

# --------------------------------------------------------------------
sub inSyncPri
# --------------------------------------------------------------------
{
  $is_sbyhost   = $arg1;
  $is_sbysid    = $arg2;
  &msg("inSyncPri(): is_sbyhost=$is_sbyhost is_sbysid=$is_sbysid");

  $priup = "N";
 
  #---- Get controlfile_time age & force_logging setting
  $sqlstmt = '
    select \'X\', sysdate-CONTROLFILE_TIME from v\$database;
    select \'N\', force_logging from v\$database;
  ';
  &oraSQL("$sqlstmt");
  foreach (@oraSQLout)
  {
    ##print;
    print if /^ORA/;
    @words  = split();
    $verb = $words[0];
    if ($verb eq "X")
    {
      $priup = "Y";
      $minago = $words[1] * 24 * 60;
      $minago = '.' if $minago eq "";
      printf "INSYNC: PRI %10.2f\n",
        $minago;
    }
    if ($verb eq "N") 
    { 
      $force_logging = $words[1]; 
      print "INSYNC: FORCE_LOGGING: $force_logging\n"; 
    }
  }

  # Get list of nologging objects
  $sqlstmt = '
    select
      \'X\',
      \'TABLE\',
      owner,
      table_name
    from
      dba_tables
    where
      logging = \'NO\'
      and table_name != \'DEF\$_TEMP\$LOB\'
      and table_name != \'ATEMPTAB\$\'
      and tablespace_name is not null
      and temporary = \'N\'
      ;
    select
      \'X\',
      \'INDEX\',
      owner,
      index_name
    from
      dba_indexes
    where
      logging = \'NO\'
      and tablespace_name is not null
      and temporary = \'N\'
      ;
  ';

  &oraSQL("$sqlstmt");
  foreach (@oraSQLout)
  {
    ##print;
    print if /^ORA/;
    @words  = split();
    $verb = $words[0];
    if ($verb eq "X")
    {
      $priup = "Y";
      $obj = "$words[1]=$words[2].$words[3]";
      if ($force_logging eq "YES")
      {
        print "INSYNC: NOLOG_NBD $obj\n";
      }
      else
      {
        print "INSYNC: NOLOG $obj\n";
      }
    }
  }

  print "INSYNC: PRIUP $priup\n";

  # Check the dbamon.standby_rebuild table

  &msg("inSyncSby(): Selecting dbamon.standby_rebuild");
  $sqlstmt = "select 
    \'X\', 
      to_char(ts,\'YYYY/MM/DD-HH24:MM:SS\'),
      prisid,
      prihost,
      sbysid,
      sbyhost,
      tool
    from 
      dbamon.standby_rebuild
    where 
      sbysid      = '$is_sbysid'
      and sbyhost = '$is_sbyhost'
    order by 2;";

  &oraSQL("$sqlstmt");

  $tbl_exists = 0;
  $tbl_rows  = 0;

  foreach (@oraSQLout)
  {
    ##print;
    print if /^ORA/;
    @words  = split();
    $verb = $words[0];
    if ($verb eq "X")
    {
      if ($tbl_exists == 0)
      {
        $tbl_exists = 1;
        print "\n";
        print "             Rebuild history for this standby database\n";
        print "\n";
        print "Rebuild Timestamp   Pri SID  Pri Host Sby SID  Sby Host Tool\n";
        print "------------------- -------- -------- -------- -------- ----------------\n";
      }
      $tbl_rows++; 
      $ts      = $words[1];
      $prisid  = $words[2];
      $prihost = $words[3];
      $sbysid  = $words[4];
      $sbyhost = $words[5];
      $sbtool  = $words[6];
      printf "%-19s %-8s %-8s %-8s %-8s %-16s\n", $ts,  $prisid, $prihost, $sbysid, $sbyhost, $sbtool;
      $lastts = $ts;
    }
  }
  
  print "\n";
  &msg("DBAMON.STANDBY_REBUILD contains $tbl_rows row(s) - most recent rebuild: $lastts");

  if ($tbl_exists)
  {
    &msg("Seeing if there are any vdatafile unrecoverable_timestamps greater than the last rebuild of this stby");

    $sqlstmt = "select 
      \'X\', 
      df.name,
      to_char(df.unrecoverable_time,\'YYYY/MM/DD-HH24:MM:SS\')
    from
      v\\\$datafile df
    where
      df.unrecoverable_time > 
        (select 
           max(ts) 
         from 
           dbamon.standby_rebuild          
         where 
           sbysid      = '$is_sbysid'
           and sbyhost = '$is_sbyhost');";

    &oraSQL("$sqlstmt");

    $tbl_exists = 0;
    $tbl_rows = 0;
    $unrec_changes = 0;

    foreach (@oraSQLout)
    {
      ##print;
      print if /^ORA/;
      @words  = split();
      $verb = $words[0];
      if ($verb eq "X")
      {
	if ($tbl_exists == 0)
	{
	  $tbl_exists = 1;
	  print "\n";
	  print "  Datafiles that have unrecoverable changes that have occured after the \n";
	  print "            the most recent standby rebuild which occured\n";
	  print "                        at $lastts\n";
	  print "\n";
	  print "Datafile                                           Last Unrec. Change\n";
	  print "-------------------------------------------------- ------------------\n";
          $unrec_changes = 1;
	}
	$tbl_rows++; 
	$df      = $words[1];
	$dftime  = $words[2];
	printf "%-50s %-20s \n", $df,  $dftime;
      }
    }
    print "\n";
    if ($unrec_changes)
    {
      print "INSYNC: PRIUNREC $tbl_rows\n\n";
    }
  }
}


# =========================================================
sub rmanHung
# =========================================================
{
  # Look for OLD rman processes
  $rman_days_threshold = 0.75;

  # Force UX95 mode for ps command
  $ENV{"UNIX95"} = 1;

  &msg("Looking for hung ' rman' user=$userid processes");
  #pen(PS, "ps -ef -oetime,pid,tty,comm,ruser,ppid,pcpu | grep 'rman ' | egrep -v 'sh|grep' | grep '$userid' |") || die "can't run ps - $!";
  open(PS, "ps -ef -oetime,pid,tty,ruser,ppid,pcpu,comm | grep ' rman' | egrep -v 'sh|grep' | grep '$userid' |") || die "can't run ps - $!";

  $rman_hungcnt = 0;
  $rman_pidlist = "";
  $ruser = ""; 

  while(<PS>)
  {
    ##print;
    @words = split;
    $etime = shift @words;
    $pid   = shift @words;
    $tty   = shift @words;
    $ruser = shift @words;
    $ppid  = shift @words;
    $pcpu  = shift @words;
    $comm  = shift @words;

    ## @t = split(":-",$etime);
    @t = split(/[-:]/,$etime);

    $secs = -1;
    if (length($etime) == 5)  { $secs = ($t[0] * 60) + $t[1]; }
    if (length($etime) == 8)  { $secs = ($t[0] * 3600) + ($t[1] * 60) + $t[2]; }
    if (length($etime) == 10) { $secs = ($t[0] * 86400) + ($t[1] * 3600) + ($t[2] * 60) + $t[3]; }
    if (length($etime) == 11) { $secs = ($t[0] * 86400) + ($t[1] * 3600) + ($t[2] * 60) + $t[3]; }
    $days = sprintf("%.2f", $secs / (24*60*60));

    print "  pid=$pid ppid=$ppid pcpu=$pcpu comm=$comm ty=$tty secs=$secs days=$days\n";

    #---- This is to debug RMAN hung problems
    print "$P RMANDIAG: $date $host/$os pid=$pid ppid=$ppid pcpu=$pcpu days=$days comm=$comm\n";

    #---- Collect some diagnostic data
    $rmandiagdata = `ps -ef | egrep 'rman|ora_backup' | sort`;
    open(DIAG, ">$tmp2");  
    print DIAG $rmandiagdata;
    close(DIAG); 

    #---- If rman process has ppid of 1 and is consuming >50% cpu and is >= 300 seconds old, then kill it NOW
    if ($ppid == 1 && $pcpu >= 50 && $secs >= 300)
    {
      $rc = system("kill $pid 2>&1");

      $rmandiagdata = `ps -ef | egrep 'rman|ora_backup' | sort`;
      open(DIAG, ">>$tmp2");  
      print DIAG "*---------- After kill:\n";
      print DIAG $rmandiagdata;
      close(DIAG); 
      &msg("Process list before and after kill"); 
      system("cat $tmp2 2>&1"); 

      ##system("cat $tmp2 | mailx -s 'DBAmon | $host/$os - RMANHUNGKILLED rc=$rc pid=$pid ppid=$ppid pcpu=$pcpu secs=$secs' dbaadmin\@dba.it.agilent.com") if $company eq "agilent";

      print "$P RMANKILLED: RMAN process $pid (ppid=$ppid pcpu=$pcpu) This is consuming >= 50% CPU with PPID=1\n";
      next;
    }

    if ($days > $rman_days_threshold)
    {
      print "\n";
      print "$P RMANHUNG: Found rman process (pid=$pid ppid=$ppid) that has been running for $days days (threshold=$rman_days_threshold days)\n";
      system("ps -ef | grep '$pid'");
      $rman_hungcnt++;
      $rman_pidlist .= "${pid},"; 
      ##system("cat $tmp2 | mailx -s 'DBAmon | $host/$os - RMANHUNG pid=$pid ppid=$ppid pcpu=$pcpu days=$days' dbaadmin\@dba.it.agilent.com") if $company eq "agilent";
    }
  }
  close(PS);

  &msg("Found $rman_hungcnt possible hung RMAN process(es)");
  if ($rman_hungcnt > 0)
  {
    chop $rman_pidlist;
    print "$P RMANHUNGMULTI: $rman_hungcnt $rman_pidlist\n";
  }
}

# =========================================================
sub fs
# =========================================================
{
  $fsmask = $arg3;

  &msg("Looking for filesystems that match $fsmask");

  open(DF, "$bdfcmd | grep '$fsmask' |") || die "can't run ps - $!";

  $fs_cnt = 0;
  $max_fsfree_gb = 0;

  while(<DF>)
  {
    print;
    @words = split;

    if ($words[0] =~ /^\//)
    {
      shift @words;
    }
    $fssize = $words[0];
    $fsused = $words[1];
    $fsfree = $words[2];
    #$fspct  = $words[3];
    #$fsname = $words[4];

    $fssize_gb = $fssize / 1000000;
    $fsused_gb = $fsused / 1000000;
    $fsfree_gb = $fsfree / 1000000;

    $tot_fssize_gb += $fssize_gb;
    $tot_fsused_gb += $fsused_gb;
    $tot_fsfree_gb += $fsfree_gb;

    $max_fsfree_gb = $fsfree_gb if $fsfree_gb > $max_fsfree_gb;
    $fs_cnt++;
  }
  close(DF);

  &msg("Found $fs_cnt filesystems");
 
  $pct_fsused = 100 * ($tot_fsused_gb / $tot_fssize_gb) if $tot_fssize_gb > 0;

  $tot_fssize_gb = sprintf("%.2f", $tot_fssize_gb);
  $tot_fsused_gb = sprintf("%.2f", $tot_fsused_gb);
  $tot_fsfree_gb = sprintf("%.2f", $tot_fsfree_gb);
  $max_fsfree_gb = sprintf("%.2f", $max_fsfree_gb);
  $pct_fsused = sprintf("%.2f", $pct_fsused);

  print "$P TOT_FSSIZE_GB:  $tot_fssize_gb\n";
  print "$P TOT_FSUSED_GB:  $tot_fsused_gb\n";
  print "$P TOT_FSFREE_GB:  $tot_fsfree_gb\n";
  print "$P MAX_FSFREE_GB:  $max_fsfree_gb\n";
  print "$P PCT_FSUSED:     $pct_fsused\n";
}

# =========================================================
sub fsGeneric
# =========================================================
{
  $fsmask = "/var/opt/oracle/disk";
  &msg("Looking for filesystems that match $fsmask");

  open(DF, "$bdfcmd | grep '$fsmask' |") || die "can't run ps - $!";

  $fs_cnt = 0;
  $max_fsfree_gb = 0;

  while(<DF>)
  {
    print;
    @words = split;

    if ($words[0] =~ /^\//)
    {
      shift @words;
    }
    $fssize = $words[0];
    $fsused = $words[1];
    $fsfree = $words[2];
    #$fspct  = $words[3];
    #$fsname = $words[4];

    $fssize_gb = $fssize / 1000000;
    $fsused_gb = $fsused / 1000000;
    $fsfree_gb = $fsfree / 1000000;

    $tot_fssize_gb += $fssize_gb;
    $tot_fsused_gb += $fsused_gb;
    $tot_fsfree_gb += $fsfree_gb;

    $max_fsfree_gb = $fsfree_gb if $fsfree_gb > $max_fsfree_gb;
    $fs_cnt++;
  }
  close(DF);

  &msg("Found $fs_cnt filesystems");
 
  $pct_fsused = 100 * ($tot_fsused_gb / $tot_fssize_gb) if $tot_fssize_gb > 0;

  $tot_fssize_gb = sprintf("%.2f", $tot_fssize_gb);
  $tot_fsused_gb = sprintf("%.2f", $tot_fsused_gb);
  $tot_fsfree_gb = sprintf("%.2f", $tot_fsfree_gb);
  $max_fsfree_gb = sprintf("%.2f", $max_fsfree_gb);
  $pct_fsused = sprintf("%.2f", $pct_fsused);

  print "$P TOT_FSSIZE_GB:  $tot_fssize_gb\n";
  print "$P TOT_FSUSED_GB:  $tot_fsused_gb\n";
  print "$P TOT_FSFREE_GB:  $tot_fsfree_gb\n";
  print "$P MAX_FSFREE_GB:  $max_fsfree_gb\n";
  print "$P PCT_FSUSED:     $pct_fsused\n";
}


# ----------------------------------------------------------------------
sub bkbl
# ----------------------------------------------------------------------
{
  &bkTypeCheck;

  $bktype = $arg1;
  $what   = $arg2;

  if ($bk_type eq "ora_backup")
  {
    $logpath = "/opt/oracle/adm/cronlog/ora_backup_${os}_${bktype}.log";
  }
  else
  {
    ##$z = "/opt/app/oracle/esoadmin/log/${os}_rman2ob_*.log";
    $z = "/opt/oracle/adm/cronlog/rman2ob_${os}*.log";
    chop($logpath = `ls -l $z | tail -1 | awk '{ print \$NF }'`);
  }

  &msg("bkbl() - what=$what bktype=$bktype logpath=$logpath");

  system("ls -l $logpath 2>&1");
  if (! -e $logpath)
  {
    &error("Log file $logpath does not exist");
  }

  chop($lines = `wc -l $logpath | awk '{ print \$1 }'`);
  &msg("File $logpath contains $lines lines");

  if    ($what eq "view") { $cmd = "cat"; }
  elsif ($what eq "tail") { $cmd = "tail -50 "; }
  &msg("Running $cmd on $logpath");

  print "<table bgcolor=skyblue>
  <tr><td><pre>
  <b>Start of ora_backup Log: $logpath</b><hr>";

  system("$cmd $logpath 2>&1");

  print "<hr>
  <b>End of ora_backup Log: $logpath</b></table>\n"; 
}

# ----------------------------------------------------------------------
sub bkrb
# ----------------------------------------------------------------------
{
  &bkTypeCheck;

  $bk_torun = $arg1;
  &msg("Invoking an $bk_torun $bk_type backup");

  if ($bk_type eq "ora_backup")
  {
    $bk_cmd = "/usr/local/dba/tools/ora_backup $os $bk_torun >> /opt/oracle/adm/cronlog/ora_backup_${os}_${bk_torun}.log 2>&1";
  }
  else  # Must be rman2ob
  {
    if ($bk_torun eq "ARCEMERGENCY")
    {
      $bk_cmd = "/usr/local/dba/tools/rman2ob.pl -D $os -d 0 >> $tmpdir/dbamon_ora_bkrb.log 2>&1";
    }
    elsif ($bk_torun eq "ARC")
    {
      $bk_cmd = "/usr/local/dba/tools/rman2ob.pl -D $os -a   >> $tmpdir/dbamon_ora_bkrb.log 2>&1";
    }
    elsif ($bk_torun eq "LVL0")
    {
      $bk_cmd = "/usr/local/dba/tools/rman2ob.pl -D $os -O 0 >> $tmpdir/dbamon_ora_bkrb.log 2>&1"; 
    }
    elsif ($bk_torun eq "LVL1")
    {
      $bk_cmd = "/usr/local/dba/tools/rman2ob.pl -D $os -O 1 >> $tmpdir/dbamon_ora_bkrb.log 2>&1"; 
    }
    else
    {
      &error("Backup type of $bk_torun is not valid for rman2ob");
    }
  }

  &msg("Setting NOTIX environment variable to 1");
  $ENV{"NOTIX"} = "1";
  system("env | grep 'NOTIX'"); 

  $cmd = "echo 'time $bk_cmd' | at now";
  $rc = system($cmd);

  print "<table bgcolor=skyblue>
  <tr><td><pre>

  Backup Was Invoked - cmd=$cmd
  </table>";
  &msg("Back from issuing at now - rc=$rc");
}

# ----------------------------------------------------------------------
sub bkhi
# ----------------------------------------------------------------------
{
  &bkTypeCheck;

  print "<table bgcolor=skyblue border=1>
  <tr bgcolor=slate>
    <th><font size=2>Backup Type
    <th><font size=2>Timestamp 
    <th><font size=2>Backup<br>Duration<br>(Minutes)  
    <th><font size=2>Backup Age<br>(Hours)
    <th><font size=2>DB Size<br>(MB Used)
  ";

  $now = time;
  $rowcount = 0;
  $sqlstmt = 'select \'Y\', SID, BCKLEVEL, TSNUM, TSTEXT, DBSIZE, ELAPSED
    from dbamon.backup_age
    order by 5 desc;';
  &oraSQL($sqlstmt);
  foreach (@oraSQLout)
  {
    ##print;
    print if /^ORA/;
    @words = split;
    $verb    = $words[0];
    if ($verb eq "Y")
    {
      #$sid     = $words[1];
      $level   = $words[2];
      $tsnum   = $words[3];
      $tstext  = $words[4];
      $dbsize  = $words[5];
      $elapsed = int($words[6]/60);
      $age     = ($now - $tsnum) / (60*60);

      $age = sprintf("%.2f",$age);

      print "<tr>
        <td><font size=2>$level
        <td><font size=2>$tstext
        <td align=right><font size=2>$elapsed
        <td align=right><font size=2>$age
        <td align=right><font size=2>$dbsize
      "; 
     
      $rowcount++;
    }
  }
  print "</table>";
  &msg("$rowcount Backup rows found");
}

# ----------------------------------------------------------------------
sub bkTypeCheck
# ----------------------------------------------------------------------
{
  &msg("Determining backup type");
  if (-e "/opt/app/oracle/esoadmin/log/${os}_rman2ob_1.log")
  {
    $bk_type = "rman2ob";
  }
  elsif (-e "/opt/oracle/adm/cronlog/${os}_rman2ob_1.log")
  {
    $bk_type = "rman2ob";
  }
  elsif (-e "/opt/oracle/adm/cronlog/ora_backup_${os}_LVL0.log")
  {
    $bk_type = "ora_backup";
  }
  elsif (-e "/usr/openv/netbackup/logs/user_ops/dbext/logs/")
  {
    $bk_type = "ora_backup";
  }
  else
  {
    system("echo ' ' | mailx -s 'DBAmon | $host/$os - Cannot determine bk_type ' dbaadmin\@dba.it.agilent.com") if $company eq "agilent";
    &error("Cannot determine backup type - ora_backup and rman2ob.pl residue not found - BB was contacted");
  }

  ##if ($bk_type eq "rman2ob")
  ##{
  ##  $bk_dir = "/opt/app/oracle/esoadmin/log";
  ##}
  ##else
  ##{
  ##  $bk_dir = "/opt/oracle/adm/cronlog";
  ##}

  $bk_dir = "/opt/oracle/adm/cronlog";
   
  &msg("Derived bk_type=$bk_type bk_dir=$bk_dir");
}

# ----------------------------------------------------------------------
sub bkps
# ----------------------------------------------------------------------
{
  &bkTypeCheck;

  $cmd = "ps -ef | grep '$bk_type' | grep -v 'grep'";
  &msg("Running $cmd");
  print "<table bgcolor=skyblue>
  <tr><td><pre>
  <b>Start of $bk_type Running Process List</b><hr>";
  system("$cmd 2>&1");
  print "<hr>
  <b>End of $bk_type Running Process List</b><hr></table>";

  &msg("bkps() Listing $bk_type Logs In /opt/oracle/adm/cronlog");
  print "<table bgcolor=skyblue>
  <tr><td><pre>
  <b>Start - $bk_type Log Files</b><hr>";
  system("ls -l $bk_dir  2>&1 | grep '$bk_type'");
  print "<hr>
  <b>End - $bk_type Log Files</b><hr></table>";
}

# ----------------------------------------------------------------------
sub patches
# ----------------------------------------------------------------------
{
  $patch_dir  = "$oh/patch";
  $patch_file = "$patch_dir/applied.txt";

  &msg("patches() - Listing patches that have been applied (patch_dir=$patch_dir patch_file=$patch_file)");

  if (! -e $patch_dir)
  {
    &msg("Directory $patch_dir Does not exist - creating");
    $rc = system("mkdir $patch_dir");
    if ($rc != 0)
    {
      system("echo '$!' | mailx -s 'DBAmon | $host/$os - patches() Error mkdir $patch_dir' dbaadmin\@dba.it.agilent.com") if $company eq "agilent";
      &error("Error mkdir $patch_dir - $!");
    }
    system("echo '' | mailx -s 'DBAmon | $host/$os - patches() patch_dir=$patch_dir created' dbaadmin\@dba.it.agilent.com") if $company eq "agilent";
    $rc = system("chmod 775 $patch_dir");
  }
  
  if (! -e $patch_file || system("grep 'Version_' $patch_file") != 0)
  {
    &msg("File $patch_file Does not exist - creating");
    system("echo '' | mailx -s 'DBAmon | $host/$os - patches() patch_file=$patch_file created' dbaadmin\@dba.it.agilent.com") if $company eq "agilent";
    $rc = open(PFILE, ">$patch_file");
    if (! defined $rc)
    {
      system("echo '$!' | mailx -s 'DBAmon | $host/$os - patches() Error open $patch_file' dbaadmin\@dba.it.agilent.com") if $company eq "agilent";
      &error("Error open $patch_file - $!");
    }
    print PFILE "
#-------------------------------------------------------------------------------------
#
# DBAmon Patch Tracking
#
# Version_1.02
#-------------------------------------------------------------------------------------
#  You can enter data into this file in order to inform DBAmon
#  that Oracle patches have been applied to this ORACLE_HOME.
#-------------------------------------------------------------------------------------
# Example Entry:
#
# NOTE: It is VERY IMPORTANT that the column alignment for all entries be the
#   same as this example.
#
#Patch Num.  DBMS Version  YYYY/MM/DD Your Name                 Comments 
#----------> <-----------> <--------> <-----------------------> <---------------------------------->
#223344555   9.2.0.2.1     2004/07/21 John Doe                  This is a test comment
#-------------------------------------------------------------------------------------
";
    close(PFILE) || &msg("Error closing PFILE - $!");
    $rc = system("chmod 775 $patch_file");
  }

  #---- Read applied.txt file
  open(PFILE, "$patch_file") || &error("Cannot open input $patch_file - $!");
  while(<PFILE>)
  {
    next if /^$/;
    next if /^#/;
    ##print;

    $pa_num   = substr($_,0,12);
    $pa_ver   = substr($_,13,10);
    $pa_date  = substr($_,27,10);
    $pa_name  = substr($_,38,25);
    $pa_desc  = substr($_,64);

    #---- Data cleanup
    chomp $pa_desc;
  
    $pa_num  =~ s/\'/\"/g;   #---- single quotes are bad for SQL insert statements
    $pa_ver  =~ s/\'/\"/g;
    $pa_date =~ s/\'/\"/g;
    $pa_name =~ s/\'/\"/g;
    $pa_desc =~ s/\'/\"/g;

    $pa_num  =~ s/\n//g;   #---- get rid of newlines
    $pa_ver  =~ s/\n//g;
    $pa_date =~ s/\n//g;
    $pa_name =~ s/\n//g;
    $pa_desc =~ s/\n//g;

    #---- Display clean rows
    if ($pa_num && $pa_ver && $pa_date && $pa_name)
    {
      print "$P PATCH: |$pa_num|$pa_ver|$pa_date|$pa_name|$pa_desc|\n";
    }
  }
  close(PFILE);
  
  &msg("patches() - Done");
}

# ----------------------------------------------------------------------
sub orphanDFs
# ----------------------------------------------------------------------
{
  &msg("orphanDFs() - Listing datafiles to obtain dfmask");

  if (&DBOpenCheck ne "OPEN") { &error("DB must have Dropped-OPEN - terminating"); }

  chop($systemdffirst = `$progdir/dbamon_orastat.pl -df | grep '^SYSTEM' | head -1 | awk '{ print \$3 }'`);
  $dfmask = $systemdffirst; 

  if (!$systemdffirst)
  {
    &msg("Cannot look for orphan datafiles - systemdffirst is null");
    return
  }

  # Save a list of all DB files
  $all_db_files = `$progdir/dbamon_orastat.pl -de`;

  while (length($dfmask) > 0)
  {
    if ($dfmask =~ /\/$/) { last; }
    chop $dfmask;
  }

  $dfmask =~ s/[0-9]/\*/g;
  $dfmask .= "*";
  &msg("Looking for orphan datafiles - dfmask=$dfmask");

  $num_orphans = 0;
  $size_orphans = 0;

  open(FN,"find $dfmask -type f -mtime +14 | grep 'dbf\$' |" || &error("Cannot run find"));
  while(<FN>)
  {
    chop($df_orphan = $_);

    next if $df_orphan !~ /dbf$/;
    next if $df_orphan =~ /\/arch/;

    #---- Version 1.06 don't report TEMP orphan datafiles for standby DB's
    if ($standby && $df_orphan =~ /\/temp/i) 
    {
      next;
    }

    # Make sure that it belongs to this db (sid-subset)
    next if $df_orphan !~ /\/$os\//;

    $z = index($all_db_files,$df_orphan);
    next if $z > -1;  # Skip if found in list

    $df_mtime = (stat "$df_orphan") [9];
    $df_age_days = int((time - $df_mtime) / (60*60*24));
    $df_size  = (stat "$df_orphan") [7];
    $df_size_gb = $df_size / 1000000000;
    $df_size_gb = sprintf("%.2f", $df_size_gb);

    print "$P ORPHANDF: $df_orphan $df_age_days $df_size_gb\n";

    $num_orphans++;
    $size_orphans += $df_size_gb;
  }

  &msg("Found $num_orphans orphaned datafiles - $size_orphans gB");
  return;
}

# ----------------------------------------------------------------------
sub filePermNum
# ----------------------------------------------------------------------
{
  my $fpm_string = $_[0];
  if    (substr($fpm_string,0,3) eq "rwx") { $cfp_perm_num .= "7"; }
  elsif (substr($fpm_string,0,3) eq "rw-") { $cfp_perm_num .= "6"; }
  elsif (substr($fpm_string,0,3) eq "r-x") { $cfp_perm_num .= "5"; }
  elsif (substr($fpm_string,0,3) eq "r--") { $cfp_perm_num .= "4"; }
  elsif (substr($fpm_string,0,3) eq "-wx") { $cfp_perm_num .= "3"; }
  elsif (substr($fpm_string,0,3) eq "-w-") { $cfp_perm_num .= "2"; }
  elsif (substr($fpm_string,0,3) eq "--x") { $cfp_perm_num .= "1"; }
  elsif (substr($fpm_string,0,3) eq "---") { $cfp_perm_num .= "0"; }
  return $fpm_string;
}

# ----------------------------------------------------------------------
sub checkFilePermission 
# ----------------------------------------------------------------------
{
  $cfp_file = $_[0];

  if (! -e $cfp_file)
  {
    &msg("  File $cfp_file does not exist"); 
    return;
  }
  if (-l $cfp_file)
  {
    &msg("  File $cfp_file is a link - skipping"); 
    return;
  }

  chop($cfp_permission = `ls -l $cfp_file | cut -b 2-11`) if -e $cfp_file;
  return if ! $cfp_permission;
  #---- translate to numeric
  $cfp_perm_num = ""; 
  &filePermNum(substr($cfp_permission,0,3));
  &filePermNum(substr($cfp_permission,3,3));
  &filePermNum(substr($cfp_permission,6,3));

  &msg("  File permission of $cfp_file is $cfp_perm_num ($cfp_permission)"); 

  if (substr($cfp_permission,7,1) eq "w")
  {
    print "$P ORAFILEPERM: Event: $cfp_file is world-writable ($cfp_perm_num)\n" if ! $sec_fix; 
  }

  return $cfp_perm_num;
}

# ----------------------------------------------------------------------
sub securityMain 
# ----------------------------------------------------------------------
{
  #if ($host eq "zzdocevil")
  if (1 == 1)
  {
    $sec_fix = 1; 
    &msg("Running securityChecks() with sec_fix=$sec_fix");
    &securityChecks;
  }

  $sec_fix = 0; 
  &msg("Running securityChecks() with sec_fix=$sec_fix");
  &securityChecks;
}

# ----------------------------------------------------------------------
sub securityChecks 
# ----------------------------------------------------------------------
{
  &msg("Checking permission of tnsnames/listener files");

  $sec_fp = &checkFilePermission("/etc/listener.ora"); 
  if ($sec_fp && 
      $sec_fp ne "700" && 
      $sec_fp ne "600" && 
      $sec_fp ne "640")
  {
    if ($sec_fix)
    {
      chmod(0600, "/etc/listener.ora");
    }
    else
    {
      print "$P ORAFILEPERM: Event: $cfp_file has file permission of $sec_fp/$cfp_permission - Should be 700/600/640\n"; 
    }
  }

  $sec_fp = &checkFilePermission("$oh/network/admin/listener.ora"); 
  if ($sec_fp && 
      $sec_fp ne "700" && 
      $sec_fp ne "600" && 
      $sec_fp ne "640")
  {
    if ($sec_fix)
    {
      chmod(0600, "$oh/network/admin/listener.ora");
    }
    else
    {
      print "$P ORAFILEPERM: Event: $cfp_file has file permission of $sec_fp/$cfp_permission - Should be 700/600/640\n"; 
    }
  }

  if (! $sec_fix) 
  {
    # GROUP 
    $my_gid   = (split(' ',$()) [0];
    $my_group = (getgrgid($my_gid)) [0];
    $my_userid = $userid;
    &msg("Checking group=dba - my_gid=$my_gid my_group=$my_group my_userid=$my_userid");
    chop($dbagroupok = `grep '^DBAGROUPOK' $cfg | tail -1 | awk '{ print \$2 }'`);
    $dbagroupok = "," . $dbagroupok . ","; 

    #---- Look for members specified in /etc/group
    &msg("Looking for $my_group members specifed in /etc/group other than ora* and dba"); 
    $dba_members = (getgrgid($my_gid)) [3];
    $dba_members =~ s/,/ /g;
    ##&msg("DEBUG dba_members=$dba_members");
    foreach (split(/ /,$dba_members))
    {
      next if $_ =~ /^ora/;
      next if $_ eq "dba";
      next if $_ eq $my_userid;
      next if $_ eq lc "${os}adm";
      next if index($dbagroupok,",${_},") > -1;
      print "$P DBAGROUP_GROUP: $_\n";
    }

    #---- Look for members specified in /etc/passwd
    &msg("Looking for gid=$my_gid members specifed in /etc/passwd other than ora* and dba"); 
    while (($name, $crud, $crud, $gid) = getpwent)
    {
      next if $gid != $my_gid;
      next if $name =~ /^ora/;
      next if $name eq "dba";
      next if $name eq lc "${os}adm";
      next if index($dbagroupok,",${name},") > -1;
      print "$P DBAGROUP_PASSWD: $name\n";
    }
  }
}

# ----------------------------------------------------------------------
sub checkDST 
# ----------------------------------------------------------------------
{
  &msg("checkDST - DST2007 Logic"); 

  if ($sap_db)
  {
    &msg("This is an SAP DB. DST Checking not required"); 
    return;
  }

  $dst_required_col = 0;
  $dst_required_jvm = 0;

  $dst_colstring = ""; 

  &msg("  Running orastat -dst"); 
  chop($dst = `$progdir/dbamon_orastat.pl -dst`); 
  print "=======================================================================\n"; 
  print "$dst\n"; 
  print "=======================================================================\n"; 

  if ($dst =~ /DST Patch Missing and Required \(DSTCOL\)/)
  {
    $dst_required_col = 1;
  }
  if ($dst =~ /DST Patch Missing and Required \(JVM\)/)
  {
    $dst_required_jvm = 1;
  }

  if ($dst =~ /This DB does have DST columns \(SYS schemas\)/)
  {
    $dst_colstring .= "(SYS)"; 
  }
  if ($dst =~ /This DB does have DST columns \(non-SYS schemas\)/)
  {
    $dst_colstring .= "(Non-SYS)"; 
  }

  print "$P DST2007_COL_REQUIRED:     $dst_required_col $dst_colstring\n"; 
  print "$P DST2007_JVM_REQUIRED:     $dst_required_jvm\n"; 

  &msg("checkDST - Done"); 
}

# ----------------------------------------------------------------------
sub oddJob2 
# ----------------------------------------------------------------------
{
  &msg("OddJob2 - DST2007 Logic"); 

  $oddjob2_JVM = 0; 
  $oddjob2_col_sys = 0; 
  $oddjob2_col_nonsys = 0; 

  #---- See if there are any tablespaces with NO datafiles
  $sql = "
    select 
      'XA', owner, status, count(*) from all_objects
    where 
      object_type like '%JAVA%' and
      owner = 'SYS' 
    group by 
      owner, status
    having 
      count(*) > 9000;
    select 
      'XB', c.owner, count(*)
    from 
      dba_tab_cols c, dba_objects o
    where 
      c.data_type like '%WITH TIME ZONE'
                  and c.owner=o.owner
                  and c.table_name = o.object_name
                  and o.object_type = 'TABLE' 
    group by
      'XB', c.owner
    order by 
      owner; 
  ";
  &oraSQL($sql);
  $tslist = ""; 
  foreach (@oraSQLout)
  {
    ##print;
    @words       = split();
    $verb        = $words[0];
    if ($verb eq "XA")
    {
      $oddjob2_JVM = 1; 
      &msg("  Schema SYS owns $words[3] JAVA objects - JVM is installed");
    }
    if ($verb eq "XB")
    {
      &msg("  Schema $words[1] owns $words[2] Tables with TIME ZONE columns");
      if ($words[1] eq 'SYS') 
      {
        $oddjob2_col_sys = 1; 
      }
      else
      {
        $oddjob2_col_nonsys = 1; 
      }
    }
  }

  print "$P DST2007_JVM:           $oddjob2_JVM\n"; 
  print "$P DST2007_TZ_COL_SYS:    $oddjob2_col_sys\n"; 
  print "$P DST2007_TZ_COL_NONSYS: $oddjob2_col_nonsys\n"; 
}

# ----------------------------------------------------------------------
sub oddJob1 
# ----------------------------------------------------------------------
{
  $thiskey = $_[0];
  $sshdir  = "$ENV{'HOME'}/.ssh";
  $keyfile = "$sshdir/authorized_keys";
  &msg("oddJob1() Starting - thiskey=$thiskey sshdir=$sshdir keyfile=$keyfile");

  #---- Set correct permissions
  system("chmod 755 $sshdir 2>&1"); 
  system("chmod 644 $keyfile 2>&1"); 
 
  #---- See if sshdir exists - if not, create it 
  &msg("  Seeing if $sshdir exists");
  if (! -e "$sshdir")
  {
    &msg("  $sshdir Does not exist - Creating");
    $rc = system("mkdir $sshdir 2>&1"); 
    if ($rc != 0)
    {
      system("echo ' ' | mailx -s 'DBAmon | $host/$os - mkdir $sshdir no workie - $!' dbaadmin\@dba.it.agilent.com");
    }
    system("echo ' ' | mailx -s 'DBAmon | $host/$os - Created $sshdir' dbaadmin\@dba.it.agilent.com");
  }

  #---- See if authkeys file contains this entry - if not, add it 
  &msg("  Looking in $keyfile for $thiskey DSA entry");

  if (system("grep 'ssh-dss' $keyfile | grep '$thiskey' >/dev/null") != 0)
  {
    &msg("  $keyfile Does not contain a DSA entry for $thiskey - Adding entry");
    undef $!; 
    $rc = system("grep '$thiskey' $progdir/dbamon_ora.dsa1 >> $keyfile"); 
    if ($rc != 0 || $!)
    {
      &msg("  Adding entry failed - $! - rc=$rc");
      system("echo '$!' | mailx -s 'DBAmon | $host/$os - Add $thiskey no workie - $!' dbaadmin\@dba.it.agilent.com");
    }
    system("echo ' ' | mailx -s 'DBAmon | $host/$os - Added DSA $thiskey to $keyfile' dbaadmin\@dba.it.agilent.com");
  }
  
  &msg("oddJob1() Done");
}

# ----------------------------------------------------------------------
sub serverInfoHPUX 
# ----------------------------------------------------------------------
{
  &msg("serverInfoHPUX - Collecting server info (5 second delay)");

  chop($servermodel = `model`); 
  $servermodel =~ s/ //g; 
  &msg("DEBUG servermodel=($servermodel)"); 

  chop($serveruptime = `uptime`); 
  &msg("DEBUG serveruptime=($serveruptime)"); 

  &msg("serverInfoHPUX - Running cpuinfo") if !$WWW; 
  #system("$progdir/dbamon_cpuinfo 2>&1");
  open(CPUINFO, "$progdir/dbamon_cpuinfo 2>&1|") || &error("Cannot open input $tmp1 - $!");
  while(<CPUINFO>)
  {
    if (/^Phy/)
    {
      $phy_ram_mb = (split) [1];
    }
    if (/^Num/)
    {
      $num_cpus   = (split) [1];
    }
  }
  close(CPUINFO);
  if ($phy_ram_mb)
  {
    $mem_gb = sprintf("%.2f", $phy_ram_mb / (1024));

    print "$P Physical_RAM_MB: $phy_ram_mb\n" if !$WWW;  
    print "$P Num_Processors:  $num_cpus\n"   if !$WWW;  
    print "$P Memory_Size_GB:  $mem_gb\n"   if !$WWW;  
  }

  #---- Run "top" to collect memory usage info 
  &msg("serverInfoHPUX - Running top to gather memory usage info") if !$WWW; 
  $rc = system("top -d 1 -f $tmp1 2>&1"); 
  if ($rc != 0)
  {
    &msg("top Failed - rc=$rc - $!");
    system("cat $tmp1 | mailx -s '$P | $P rc=$rc $host/$os - [AUTO]' dbaadmin\@dba.it.agilent.com");
  }

  #---- See if cron is running
  &msg("Seeing if cron daemon is running"); 
  system("ps -ef | grep 'cron' | grep 'root' | grep -v 'grep'"); 
  chop($numcron = `ps -ef | grep 'cron' | grep 'root' | grep -v 'grep' | wc -l`); 
  print "$P Num_Cron: $numcron\n";

  #---- Check free memory
  open(TOP, "$tmp1") || &error("Cannot open input $tmp1 - $!");
  while(<TOP>)
  {
    if (/^Memory/)
    {
      $memfree = (split) [7];
    }
  }
  close(TOP); 
  system("rm -fr $tmp1 2>&1");

  if ($memfree > 0)
  {
    $memfree = sprintf("%.2f", $memfree / (1024*1024));
    $mempct = sprintf("%.2f", (($mem_gb - $memfree) / $mem_gb) * 100);
    print "$P Memory_Free_GB:  $memfree\n" if !$WWW; 
    print "$P Memory_Pct_Full: $mempct\n" if !$WWW; 
  }

  &msg("serverInfoHPUX - Done - mem_gb=$mem_gb memfree=$memfree mempct=$mempct") if !$WWW; 
}

# ----------------------------------------------------------------------
sub serverInfoLinux 
# ----------------------------------------------------------------------
{
  &msg("serverInfoLinux - Collecting server info");

  ##&msg("TEST-");
  ##system("x86info"); 

  chop($servermodel1 = `uname -a | awk '{ print \$12 }'`); 
  chop($servermodel2 = `x86info 2>/dev/null | grep '^Processor' | head -1 | awk '{ print \$NF }'`); 
  $servermodel = "$servermodel1-$servermodel2"; 

  chop($serveruptime = `uptime`); 

  chop($num_cpus = `x86info 2>/dev/null | grep '^Found' | tail -1 | awk '{ print \$2 }'`); 
  if (! $num_cpus)
  {
    chop($num_cpus = `ll /dev/cpu | grep root | wc -l`); 
  }

  open(MEMINFO, "/usr/bin/free -m 2>&1|") || &error("Cannot run free - $!");
  while(<MEMINFO>)
  {
    if (/^Mem/)
    {
      $phy_ram_mb = (split) [1];
      ###don't do this--- it is always very low###$memfree    = (split) [3];
    }
  }
  close(MEMINFO);

  if ($servermodel)
  {
    print "$P Server_Model:    $servermodel\n" if !$WWW;  
    print "$P Physical_RAM_MB: $phy_ram_mb\n"  if !$WWW;  
    print "$P Num_Processors:  $num_cpus\n"    if !$WWW;  

    $mem_gb = sprintf("%.2f", $phy_ram_mb / (1024));
    print "$P Memory_Size_GB:  $mem_gb\n"   if !$WWW;  
  }

  if ($memfree > 0)
  {
    $memfree = sprintf("%.2f", $memfree / (1024*1024));
    $mempct = sprintf("%.2f", (($mem_gb - $memfree) / $mem_gb) * 100);
    print "$P Memory_Free_GB:  $memfree\n" if !$WWW; 
    print "$P Memory_Pct_Full: $mempct\n" if !$WWW; 
  }

  &msg("serverInfoLinux - Done - mem_gb=$mem_gb memfree=$memfree mempct=$mempct") if !$WWW; 
}

# ----------------------------------------------------------------------
sub DCFRead 
# ----------------------------------------------------------------------
{
  #---- DCF (DBAmon control file) path
  $dcf_path = "$ENV{'HOME'}/.dbamon_ora_cf_${os}_${rq_dbamonmode}.txt";
  &msg("DCFRead - Reading dcf_path=$dcf_path"); 

  if (-e "$dcf_path") 
  {
    #---- Only require the file if it passes a perl syntax check
    if (system("perl -wc $dcf_path > $tmp2 2>&1") != 0)
    {
      &msg("Require file $dcf_path Perl compile error - Not requiring"); 
      # system("cat $tmp2"); 
      # system("cat $tmp2 | mailx -s 'DBAmon | $host/$os $dcf_path Compile Error' dbaadmin\@dba.it.agilent.com") if $company eq "agilent";
    }
    elsif (-z $dcf_path)
    {
      &msg("Require file $dcf_path Is zero bytes - Not requiring"); 
    }
    else
    {
      require "$dcf_path"; 
    }
  }
  else
  {
    &msg("Controlfile file $dcf_path missing - DCFFILEMISSING"); 
    # system("echo ' ' | mailx -s 'DBAmon | $host/$os - DCF $dcf_path Missing' dbaadmin\@dba.it.agilent.com") if $company eq "agilent";
  }

  #---- TEMP DEBUG: show variable values
  foreach $dcf_key (sort keys %dcf_hash)
  {
    ##&msg("DEBUG - dcf_hash{$dcf_key}=$dcf_hash{$dcf_key}"); 
  }

  if ($dcf_hash{"LastCycleFinishNum"} > 0)
  {
    $zmins_since = sprintf("%.2f", (time - $dcf_hash{"LastCycleFinishNum"}) / 60);
    &msg("DCFRead - Minutes since last iteration: $zmins_since"); 
  }
}

# ----------------------------------------------------------------------
sub DCFWrite 
# ----------------------------------------------------------------------
{
  &msg("DCFWrite - Writing dcf_path=$dcf_path"); 

  #---- Cycle finish variable
  $z = time; 
  $dcf_hash{"LastCycleFinishNum"}  = $z; 
  $dcf_hash{"LastCycleFinishChar"} = &timeToText($z); 

  #---- Write out values
  foreach $dcf_key (sort keys %dcf_hash)
  {
    $dcf_out .= "\$dcf_hash{$dcf_key} = '$dcf_hash{$dcf_key}';\n";
    $dcf_count++; 
  }
  ##&msg("DEBUG - dcf_count=$dcf_count dcf_out=$dcf_out"); 

  open(DCF, ">$dcf_path") || &msg("Cannot open output $dcf_path - $!");
  print DCF $dcf_out; 
  close(DCF);

  ##system("cat $dcf_path");

  &msg("DCFWrite - Wrote $dcf_count controlfile entries"); 
}

# ----------------------------------------------------------------------
sub serverInfoSolaris 
# ----------------------------------------------------------------------
{
  &msg("serverInfoSolaris - Collecting server info (5 second delay)");

  #---- Server model
  chop($servermodel = `uname -a | awk '{ print \$NF}'`); 
  $servermodel =~ s/SUNW,//;
  $servermodel =~ s/Sun-Fire-//;

  #---- CPU count
  chop($num_cpus = `mpstat -a | tail -1 | awk '{ print \$NF}'`); 

  #---- RAM 
  chop($phy_ram_mb = `prtconf | grep 'Memory' | awk '{ print \$3}'`); 

  if ($servermodel)
  {
    print "$P Server_Model:    $servermodel\n" if !$WWW;  
    print "$P Physical_RAM_MB: $phy_ram_mb\n"  if !$WWW;  
    print "$P Num_Processors:  $num_cpus\n"    if !$WWW;  

    $mem_gb = sprintf("%.2f", $phy_ram_mb / (1024));
    print "$P Memory_Size_GB:  $mem_gb\n"   if !$WWW;  
  }

  #---- Run "top" to collect memory usage info 
  $toppath = "/opt/sfw/bin/top"; 
  if (-e $toppath)
  {
    &msg("serverInfoHPUX - Running top to gather memory usage info") if !$WWW; 
    $rc = system("$toppath -d 1 > $tmp1 2>&1"); 
    if ($rc != 0)
    {
      &msg("top Failed - rc=$rc - $!");
      system("cat $tmp1 | mailx -s '$P | $P rc=$rc $host/$os - [AUTO]' dbaadmin\@dba.it.agilent.com");
    }

    open(TOP, "$tmp1") || &error("Cannot open input $tmp1 - $!");
    while(<TOP>)
    {
      if (/^Memory/)
      {
	$memfree = (split) [3];
        chop $memfree;
      }
    }
    close(TOP); 
    system("rm -fr $tmp1 2>&1");
  }


  if ($memfree > 0)
  {
    $memfree = sprintf("%.2f", $memfree / (1024));  #---- Divide to convert MB to GB
    $mempct = sprintf("%.2f", (($mem_gb - $memfree) / $mem_gb) * 100);
    print "$P Memory_Free_GB:  $memfree\n" if !$WWW; 
    print "$P Memory_Pct_Full: $mempct\n" if !$WWW; 
  }

  &msg("serverInfoSolaris - Done - mem_gb=$mem_gb memfree=$memfree mempct=$mempct") if !$WWW; 
}

# ----------------------------------------------------------------------
sub instanceDetails 
# ----------------------------------------------------------------------
{
  my $thissub_raw = ( caller( 0 ) )[ 3 ]; 
  my $thissub     = (split(/\:/,$thissub_raw)) [2];
  $instance_details = ""; 
  &msg("$thissub - Collecting instance details"); 

  #---- Collect client data
  &msg("$thissub - Running orastat -cc to collect client details"); 
  foreach (`$progdir/dbamon_orastat.pl -cc`)
  {
    if (/^Network:/)
    {
      my $network_id  = (split())[1];
      my $network_cnt = (split())[2];
      $instance_details .= "${thissub}: Network $network_id $network_cnt\n"; 
    }
    if (/^Client:/)
    {
      my $client_id  = (split())[1];
      my $client_cnt = (split())[3];
      $instance_details .= "${thissub}: Client $client_id $client_cnt\n"; 
    }
  }

  #---- Collect kernel parms 
  if ($thisos eq "HP-UX")
  {
    &msg("$thissub - Running kmtune to collect kernel parms"); 
    foreach (`kmtune 2>/dev/null`)
    {
      next if /^Parameter/; 
      next if /^===/; 

      my $parm  = (split())[0];
      my $value = (split())[1];
      $instance_details .= "${thissub}: Kernel $parm $value\n"; 
    }
  }
  if ($thisos eq "Linux")
  {
    &msg("$thissub - Running sysctl to collect kernel parms"); 
    foreach (`/sbin/sysctl -a 2>&1`)
    {
      next if ! /^kernel/; 

      my $parm  = (split())[0];
      my $value = (split())[2];
      $instance_details .= "${thissub}: Kernel $parm $value\n"; 
    }
  }

  #---- Print all data
  print "$instance_details"; 
  &msg("$thissub - Done"); 
}

# ----------------------------------------------------------------------
sub auditSession 
# ----------------------------------------------------------------------
{
  my $thissub_raw = ( caller( 0 ) )[ 3 ]; 
  my $thissub     = (split(/\:/,$thissub_raw)) [2];

  #---- See if audit_session is turned on
  &msg("$thissub - Seeing if 'audit session' is on"); 
  $sql = 'select \'X\', count(*) from dba_priv_audit_opts where user_name is null and privilege = \'CREATE SESSION\';';
  &oraSQL($sql);
  foreach (@oraSQLout)
  {
    ##print;
    print if /^ORA/;
    @words = split;
    $verb    = $words[0];
    if ($verb eq "X")
    {
      $rowcnt = $words[1];
    }
  }
  &msg("$thissub - Resulting rowcnt=$rowcnt"); 
  return if $rowcnt < 1; 

  #---- Read audit date
  $sql = "select 
    \'X\',
    nvl(username,\'?\'), 
    nvl(os_username,\'?\'), 
    nvl(userhost,\'?\'),
    max(to_char(timestamp,\'YYYY/MM/DD-HH24:MM:SS\')),
    count(*) 
  from 
    dba_audit_session 
  --where
  --  timestamp >= to_date(\'$aud_timestamp\', \'YYYY-MM-DD:HH24:MI:SS\')
  group by 
    username,
    os_username, 
    userhost;";

  ##&msg("DEBUG sql=$sql"); 
  &oraSQL($sql);

  $aud_timestamp = ""; 
  $S = "Stack: oraAuditSes ";

  foreach (@oraSQLout)
  {
    ##print;
    print if /^ORA/;
    @words = split;
    $verb    = shift @words;
    if ($verb eq "X")
    {
      $dbuser = shift @words;
      $osuser = shift @words;
      $host   = shift @words;
      $mrts   = shift @words;
      $count  = shift @words;

      #---- Weed out system access 
      next if $osuser eq $userid && $dbuser =~ /^SYS/;
      next if $osuser eq $userid && $dbuser eq "DBAMON";
      next if $osuser eq $userid && $dbuser eq "OUTLN";
      next if $osuser eq $userid && $dbuser eq "DBSNMP"; 

      $id = "$dbuser/$osuser/$host"; 

      printf("$S$P %-35s %-20s %8s\n",$id,$mrts,$count); 

      $aud_timestamp = $mrts if $mrts gt $aud_timestamp;      
    }
  }
  &msg("$thissub - Resulting Max aud_timestamp=$aud_timestamp"); 

  #---- Delete this data 
  $sql = "delete  
  from 
    dba_audit_session 
  where
    timestamp >= to_date(\'$aud_timestamp\', \'YYYY-MM-DD:HH24:MI:SS\');";
  &msg("Deleting these audit rows - sql=$sql"); 
  ##&oraSQL($sql);
  ##foreach (@oraSQLout)
  ##{
  ##  print;
  ##}

  #---- Return
  &msg("$thissub - Done"); 
}

# ----------------------------------------------------------------------
sub reportRunOrastat 
# ----------------------------------------------------------------------
{
  my $this_title = $_[0];
  my $this_verb  = $_[1];

  ##&msg("this_verb=$this_verb this_title=$this_title"); 

  print "RPT: $fs <h4>$this_title (orastat -$this_verb)</h4>\n"; 
  print "RPT: <table border=1>\n"; 
  $hdrflag = 0; 
  foreach (`$progdir/dbamon_orastat.pl -$this_verb 2>&1`) 
  {
    $line = "<tr>"; 
    chop; 
    next if /orastat/; 
    next if /^------/; 
    next if /^$/; 

    @words = split(' ',$_);

    foreach $word (@words)
    {
      if ($hdrflag == 0)
      {
        $line .= "<th bgcolor=steelblue nowrap>$fs $word"; 
      }
      else
      {
        $line .= "<td bgcolor=lightblue nowrap>$fs $word"; 
      }
    }

    print "RPT: $line\n"; 
    $hdrflag = 1; 
  }
  print "RPT: </table>\n"; 
}

# ----------------------------------------------------------------------
sub reportUS 
# ----------------------------------------------------------------------
{
  &msg("reportUS() - Creating user report"); 

  print "RPT: $fs <h3>DB User Report For Instance $host/$os</h3>\n"; 

  #---- See if complex pw logic is on
  $dash = `$progdir/dbamon_orastat.pl -`;
  if ($dash =~ /ComplexDBPW:  ON/)
  {
    $zwhat = "ON"; 
  }
  else
  {
    $zwhat = "OFF"; 
  }

  print "RPT: $fs <h5>(Complex Password Functionality for this instance is $zwhat)</h5>\n"; 

  &reportRunOrastat("Report of All DB Userids","us"); 
  &reportRunOrastat("Report of All DB Profiles","pr"); 
  
  &msg("reportUS() - Done"); 
}

# ----------------------------------------------------------------------
sub corruption
# ----------------------------------------------------------------------
{
  &msg("corruption() - Checking for DB block corruption");

  if ($oraver_num < 9) 
  { 
    &msg("Skipping corruption check since Oracle version ($oraver_num) < 9"); 
    return;
  }

  $corruption_count = 0; 

  &oraSQL("select  \'Z\', FILE#, BLOCK#, BLOCKS, CORRUPTION_CHANGE#, CORRUPTION_TYPE from v\\\$database_block_corruption order by 2,3;");
  foreach (@oraSQLout)
  {
    ##print;
    @words = split;
    if ($words[0] eq "Z")
    {
      $file   = $words[1];
      $block  = $words[2];
      $blocks = $words[3];
      $change = $words[4];
      $type   = $words[5];
      $corruption_count++; 
      print "$P CORRUPTION_DETAILS: File=$file Block=$block BlockCount=$blocks SCN=$change Type=$type\n"; 
    }
  }

  if ($corruption_count > 0) 
  {
    print "$P CORRUPTION: $corruption_count\n"; 
  }
}

# ----------------------------------------------------------------------
sub ASMSpace
# ----------------------------------------------------------------------
{
  $t_warn = $arg1;
  $t_crit = $arg2;
  &msg("ASMSpace - Checking ASM diskgroups - t_warn=$t_warn t_crit=$t_crit"); 

  foreach (`$progdir/dbamon_orastat.pl -asm_dg`)
  {
    next unless /^DG:/;

    $diskgroup = (split())[1];
    $dg_size   = (split())[8];
    $dg_free   = (split())[9];
    $dg_used   = (split())[10];
    $dg_pct    = (split())[11];

    $dg_pct =~ s/\%//;

    if    ($dg_pct >= $t_crit) { $dg_flag = "C"; }
    elsif ($dg_pct >= $t_warn) { $dg_flag = "W"; }
    else                       { $dg_flag = "OK"; }

    print "DG: $diskgroup $dg_size $dg_free $dg_used $dg_pct $dg_flag\n"; 
  }

  &msg("ASMSpace - Done"); 
}

# ----------------------------------------------------------------------
sub EMStatus
# ----------------------------------------------------------------------
{
  $em_out = `emctl status dbconsole 2>&1`;  
  &msg("  Running: emctl status dbconsole");
  &msg("  EM Status:");
  print $em_out;

  if    ($em_out =~ /is not running/)           { $em_status = "D"; }
  elsif ($em_out =~ /is running/)               { $em_status = "U"; }
  elsif ($em_out =~ /OC4J Configuration issue/) { $em_status = "N"; }
  else                                          { $em_status = "?"; }

  #---- Debug
  if ($em_status eq "?")
  {
    open(DIAG, ">$tmp2");  
    print DIAG $em_out;
    close(DIAG); 
    system("cat $tmp2 | mailx -s 'DBAmon | $host/$os em_status=$em_status' $phonehome") if $company eq "agilent";
  }

  return $em_status;
}

# ----------------------------------------------------------------------
sub EMCheck
# ----------------------------------------------------------------------
{
  if ($oraver_num < 10) 
  { 
    &msg("EMCheck() - Skipping EM check since Oracle version ($oraver_num) < 10"); 
    return;
  }
  &msg("EMCheck - Checking EM"); 

  &EMStatus(); 

  if ($em_status eq "U")
  {
    &msg("  EM appears to be running"); 
  }
  elsif ($em_status eq "N")
  {
    &msg("  EM was never configured for this instance"); 
  }
  elsif ($em_status eq "D")
  {
    #---- Start EM 
    &msg("  Starting EM - Running emctl start dbconsole"); 
    $em_start = `emctl start dbconsole 2&>1`; 
    &msg("  Rechecking EM"); 
    if (&EMStatus() eq "D")
    {
      open(DIAG, ">$tmp2");  
      print DIAG $em_start;
      close(DIAG); 
      system("cat $tmp2 | mailx -s 'DBAmon | $host/$os EM Start failed em_status=$em_status' $phonehome") if $company eq "agilent";
    }
    $em_started = "Y"; 
  }

  print "$P EM_STATUS: $em_status $em_started\n"; 
  &msg("EMCheck - Done - em_status=$em_status"); 
}

# ----------------------------------------------------------------------
sub ISQStatus
# ----------------------------------------------------------------------
{
  $pscmd = "ps -ef"; 
  $pscmd = "ps -efx" if $thisos eq "HP-UX"; 

  chop($isql_pcnt = `$pscmd | grep -i 'isqlplus' | grep -v 'grep' | wc -l`); 
  $isql_pcnt = $isql_pcnt + 0;
  $isql_check_output = `isqlplusctl start`;

  if    ($isql_check_output =~ /is already running/)  { $isq_status = "U"; &msg("  (already running)");  }
  elsif ($isql_pcnt == 0)                             { $isq_status = "D"; }
  elsif ($isql_pcnt == 1)                             { $isq_status = "U"; }
  else                                                { $isq_status = "?"; }

  #---- Debug
  if ($isq_status eq "?")
  {
    system("$pscmd | mailx -s 'DBAmon | $host/$os isq_status=$isq_status' $phonehome") if $company eq "agilent";
  }

  &msg("  isq_status=$isq_status isql_pcnt=$isql_pcnt"); 
  return $isq_status;
}

# ----------------------------------------------------------------------
sub ISQCheck
# ----------------------------------------------------------------------
{
  if ($oraver_num < 10.2) 
  { 
    &msg("ISQCheck() - Skipping iSQLPlus check since Oracle version ($oraver_num) < 10.2"); 
    return;
  }
  if (! -e "$oh/bin/isqlplusctl") 
  { 
    &msg("ISQCheck() - Skipping iSQLPlus check $oh/bin/isqlplusctl does not exist"); 
    return;
  }

  &msg("ISQCheck - Checking iSQLPlus"); 

  &ISQStatus(); 

  if ($isq_status eq "U")
  {
    &msg("  iSQLPlus appears to be running"); 
  }
  #elsif ($isq_status eq "N")
  #{
  #  &msg("  iSQLPlus was never configured for this instance"); 
  #}
  elsif ($isq_status eq "D")
  {
    #---- Start 
    &msg("  Starting iSQLPlus - Running isqlplusctl start"); 
    $isq_start = `isqlplusctl start 2&>1`; 
    print $isq_start;

    &msg("  Rechecking iSQLPlus"); 
    if (&ISQStatus() eq "D")
    {
      open(DIAG, ">$tmp2");  
      print DIAG $isq_start;
      close(DIAG); 
      system("cat $tmp2 | mailx -s 'DBAmon | $host/$os iSQLPlus Start failed isq_status=$isq_status' $phonehome") if $company eq "agilent";
    }
    $isq_started = "Y"; 
  }

  print "$P ISQ_STATUS: $isq_status $isq_started\n"; 
  &msg("ISQCheck - Done - isq_status=$isq_status"); 
}

# ----------------------------------------------------------------------
#
# Main
#
# ----------------------------------------------------------------------

#---- Capture start time for probe duration
$stime = time;

#---- Read prior run controlfile 
&DCFRead;

#---- Check to see if Oracle is up
if ($verb eq "up") 
{
  $runmon = $arg4;   # is this instance backup-only monitoring?

  $subrc  = &up();

  if ($os =~ /^\+ASM/)
  {
    $subrc += &alertlog();
    goto TERMINATE; 
  }

  $subrc += &securityMain();    
  $subrc += &patches();    
  $subrc += &orphanDFs();
  $subrc += &rmanHung();
  $subrc += &filecheck();
  $subrc += &lsnr() unless $rq_listener_check eq "N";
  $subrc += &lan();
  $subrc += &datafiles();
  $subrc += &instanceDetails;
  $subrc += &auditSession if $host eq "bigdog";

  if ($host eq "atrdev1")
  {
    $subrc += &alertLogByTS();
  }
  else
  {
    $subrc += &alertlog();
  }
  ##$subrc += &alertlog();

  $subrc += &aliasInfo();
  $subrc += &corruption;
  $subrc += &perf();
  $subrc += &fs() if $arg3 ne "" && $arg3 ne ".";
  $subrc += &userPassword() if $runmon ne "B" && ! $standby_flag;

  ##if ($company eq "agilent" && $host eq "acomr20")
  if ($company eq "agilent")
  {
    &oddJob1("dbamon\@bigdog");
    &oddJob1("dbamon\@lvmon01");
  }
  #---- Old way
  #&oddJob2; 
  #---- New way
  &checkDST if ! $standby_flag; 
  &EMCheck;   #---- Check for EM running
  &ISQCheck;  #---- Check for iSQLPlus running
}

#
# Check to see if the listener is up - start it if not
#
if ($verb eq "lsnr") 
{
  $subrc = &lsnr();
}

#
# Check for full tablespaces
#
if ($verb eq "ts_full") 
{
  &msg("DEBUG - Before ts_full - parallel=$parallel instnum=$instnum"); 
  if ($os =~ /^\+ASM/)
  {
    &msg("Since this is an ASM instnace, invoking ASMSpace");
    &ASMSpace;
  }
  elsif ($parallel eq "YES" && $instnum > 1)
  {
    &msg("Since this RAC/OPS instance number is > $instnum, not performing TS checks (they occur only on instance=1");
  }
  else
  {
    $subrc += &fsGeneric();
    $subrc = &ts_full();
    if ($ts_recheck) 
    { 
      $ts_where = "and a.tablespace_name in ( ";
      foreach (@recheck_list) 
      {
	$ts_where .= "'$_',"; 
      }
      chop($ts_where);
      $ts_where .= ")";
      print "$P | Re-invoking ts_full() with where clause=$ts_where \n";
      $subrc = &ts_full();
    }
  }
}

#
# Check the alertlog
#
if ($verb eq "alertlog") 
{
  $subrc = &alertlog();
}

#
# Check object extents
#
if ($verb eq "extents") 
{
  $subrc = &extents();
}

#
# Check for offline datafiles
#
if ($verb eq "datafiles") 
{
  $subrc = &datafiles();
}

#
# Check object extents
#
if ($verb eq "arclogs") 
{
  $subrc = &arclogs();
}

#
# Run a backup
#
if ($verb eq "bkrun") 
{
  $subrc = &bkrun();
}

#
# Standby inSync - routine #1
#
if ($verb eq "inSyncSby") 
{
  $subrc = &inSyncSby();
}

#
# Standby inSync - routine #2
#
if ($verb eq "inSyncPri") 
{
  $subrc = &inSyncPri();
}

# TEST
if ($verb eq "tstest")    { $subrc = &ts_full(); }
if ($verb eq "listtest")  { $subrc = &checkListenerLog(); }
if ($verb eq "security")  { $subrc = &securityMain(); }
if ($verb eq "perftest")  { $subrc = &perf(); }
if ($verb eq "odd1test")  { $subrc = &oddJob1("dbamon\@bigdog"); }
if ($verb eq "bkagetest") { $subrc = &bkage(); }
if ($verb eq "dftest")    { &orphanDFs(); }
if ($verb eq "redotest")  { &perfRedo(); }
if ($verb eq "patches")   { &patches(); }

#
# Magnifying glass routines
#
if ($verb eq "bkbl") { $subrc = &bkbl(); }
if ($verb eq "bkps") { $subrc = &bkps(); }
if ($verb eq "bkhi") { $subrc = &bkhi(); }
if ($verb eq "bkrb") { $subrc = &bkrb(); }

#---- Reports
if ($verb eq "report_us") { $subrc = &reportUS(); }

#
# Terminate
#
TERMINATE: $etime = time;
$elapsed = $etime - $stime;
&msg("Done - elapsed: $elapsed - subrc: $subrc");

&msg("Removing tmp files");
system("rm $tmp1 $tmp2 2>&1");

#---- Write out controlfile for next run
&DCFWrite;

&msg("END_OF_PROBE");
exit 0;
